
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000012=
{ /*reference*/     "lcrzoex", 12,
  /*version*/       1, 0,
  /*title*/         "sniff packets (TCP reor.) and save them in an Eth record",
  /*french title*/  "sniffe des paquets (reor. TCP) et les sauve dans un record Eth",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file [device [\"bpf_filter\"]]",
  /*french usage*/  "fichier [device [\"filtre_bpf\"]]",
  /*usage example*/ "/tmp/file eth0 \"host 1.2.3.4 and port 25\"",
  /*fr. usage ex.*/ "/tmp/fichier eth0 \"host 1.2.3.4 and port 25\"", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000012_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000012_main(int argc, char *argv[])
{
  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000012, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_sniff_dumpsaveeth(argc, argv, LCRZO_SNIFF_TYPE_TCPREOR));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
