
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000028=
{ /*reference*/     "lcrzoex", 28,
  /*version*/       1, 0,
  /*title*/         "IP record : spoof",
  /*french title*/  "IP record : spoofe",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file [startpacket [endpacket]]",
  /*french usage*/  "nom_fichier [packet_debut [packet_fin]]",
  /*usage example*/ "/tmp/file 1 5",
  /*fr. usage ex.*/ "/tmp/fichier 1 5", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000028_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000028_main(int argc, char *argv[])
{ lcrzo_int32 start, end;
  lcrzo_record record;
  shared_record_exact sram;
  lcrzo_spoof spoof;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000028, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (argc>=3)
  { lcrzo_epr(lcrzo_int32_init_text(argv[2], &start));
  }
  else 
  { start=+1;
  }
  if (argc>=4)
  { lcrzo_epr(lcrzo_int32_init_text(argv[3], &end));
  }
  else
  { end=-1;
  }

  /* init spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_TRUE));

  /* initialize the sram */
  lcrzo_epr(shared_record_exact_initdefault(&sram));
  sram.pspoof=&spoof;
  
  /* loop through the record */
  lcrzo_epr(lcrzo_record_open(&record, argv[1], LCRZO_RECORD_OPEN_READ));
  lcrzo_epr(lcrzo_record_loop_range(&record, start, end,
				    &shared_record_exact_ip_spoof, &sram));
  lcrzo_epr(lcrzo_record_close(&record));

  /* close spoof */
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}


