
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000032=
{ /*reference*/     "lcrzoex", 32,
  /*version*/       1, 0,
  /*title*/         "{ETH,IP} spoof specified by user",
  /*french title*/  "spoof {ETH,IP} specifie par l'utilisateur",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "",
  /*french usage*/  "",
  /*usage example*/ "",
  /*fr. usage ex.*/ "", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000032_main(void);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000032_main(void)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_spoof spoof;
  lcrzo_int16 language;
  lcrzo_hdrleth hdrleth;
  lcrzo_hdrlip hdrlip;
  lcrzo_ipopt ipopt;
  lcrzo_uint8 ipoptsize;
  lcrzo_device device;
  int ret;

  lcrzo_init();
  /* get language */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* initialize device */
  ret=lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_BEST, 1, device);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_er(lcrzo_device_initdefault(device));
  }
  lcrzo_epr(lcrzo_device_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				    "envoyer sur quel device":
				    "send on which device",
				    device, device));

  /* initialize Ethernet header */
  lcrzo_epr(lcrzo_hdrleth_initdefault(&hdrleth));
  lcrzo_epr(lcrzo_etha_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?"adresse source":
				  "source address", "aa:bb:cc:dd:ee:ff", 
				  hdrleth.src));
  lcrzo_epr(lcrzo_etha_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				  "adresse destination":"destination address",
				  "ff:ff:ff:ff:ff:ff", 
				  hdrleth.dst));

  /* initialize IP header */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&hdrlip));
  lcrzo_epr(lcrzo_ipl_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?"adresse source":
				 "source address", "255.255.255.255",
				 &(hdrlip.saddr)));
  lcrzo_epr(lcrzo_ipl_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				 "adresse destination":
				 "destination address", "1.2.3.4",
				 &(hdrlip.daddr)));
  lcrzo_epr(lcrzo_uint8_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				   "protocole":"protocol", 
				   0, 255, 0, &(hdrlip.protocol)));

  /* initialize IP options */
  lcrzo_epr(lcrzo_ipopt_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				   "options IP":"IP options", "",
				   ipopt, &ipoptsize));

  /* initialize data */
  lcrzo_epr(lcrzo_data_initm_mixed_stdin((language==LCRZO_GLOBAL_LANG_FR)?
					 "donnees du paquet":"packet's data",
					 "'hello' 0D0A", &data, &datasize));

  /* spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_TRUE));
  lcrzo_epr(lcrzo_spoof_ethipoptdata(&spoof, device, hdrleth,
				     hdrlip, ipopt, ipoptsize,
				     data, (lcrzo_uint16)datasize));
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_er(lcrzo_data_free2(&data));
  lcrzo_close();
  return(LCRZO_ERR_OK);
}
