
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000061=
{ /*reference*/     "lcrzoex", 61,
  /*version*/       1, 0,
  /*title*/         "{IP,TCP} spoof of a RST (fragmented)",
  /*french title*/  "spoof {IP,TCP} d'un RST (fragmente)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ip_source_address ip_dest_address source_port dest_port seqnum acknum fragsize",
  /*french usage*/  "adresse_ip_source adresse_ip_dest port_source port_dest numseq numack taillefrag",
  /*usage example*/ "1.2.3.4 5.6.7.8 1234 21 786453 56544 1",
  /*fr. usage ex.*/ "1.2.3.4 5.6.7.8 1234 21 786453 56544 1", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000061_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000061_main(int argc, char *argv[])
{ lcrzo_spoof spoof;
  lcrzo_hdrlip hdrlip;
  lcrzo_hdrltcp hdrltcp;
  lcrzo_uint16 fragoctosize;

  lcrzo_init();
  if ( argc<8 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000061, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize IP header */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&hdrlip));
  lcrzo_epr(shared_para_ipl_init_src(argv[1], &(hdrlip.saddr)));
  lcrzo_epr(shared_para_ipl_init_dst(argv[2], &(hdrlip.daddr)));

  /* initialize TCP header */
  lcrzo_epr(lcrzo_hdrltcp_initdefault(&hdrltcp));
  lcrzo_epr(shared_para_port_init_src(argv[3], &hdrltcp.sport));
  lcrzo_epr(shared_para_port_init_dst(argv[4], 0, &hdrltcp.dport));
  hdrltcp.rst=1;
  lcrzo_epr(shared_para_uint32_init_tcpseqnum(argv[5], &hdrltcp.seqnum));
  lcrzo_epr(shared_para_uint32_init_tcpacknum(argv[6], &hdrltcp.acknum));

  /* spoof */
  lcrzo_epr(shared_para_uint16_init_ipfragoctosize(argv[7], &fragoctosize));
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_TRUE));
  lcrzo_epr(lcrzo_spoof_set_fragoctosize(&spoof, fragoctosize));
  lcrzo_epr(lcrzo_spoof_ipopttcpoptdata(&spoof, hdrlip, NULL, 0,
					hdrltcp, NULL, 0, NULL, 0));
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
