
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000063=
{ /*reference*/     "lcrzoex", 63,
  /*version*/       1, 0,
  /*title*/         "ICMP record : display",
  /*french title*/  "ICMP record : affiche",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file [startpacket [endpacket]]",
  /*french usage*/  "nom_fichier [packet_debut [packet_fin]]",
  /*usage example*/ "/tmp/file 1 6",
  /*fr. usage ex.*/ "/tmp/fichier 1 6", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000063_main(int argc, char *argv[]);
int lcrzoex_000063_printicmpdata(lcrzo_ptr data,
				 lcrzo_int32 datasize,
				 lcrzo_ptr pinfos);

/*-------------------------------------------------------------*/
/* variable declaration */
lcrzo_printprofile lcrzoex_000063printprofile;

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000063_main(int argc, char *argv[])
{ lcrzo_int32 start, end;
  lcrzo_record record;
  lcrzo_int16 language;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000063, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (argc>=3)
  { lcrzo_epr(lcrzo_int32_init_text(argv[2], &start));
  }
  else 
  { start=+1;
  }
  if (argc>=4)
  { lcrzo_epr(lcrzo_int32_init_text(argv[3], &end));
  }
  else
  { end=-1;
  }

  /* open the record */
  lcrzo_epr(lcrzo_record_open(&record, argv[1], LCRZO_RECORD_OPEN_READ));

  /* get printprofile */
  lcrzo_epr(lcrzo_global_get_language(&language));
  lcrzo_epr(lcrzo_printprofile_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				     "Choisissez le profil d'affichage":
				     "Choose the print profile",
				     LCRZO_PRINTPROFILE_ARRAYDUMP, 
				     &lcrzoex_000063printprofile));

  /* main loop */
  lcrzo_epr(lcrzo_record_loop_range(&record, start, end,
				    &lcrzoex_000063_printicmpdata, 
				    NULL));

  /* end */
  lcrzo_epr(lcrzo_record_close(&record));
  lcrzo_close();
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000063_printicmpdata(lcrzo_ptr data,
				 lcrzo_int32 datasize,
				 lcrzo_ptr pinfos)
{
  lcrzo_epr(lcrzo_packet_print_icmp((lcrzo_data)data, datasize,
				    lcrzoex_000063printprofile));
  if (lcrzoex_000063printprofile.hdr!=LCRZO_PRINTTYPE_SYNTH) printf("\n");
  return (LCRZO_ERR_OK);
  pinfos=pinfos; /*just for the compiler warning*/
}

