
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000108=
{ /*reference*/     "lcrzoex", 108,
  /*version*/       1, 1,
  /*title*/         "real udp server [stdin]",
  /*french title*/  "serveur udp reel [stdin]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_port",
  /*french usage*/  "port_serveur",
  /*usage example*/ "5566",
  /*fr. usage ex.*/ "5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000108_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000108_main(int argc, char *argv[])
{ lcrzo_sock sock;
  lcrzo_uint16 port;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000108, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_port_init_listen(argv[1], &port));
  lcrzo_epr(lcrzo_sock_udpser_real(port, &sock));
  lcrzo_epr(shared_sock_stdin(&sock, LCRZO_TRUE));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

