
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000131=
{ /*reference*/     "lcrzoex", 131,
  /*version*/       1, 0,
  /*title*/         "answer to ARP/ping request for a computer",
  /*french title*/  "repond aux requetes ARP/ping d'une machine",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "device spoofed_ethernet_address spoofed_ip_address",
  /*french usage*/  "device adresse_ethernet_usurpee adresse_ip_usurpee",
  /*usage example*/ "eth0 aa:bb:cc:dd:ee:ff 1.2.3.4",
  /*fr. usage ex.*/ "eth0 aa:bb:cc:dd:ee:ff 1.2.3.4",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000131_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000131_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_etha ethtospoof;
  lcrzo_ipl iptospoof;
  lcrzo_uint32 mtu;
  lcrzo_sniff sniff;
  lcrzo_data sniffdata;
  lcrzo_int32 sniffdatasize;
  int ret;

  lcrzo_init();
  if ( argc<4 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000131, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize device, ethernet address and mtu */
  lcrzo_epr(shared_para_device_init_src(argv[1], device));
  lcrzo_epr(shared_para_etha_init_src(argv[2], ethtospoof));
  lcrzo_epr(shared_para_ipl_init_src(argv[3], &iptospoof));
  lcrzo_epr(lcrzo_mtu_init_device(device, &mtu));

  /* init sniff */
  lcrzo_epr(lcrzo_sniff_init(device, mtu, LCRZO_SNIFF_TYPE_NORMAL, 
			     "", &sniff));

  /* main loop */
  lcrzo_epr(lcrzo_global_set_spoof_printbeforesending(LCRZO_TRUE));
  lcrzo_epr(lcrzo_global_set_spoof_printprofile(LCRZO_PRINTPROFILE_SYNTHSYNTH));
  while ( LCRZO_TRUE )
  { ret=lcrzo_sniff_nextm(&sniff, LCRZO_WAIT_INFINITE, 
			  &sniffdata, &sniffdatasize);
    if (ret!=LCRZO_ERR_OK) break;
    /*lcrzo_packet_print_eth(sniffdata, sniffdatasize,
                           LCRZO_PRINTPROFILE_SYNTHSYNTH);*/
    lcrzo_epr(lcrzo_virtual_answer_alive(sniffdata, sniffdatasize, 
					 device, ethtospoof, iptospoof));
    lcrzo_epr(lcrzo_data_free2(&sniffdata));
  }

  /* close everything */
  lcrzo_epr(lcrzo_sniff_close(&sniff));
  lcrzo_close();
  return (LCRZO_ERR_OK);
}
