
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000134=
{ /*reference*/     "lcrzoex", 134, 
  /*version*/       1, 1, 
  /*title*/         "print Ethernet addresses of computers on a network", 
  /*french title*/  "affiche les adresses Ethernet des machines d'un reseau", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "w.x.y.z (class C if z==0, class B if y==z==0)",
  /*french usage*/  "w.x.y.z (classe C si z==0, classe B si y==z==0)", 
  /*usage example*/ "192.168.1.0",
  /*fr. usage ex.*/ "192.168.1.0",
  /*author*/        "Laurent"
};

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000134_main(int argc, char *argv[]);
int lcrzoex_000134_main(int argc, char *argv[])
{ lcrzo_ipa ipa;
  lcrzo_ipl ipl;
  lcrzo_etha etha;
  lcrzo_uint8 i, j;
  lcrzo_int16 language;
  int ret;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000134, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(lcrzo_global_get_language(&language));
  lcrzo_epr(shared_para_ipl_init(argv[1],
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez l'adresse":
				 "Choose address",
				 "192.168.0.0", 
				 &ipl));
  lcrzo_epr(lcrzo_ipa_init_ipl(ipl, ipa));
  if ( ipa[2]==0 && ipa[3]==0 )
  { for ( i=0 ; i<=255 ; i++ )
      for ( j=0 ; j<=255 ; j++ )
      { ipa[2]=i;
        ipa[3]=j;
	lcrzo_epr(lcrzo_ipa_print("", ipa, ""));
        ret=lcrzo_etha_init_ipa(ipa, etha);
	if (ret==LCRZO_ERR_OK)
	{ lcrzo_epr(lcrzo_etha_print("\t", etha, "\n"));
	}
	else
	  puts("");
      }
  }
  else if ( ipa[3]==0 )
  { for ( i=1 ; i<=254 ; i++ )
    { ipa[3]=i;
      lcrzo_epr(lcrzo_ipa_print("", ipa, ""));
      ret=lcrzo_etha_init_ipa(ipa, etha);
      if (ret==LCRZO_ERR_OK)
      { lcrzo_epr(lcrzo_etha_print("\t", etha, "\n"));
      }
      else
	puts("");
    }
  }
  else
  { ret=lcrzo_etha_init_ipa(ipa, etha);
    lcrzo_epr(lcrzo_ipa_print("", ipa, ""));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_epr(lcrzo_etha_print("\t", etha, "\n"));
    }
    else
      puts("");
  }
  lcrzo_close();
  return(LCRZO_ERR_OK);
}
