
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000148=
{ /*reference*/     "lcrzoex", 148, 
  /*version*/       1, 0, 
  /*title*/         "convert a base64 string", 
  /*french title*/  "convertit une chaine base64", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "\"base64_string\"",
  /*french usage*/  "\"chaine_base64\"", 
  /*usage example*/ "\"aGVsbG8=\"",
  /*fr. usage ex.*/ "\"aGVsbG8=\"",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000148_main(int argc, char *argv[]);

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000148_main(int argc, char *argv[])
{ lcrzo_data data;
  lcrzo_int32 datasize;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000148, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(lcrzo_data_initm_base64(argv[1], &data, &datasize));
  lcrzo_epr(shared_misc_printdata(data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));
  lcrzo_close();
  return(LCRZO_ERR_OK);
}
