
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000151=
{ /*reference*/     "lcrzoex", 151, 
  /*version*/       1, 0, 
  /*title*/         "dump the content of a file", 
  /*french title*/  "dumpe le contenu d'un fichier", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "input_file",
  /*french usage*/  "fichier", 
  /*usage example*/ "/tmp/file",
  /*fr. usage ex.*/ "/tmp/fichier",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000151_main(int argc, char *argv[]);

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000151_main(int argc, char *argv[])
{ lcrzo_file inputfile;
  lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_uint8 line[16];
  lcrzo_bool needtoreadmore;
  lcrzo_string filename;
  int ret, i, j;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000151, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_string_init_filelocal(argv[1], &filename));
  ret=lcrzo_file_open_read(filename, &inputfile);
  lcrzo_epr(lcrzo_string_free2(&filename));
  if (ret!=LCRZO_ERR_OK) return(ret);
  lcrzo_epr(lcrzo_data_alloc(0, &data));
  i=0;
  j=0;
  needtoreadmore=LCRZO_TRUE;
  datasize=0;
  ret=LCRZO_ERR_OK;
  while (LCRZO_TRUE)
  { if (needtoreadmore) 
    { /* read */
      j=0;
      lcrzo_epr(lcrzo_data_free2(&data));
      ret=lcrzo_file_readm(&inputfile, LCRZO_WAIT_INFINITE, &data, &datasize);
      if (ret!=LCRZO_ERR_OK)
      { if (ret==LCRZO_ERR_OKDATAEND) ret=LCRZO_ERR_OK;
        break;
      }
    }
    /* set the array */
    while ( i<16 && j<datasize ) line[i++]=data[j++];
    /* display it */
    if (i==16)
    { lcrzo_er(lcrzo_data_print(line, 16, LCRZO_PRINTTYPE_DUMP));
      needtoreadmore=LCRZO_FALSE;
      i=0;
    }
    else
    { needtoreadmore=LCRZO_TRUE;
    }
  }
  lcrzo_epr(ret);
  if (i)
  { lcrzo_epr(lcrzo_data_print(line, i, LCRZO_PRINTTYPE_DUMP));
  }

  lcrzo_epr(lcrzo_file_close(&inputfile));
  lcrzo_close();
  return (LCRZO_ERR_OK);
}


