
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000162=
{ /*reference*/     "lcrzoex", 162,
  /*version*/       1, 3,
  /*title*/         "real tcp client [send email]",
  /*french title*/  "client tcp reel [envoie email]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port \"from@a.b\" \"to@c.d\" body_filename [\"subject\"]",
  /*french usage*/  "nom_serveur port_serveur  \"from@a.b\" \"to@c.d\" fichier_body [\"sujet\"]",
  /*usage example*/ "1.2.3.4 25 \"laurent@s.com\" \"dest@d.com\" /tmp/file \"here the subject\"",
  /*fr. usage ex.*/ "1.2.3.4 25 \"laurent@s.com\" \"dest@d.com\" /tmp/fichier \"ici, le sujet\"",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000162_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000162_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_uint16 port;

  lcrzo_init();
  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000162, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &ipl));
  lcrzo_epr(shared_para_port_init_dst(argv[2], 25, &port));
  lcrzo_er(shared_smtp_sendmsg_hb_file(ipl, port,
				       argv[3], argv[4], argv[3], argv[3],
				       argv[4],
				       (argc==6)?"":argv[6], argv[5]));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}





