
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000168=
{ /*reference*/     "lcrzoex", 168,
  /*version*/       1, 1,
  /*title*/         "real udp client [pipe]",
  /*french title*/  "client udp reel [pipe]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 53",
  /*fr. usage ex.*/ "1.2.3.4 53",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000168_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000168_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_sock sock;
  lcrzo_uint16 port;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000168, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &ipl));
  lcrzo_epr(shared_para_port_init_dst(argv[2], 53, &port));
  lcrzo_epr(lcrzo_sock_udpcli_real(ipl, port, &sock));
  lcrzo_epr(shared_sock_pipe(&sock, LCRZO_FALSE, LCRZO_FALSE));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

