
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000173=
{ /*reference*/     "lcrzoex", 173, 
  /*version*/       1, 1, 
  /*title*/         "print information about the computer (devices) - simple", 
  /*french title*/  "affiche les informations sur la machine (devices) - simple", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "",
  /*french usage*/  "", 
  /*usage example*/ "",
  /*fr. usage ex.*/ "",
  /*author*/        "Laurent"
};

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000173_main(void);
int lcrzoex_000173_main(void)
{ lcrzo_int32 count, i;
  lcrzo_device device;
  lcrzo_etha etha;
  lcrzo_ipl ipl, mask, ptpipl;
  lcrzo_uint32 mtu;
  lcrzo_bool isup, isanalias, isptp;
  lcrzo_int16 hwtype;

  lcrzo_init();
  /*look at example 158 if you want the results to be nicely displayed*/

  /* we loop through the number of devices */
  lcrzo_er(lcrzo_conf_devices_count(&count));
  for ( i=1 ; i<=count ; i++ )
  { /*get the information*/
    lcrzo_epr(lcrzo_conf_devices_value_pos(i,
					   device,
					   &hwtype,
					   etha,
					   &ipl, &mask,
					   &mtu, &isup, &isanalias,
					   &isptp, &ptpipl));
    /*print the information*/
    printf("\ndevice : %s ", device);
    lcrzo_epr(lcrzo_uint32_print("(mtu:", mtu, "%u", ", "));
    printf("isup:%d, isanalias:%d, ispointtopoint:%d)\n", 
	   isup, isanalias, isptp);
    lcrzo_epr(lcrzo_int16_print("hwtype : ", hwtype, "%d", "\n"));
    lcrzo_epr(lcrzo_etha_print("Ethernet : ", etha, "\n"));
    lcrzo_epr(lcrzo_ipl_print("IP :       ", ipl, "/"));
    lcrzo_epr(lcrzo_ipl_print("", mask, "\n"));
    if (isptp) 
    { lcrzo_epr(lcrzo_ipl_print("PointToPoint :       ", ptpipl, "\n"));
    }
  }  
  lcrzo_close();
  return(LCRZO_ERR_OK);
}
