
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000178=
{ /*reference*/     "lcrzoex", 178,
  /*version*/       1, 0,
  /*title*/         "real udp client [pipe] (local ip/port and IP option)",
  /*french title*/  "client udp reel [pipe] (ip/port local et option IP)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "client_name server_name client_port server_port",
  /*french usage*/  "nom_client nom_serveur port_client port_serveur",
  /*usage example*/ "1.2.3.4 1.2.3.5 4444 21",
  /*fr. usage ex.*/ "1.2.3.4 1.2.3.5 4444 21",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000178_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000178_main(int argc, char *argv[])
{ lcrzo_ipl serveripl, clientipl;
  lcrzo_uint16 serverport, clientport;
  lcrzo_sock sock;
  lcrzo_ipopt ipopt;
  lcrzo_uint8 ipoptsize;
  lcrzo_int16 language;

  lcrzo_init();
  if ( argc<5 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000178, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize IP addresses */
  lcrzo_epr(shared_para_ipl_init_src(argv[1], &clientipl));
  lcrzo_epr(shared_para_ipl_init_dst(argv[2], &serveripl));

  /* initialize IP options */
  lcrzo_epr(lcrzo_global_get_language(&language));
  lcrzo_epr(lcrzo_ipopt_init_stdin((language==LCRZO_GLOBAL_LANG_FR)?
				   "options IP":"IP options", "",
				   ipopt, &ipoptsize));

  /* initialize port numbers */
  lcrzo_epr(shared_para_port_init_src(argv[3], &clientport));
  lcrzo_epr(shared_para_port_init_dst(argv[4], 53, &serverport));

  /* initialize the socket */
  lcrzo_epr(lcrzo_sock_udpcli_real2(clientipl, serveripl,
				    clientport, serverport,
				    ipopt, ipoptsize,
				    &sock));
  
  /* call the example working on the socket */
  lcrzo_epr(shared_sock_pipe(&sock, LCRZO_FALSE, LCRZO_FALSE));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

