
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "lcrzoex_000216.c"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000217=
{ /*reference*/     "lcrzoex", 217,
  /*version*/       1, 0,
  /*title*/         "tcp backdoor client [interactive]",
  /*french title*/  "client tcp backdoor [interactif]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur ",
  /*usage example*/ "1.2.3.4 1234",
  /*fr. usage ex.*/ "1.2.3.4 1234",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000217_main(int argc, char *argv[]);
int lcrzoex_000217_clientstdin(lcrzo_sock *psock);
int lcrzoex_000217_auth(lcrzo_sock *psock, lcrzo_conststring password);
int lcrzoex_000217_quit(lcrzo_sock *psock);
int lcrzoex_000217_help(void);
int lcrzoex_000217_exec(lcrzo_sock *psock, 
			lcrzo_conststring parameters);
int lcrzoex_000217_get(lcrzo_sock *psock, 
		       lcrzo_conststring parameters);
int lcrzoex_000217_put(lcrzo_sock *psock, 
		       lcrzo_conststring parameters);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000217_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_uint16 port;
  lcrzo_sock sock;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000217, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize addresses */
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &ipl));

  /* initialize the client */
  lcrzo_epr(shared_para_port_init_dst(argv[2], 0, &port));
  lcrzo_epr(lcrzo_sock_tcpcli_real(ipl, port, &sock));

  /* run the client */
  lcrzo_epr(lcrzoex_000217_clientstdin(&sock));

  /* close the client */
  lcrzo_epr(lcrzo_sock_close(&sock));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_clientstdin(lcrzo_sock *psock)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_string passwd, command, parameters;
  lcrzo_regexp re;
  lcrzo_file stdinfile;
  lcrzo_int16 language;
  int ret;
  
  /* authenticate the client */
  lcrzo_epr(lcrzo_string_initm_text_passwd("Passwd", "", &passwd));
  ret=lcrzoex_000217_auth(psock, passwd);
  lcrzo_epr(lcrzo_string_free2(&passwd));
  if (ret!=LCRZO_ERR_OK) return(ret);
  lcrzo_epr(lcrzo_file_init_fd(0, &stdinfile));

  /* treat user's requests */
  lcrzo_epr(lcrzo_global_get_language(&language));
  while(LCRZO_TRUE)
  { /* read user data */
    printf("server> ");
    lcrzo_epr(lcrzo_stream_flush(stdout));
    lcrzo_epr(lcrzo_file_readm_line(&stdinfile, LCRZO_WAIT_INFINITE,
				    &data, &datasize));
    /* print the read data */
    /*lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP));*/
    /* separate command and parameters */
    ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([A-Za-z]+)[ \t]*(.*)[ \t]*$", re);
    if ( ret!=LCRZO_ERR_OK )
    { /* unrecognized command */
      lcrzo_epr(lcrzo_data_free2(&data));
      if ( language==LCRZO_GLOBAL_LANG_FR )
      { printf("La ligne n'a pas la forme \"commande [parametres]\". ");
        printf("Entrez \"HELP\" pour l'aide.\n");
      }
      else
      { printf("The line hasn't the format \"command [parameters]\". ");
	printf("Enter \"HELP\" for help.\n");
      }
      continue;
    }
    /* set command and parameters */
    data[datasize]='\0';
    lcrzo_epr(lcrzo_string_initm_range((lcrzo_string)data,
				       re[1].startindex_positive,
				       re[1].endindex_positive, &command));
    if ( re[1].startindex_positive==0 && re[1].endindex_positive==0 )
    { lcrzo_epr(lcrzo_string_initm_text("", &parameters));
    }
    else
    { lcrzo_epr(lcrzo_string_initm_range((lcrzo_string)data,
					 re[2].startindex_positive,
					 re[2].endindex_positive,&parameters));
    }
    lcrzo_epr(lcrzo_data_free2(&data));
    /* call functions corresponding to commands */
    /* if we read 'QUIT', we quit */
    if ( ! shared_misc_strcasecmp(command, "quit") )
    { lcrzo_epr(lcrzoex_000217_quit(psock));
      lcrzo_epr(lcrzo_string_free2(&command));
      lcrzo_epr(lcrzo_string_free2(&parameters));    
      break;
    }
    /* if we read 'HELP', we display help */
    else if ( ! shared_misc_strcasecmp(command, "help") )
    { lcrzo_epr(lcrzoex_000217_help());
    }
    /* if we read 'EXEC', we execute a command */
    else if ( ! shared_misc_strcasecmp(command, "exec") )
    { lcrzo_epr(lcrzoex_000217_exec(psock, parameters));
    }
    /* if we read 'GET', we get a file */
    else if ( ! shared_misc_strcasecmp(command, "get") )
    { lcrzo_epr(lcrzoex_000217_get(psock, parameters));
    }
    /* if we read 'PUT', we put a file */
    else if ( ! shared_misc_strcasecmp(command, "put") )
    { lcrzo_epr(lcrzoex_000217_put(psock, parameters));
    }
    /* unknown command */
    else
    { if ( language==LCRZO_GLOBAL_LANG_FR )
      { printf("Cette commande n'est pas supportee. ");
        printf("Entrez \"HELP\" pour l'aide.\n");
      }
      else
      { printf("This command isn't supported. ");
	printf("Enter \"HELP\" for help.\n");
      }
    }
 
    lcrzo_epr(lcrzo_string_free2(&command));
    lcrzo_epr(lcrzo_string_free2(&parameters));    
  }

  lcrzo_epr(lcrzo_file_close(&stdinfile));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_auth(lcrzo_sock *psock, lcrzo_conststring password)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_regexp re;
  lcrzo_string serverrand, clientrand, hash; 
  int ret;

  /* get the server rand */
  lcrzo_epr(lcrzo_sock_readm_line(psock, LCRZO_WAIT_INFINITE, 
				  &data, &datasize));
  ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
			       "^100 (................) .*$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized banner */
    lcrzo_epr(lcrzo_data_free2(&data));
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  data[datasize]='\0';
  lcrzo_epr(lcrzo_string_initm_range((lcrzo_string)data,
				     re[1].startindex_positive,
				     re[1].endindex_positive, &serverrand));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* generate the salt */
  lcrzo_epr(lcrzo_string_initm_rand(33, 126, 16, &clientrand));

  /* compute the hash */
  lcrzo_epr(shared_misc_randpasshash_old(serverrand, clientrand, password,
					 &hash));
  lcrzo_epr(lcrzo_string_free2(&serverrand));

  /* send the hash */
  lcrzo_epr(lcrzo_data_initm_text("AUTH ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(clientrand, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_string_free2(&clientrand));
  lcrzo_epr(lcrzo_data_appendm_text(" ", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(hash, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_string_free2(&hash));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* verify if OK */
  lcrzo_epr(shared_misc_verifyresponse1(psock, LCRZOEX_000216_ERR_OK));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_quit(lcrzo_sock *psock)
{ lcrzo_data data;
  lcrzo_int32 datasize;

  /* write end */
  lcrzo_epr(lcrzo_data_initm_text("QUIT\n", &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* read answer */
  lcrzo_epr(shared_misc_verifyresponse1(psock, LCRZOEX_000216_ERR_OKBYE));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_help(void)
{ lcrzo_int16 language;

  lcrzo_epr(lcrzo_global_get_language(&language));
      
  if ( language==LCRZO_GLOBAL_LANG_FR )
  { puts("HELP                            : affiche l'aide");
    puts("GET fichierdistant fichierlocal : telecharge fichierdistant en fichierlocal");
    puts("PUT fichierlocal fichierdistant : uploade fichierlocal en fichierdistant");
    puts("EXEC commande                   : execute la commande");
    puts("QUIT                            : quitte");
  }
  else
  { puts("HELP                      : display this help");
    puts("GET distantfile localfile : download distantfile in localfile");
    puts("PUT localfile distantfile : upload localfile in distantfile");
    puts("EXEC command              : execute the command");
    puts("QUIT                      : leave");
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_exec(lcrzo_sock *psock,
			lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, sizetoread;
  lcrzo_string errorcode, commandoutputsize;
  lcrzo_regexp re;
  lcrzo_int16 language;
  int ret;

  lcrzo_epr(lcrzo_global_get_language(&language));

  /* write command */
  lcrzo_epr(lcrzo_data_initm_text("EXEC ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(parameters, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* read answer (ignore error) */
  ret=shared_misc_verifyresponse(psock, LCRZOEX_000216_ERR_OK,
				 LCRZOEX_000216_ERR_OK, LCRZOEX_000216_ERR_OK,
				 LCRZOEX_000216_ERR_OK, LCRZO_TRUE,
				 NULL, &data, &datasize);
  if ( ret==LCRZOEX_ERR_MISC_BADRESPONSE )
  { lcrzo_epr(lcrzo_data_free2(&data));
    return(LCRZO_ERR_OK);
  }
  else if ( ret!=LCRZO_ERR_OK )
  { return(ret); 
  }

  /* get size and error code */
  ret=lcrzo_data_search_regexp(data, datasize, LCRZO_FALSE, +1, -1,
			       "^([0-9]+) ([0-9]+)", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized banner */
    lcrzo_epr(lcrzo_data_free2(&data));
    return(LCRZOEX_ERR_MISC_BADRESPONSE);
  }
  data[datasize]='\0';
  lcrzo_epr(lcrzo_string_initm_range((lcrzo_string)data, 
				     re[1].startindex_positive,
				     re[1].endindex_positive,
				     &commandoutputsize));
  lcrzo_epr(lcrzo_string_initm_range((lcrzo_string)data, 
				     re[2].startindex_positive,
				     re[2].endindex_positive, &errorcode));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* display error code */
  if ( language==LCRZO_GLOBAL_LANG_FR )
    printf("Code d'erreur %s\n", errorcode);
  else
    printf("Error code %s\n", errorcode);
  lcrzo_epr(lcrzo_string_free2(&errorcode));

  /* display command result */
  lcrzo_epr(lcrzo_int32_init_text(commandoutputsize, &sizetoread));  
  lcrzo_epr(lcrzo_string_free2(&commandoutputsize));
  lcrzo_epr(lcrzo_sock_readm_fixed(psock, LCRZO_WAIT_INFINITE, 
				   sizetoread, &data));
  data[sizetoread]='\0';
  printf("%s\n", data);
  lcrzo_epr(lcrzo_data_free2(&data));
  
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_get(lcrzo_sock *psock,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize, bytetoread;
  lcrzo_string distantfile, localfile;
  lcrzo_bool errorinread;
  lcrzo_file file;
  lcrzo_regexp re;
  lcrzo_int16 language;
  int ret;

  lcrzo_epr(lcrzo_global_get_language(&language));
  /* get files */
  ret=lcrzo_string_search_regexp(parameters, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([^ \t]+)[ \t]*([^ \t]+)[ \t]*$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized command */
    if ( language==LCRZO_GLOBAL_LANG_FR )
      puts("Usage : get fichierdistant fichierlocal");
    else
      puts("Usage : get distantfile localfile");
    return(LCRZO_ERR_OK);
  }
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[1].startindex_positive,
				     re[1].endindex_positive, &distantfile));
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[2].startindex_positive,
				     re[2].endindex_positive, &localfile));

  /* open the local file */
  lcrzo_epr(lcrzo_global_get_language(&language));
  ret=lcrzo_file_open_write(localfile, LCRZO_FALSE, LCRZO_FALSE, &file);
  if (ret!=LCRZO_ERR_OK)
  { if ( language==LCRZO_GLOBAL_LANG_FR )
      printf("Impossible d'ouvrir %s\n", localfile);
    else
      printf("Can't open %s\n", localfile);
    lcrzo_epr(lcrzo_string_free2(&distantfile));
    lcrzo_epr(lcrzo_string_free2(&localfile));
    return(LCRZO_ERR_OK);
  }
  lcrzo_epr(lcrzo_string_free2(&localfile));

  /* send the command */
  lcrzo_epr(lcrzo_data_initm_text("GET ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(distantfile, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_string_free2(&distantfile));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* get the size to read */
  ret=shared_misc_verifyresponse(psock, LCRZOEX_000216_ERR_OK,
				 LCRZOEX_000216_ERR_OK, LCRZOEX_000216_ERR_OK,
				 LCRZOEX_000216_ERR_OK, LCRZO_TRUE,
				 NULL, &data, &datasize);
  if ( ret==LCRZOEX_ERR_MISC_BADRESPONSE )
  { lcrzo_epr(lcrzo_data_free2(&data));
    return(LCRZO_ERR_OK);
  }
  else if ( ret!=LCRZO_ERR_OK )
  { return(ret); 
  }
  data[datasize]='\0';
  lcrzo_er(lcrzo_int32_init_text((lcrzo_string)data, &filesize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* read filesize bytes, and put them in the file (if no error) */
  errorinread=LCRZO_FALSE;
  bytetoread=filesize;
  while (bytetoread)
  { lcrzo_epr(lcrzo_sock_readm(psock, LCRZO_WAIT_INFINITE, &data, &datasize));
    lcrzo_epr(lcrzo_file_write(&file, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
    if (datasize>bytetoread)
    { /* the server sent too much */
      errorinread=LCRZO_TRUE;
      break;
    }
    bytetoread-=datasize;
  }
  lcrzo_epr(lcrzo_file_close(&file));

  /* write error message */
  if ( errorinread )
  { if ( language==LCRZO_GLOBAL_LANG_FR )
      puts("Lu trop de caracteres");
    else
      puts("Read too much bytes");
    return(LCRZO_ERR_OK);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000217_put(lcrzo_sock *psock,
		       lcrzo_conststring parameters)
{ lcrzo_data data;
  lcrzo_int32 datasize, filesize;
  lcrzo_string distantfile, localfile;
  lcrzo_regexp re;
  lcrzo_file file;
  lcrzo_int16 language;
  int ret;

  lcrzo_epr(lcrzo_global_get_language(&language));
  /* get files */
  ret=lcrzo_string_search_regexp(parameters, LCRZO_FALSE, +1, -1,
				 "^[ \t]*([^ \t]+)[ \t]*([^ \t]+)[ \t]*$", re);
  if ( ret!=LCRZO_ERR_OK )
  { /* unrecognized command */
    if ( language==LCRZO_GLOBAL_LANG_FR )
      puts("Usage : get fichierlocal fichierdistant");
    else
      puts("Usage : get localfile distantfile");
    return(LCRZO_ERR_OK);
  }
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[1].startindex_positive,
				     re[1].endindex_positive, &localfile));
  lcrzo_epr(lcrzo_string_initm_range(parameters, re[2].startindex_positive,
				     re[2].endindex_positive, &distantfile));

  /* open the local file */
  lcrzo_epr(lcrzo_global_get_language(&language));
  ret=lcrzo_file_open_read(localfile, &file);
  if (ret!=LCRZO_ERR_OK)
  { if ( language==LCRZO_GLOBAL_LANG_FR )
      printf("Impossible d'ouvrir %s\n", localfile);
    else
      printf("Can't open %s\n", localfile);
    lcrzo_epr(lcrzo_string_free2(&distantfile));
    lcrzo_epr(lcrzo_string_free2(&localfile));
    return(LCRZO_ERR_OK);
  }
  lcrzo_epr(lcrzo_string_free2(&localfile));

  /* send the command */
  lcrzo_epr(lcrzo_data_initm_text("PUT ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(distantfile, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_string_free2(&distantfile));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* write the size of the file */
  lcrzo_epr(lcrzo_file_size(&file, &filesize));
  lcrzo_epr(lcrzo_data_initm_int32(filesize, "%d", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* write file data */ 
  while ( lcrzo_file_readm(&file, LCRZO_WAIT_INFINITE, 
			   &data, &datasize) == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
  }
  lcrzo_epr(lcrzo_file_close(&file));

  /* read answer */
  lcrzo_epr(shared_misc_verifyresponse1(psock, LCRZOEX_000216_ERR_OK));

  return(LCRZO_ERR_OK);
}
