
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000227=
{ /*reference*/     "lcrzoex", 227,
  /*version*/       1, 0,
  /*title*/         "IP record : modify IPUDP fields, spoof",
  /*french title*/  "IP record : modifie champs IPUDP, spoofe",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file srcip dstip sport dport [startpacket [endpacket]]",
  /*french usage*/  "nom_fichier ipsrc ipdst sport dport [packet_debut [packet_fin]]",
  /*usage example*/ "/tmp/file 1.2.3.4 5.6.7.8 1234 567 1 5",
  /*fr. usage ex.*/ "/tmp/fichier 1.2.3.4 5.6.7.8 1234 567 1 5", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declaration */
int lcrzoex_000227_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000227_main(int argc, char *argv[])
{ lcrzo_int32 start, end;
  lcrzo_record record;
  shared_record_addmod sram;
  lcrzo_spoof spoof;
  lcrzo_hdrlip modhdrip;
  lcrzo_hdrludp modhdrudp;

  lcrzo_init();
  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000227, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (argc>=7)
  { lcrzo_epr(lcrzo_int32_init_text(argv[6], &start));
  }
  else 
  { start=+1;
  }
  if (argc>=8)
  { lcrzo_epr(lcrzo_int32_init_text(argv[7], &end));
  }
  else
  { end=-1;
  }

  /* init new addresses */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&modhdrip));
  lcrzo_epr(shared_para_ipl_init_src(argv[2], &(modhdrip.saddr)));
  lcrzo_epr(shared_para_ipl_init_dst(argv[3], &(modhdrip.daddr)));
  lcrzo_epr(lcrzo_hdrludp_initdefault(&modhdrudp));
  lcrzo_epr(shared_para_port_init_src(argv[4], &(modhdrudp.sport)));
  lcrzo_epr(shared_para_port_init_dst(argv[5], 25, &(modhdrudp.dport)));

  /* init spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_set_printbeforesending(&spoof, LCRZO_TRUE));

  /* initialize the sram */
  lcrzo_epr(shared_record_addmod_initdefault(&sram));
  sram.pspoof=&spoof;
  sram.pmodhdrip=&modhdrip;
  sram.pmodhdrudp=&modhdrudp;
  
  /* loop through the record */
  lcrzo_epr(lcrzo_record_open(&record, argv[1], LCRZO_RECORD_OPEN_READ));
  lcrzo_epr(lcrzo_record_loop_range(&record, start, end,
				    &shared_record_addmod_ip_spoof, &sram));
  lcrzo_epr(lcrzo_record_close(&record));

  /* close spoof */
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
