
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000259=
{ /*reference*/     "lcrzoex", 259, 
  /*version*/       1, 0, 
  /*title*/         "convert a record file to a pcap file", 
  /*french title*/  "convertit un fichier record en fichier pcap", 
  /*description*/   "a pcap file is a file generated by tcpdump",
  /*french desc.*/  "un fichier pcap est un fichier genere par tcpdump",
  /*usage*/         "input_file output_file",
  /*french usage*/  "fichier_entree fichier_sortie", 
  /*usage example*/ "/tmp/file /tmp/fileout",
  /*fr. usage ex.*/ "/tmp/fichier /tmp/fichiersortie",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000259_main(int argc, char *argv[]);

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000259_main(int argc, char *argv[])
{ lcrzo_string fin, fout;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000259, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_string_init_filein(argv[1], &fin));
  lcrzo_epr(shared_para_string_init_fileout(argv[2], &fout));
  lcrzo_epr(lcrzo_record_pcapfile_init_recfile(fin, fout));
  lcrzo_epr(lcrzo_string_free2(&fin));
  lcrzo_epr(lcrzo_string_free2(&fout));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}
