
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000266=
{ /*reference*/     "lcrzoex", 266,
  /*version*/       1, 0,
  /*title*/         "real tcp client [download a newsgroup message]",
  /*french title*/  "client tcp reel [telecharge un message de news]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port newsgroup message_number filetostore",
  /*french usage*/  "nom_serveur port_serveur newsgroup numero_message fichier",
  /*usage example*/ "1.2.3.4 119 fr.test 12332 /tmp/msg.12332",
  /*fr. usage ex.*/ "1.2.3.4 119 fr.test 12332 /tmp/msg.12332",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000266_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000266_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_uint16 port;
  lcrzo_uint32 number;
  lcrzo_data data;
  lcrzo_int32 datasize;

  lcrzo_init();
  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000266, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &ipl));
  lcrzo_epr(shared_para_port_init_dst(argv[2], 119, &port));
  lcrzo_epr(lcrzo_uint32_init_text(argv[4], &number));

  lcrzo_epr(shared_nntp_recvmsg(ipl, port, argv[3], number, &data, &datasize));
  /*lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_DUMP);*/
  lcrzo_epr(lcrzo_filename_write(argv[5], LCRZO_FALSE, LCRZO_FALSE, 
				 data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

