
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000270=
{ /*reference*/     "lcrzoex", 270,
  /*version*/       1, 0,
  /*title*/         "execute telnet command",
  /*french title*/  "execute une commande telnet",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port username password command",
  /*french usage*/  "nom_serveur port_serveur nomdelogin motdepasse commande",
  /*usage example*/ "1.2.3.4 23 user mypasswd \"ls /\"",
  /*fr. usage ex.*/ "1.2.3.4 23 util motpasse \"ls /\"",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000270_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000270_main(int argc, char *argv[])
{ lcrzo_ipl serveripl;
  lcrzo_uint16 serverport;
  shared_telnet telnet;
  lcrzo_data data;
  lcrzo_int32 datasize;

  lcrzo_init();
  if ( argc<6 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000270, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &serveripl));
  lcrzo_epr(shared_para_port_init_dst(argv[2], 23, &serverport));

  /* init the session */
  lcrzo_epr(shared_telnet_init(serveripl, serverport, &telnet));

  /* send login/password */
  lcrzo_epr(shared_telnet_login(&telnet, argv[3], argv[4]));

  /* send command */
  lcrzo_epr(shared_telnet_exec(&telnet, argv[5], 1000000, 
			       &data, &datasize));
  lcrzo_epr(lcrzo_data_print(data, datasize, LCRZO_PRINTTYPE_TEXT));
  lcrzo_epr(lcrzo_data_free2(&data));

  /* logout */
  puts("");
  lcrzo_epr(shared_telnet_logout(&telnet));

  /* close the session */
  lcrzo_epr(shared_telnet_close(&telnet));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}

