
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000276=
{ /*reference*/     "lcrzoex", 276,
  /*version*/       1, 0,
  /*title*/         "tcp backdoor server (with a user specified passwd)",
  /*french title*/  "server tcp backdoor (avec un mot de passe specifie par l'utilisateur)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port",
  /*french usage*/  "nom_serveur port_serveur",
  /*usage example*/ "1.2.3.4 5566",
  /*fr. usage ex.*/ "1.2.3.4 5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000276_main(int argc, char *argv[]);
int lcrzoex_000216_server(lcrzo_sock *psock, lcrzo_ptr pinfos);


/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000276_main(int argc, char *argv[])
{ lcrzo_ipl serveripl;
  lcrzo_uint16 serverport;
  lcrzo_string passwd;
  lcrzo_int16 language;
  int ret;

  lcrzo_init();

  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000276, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize IP address */
  lcrzo_epr(shared_para_ipl_init_listen(argv[1], &serveripl));

  /* initialize port numbers */
  lcrzo_epr(shared_para_port_init_listen(argv[2], &serverport));

  /* initialize the socket */
  lcrzo_epr(lcrzo_global_get_language(&language));
  lcrzo_epr(lcrzo_string_initm_text_passwd((language==LCRZO_GLOBAL_LANG_FR)?
					   "Entrez le mot de passe que l'utilisateur aura a saisir":
					   "Enter the password which will be needed by the user",
					   "lcrzoex", &passwd));
  ret=lcrzo_sock_tcpmulser_real2(serveripl, serverport, NULL, 0,
				 &lcrzoex_000216_server, passwd);
  lcrzo_epr(lcrzo_string_free2(&passwd));
  lcrzo_epr(ret);

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

