
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000291=
{ /*reference*/     "lcrzoex", 291,
  /*version*/       1, 0,
  /*title*/         "ftp client deleting a file",
  /*french title*/  "client ftp effacant un fichier",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "sername serport distantfile user [passwd]",
  /*french usage*/  "nomserv portserv fichierdistant utilisateur [password]",
  /*usage example*/ "1.2.3.4 21 /pub/file \"joe\" \"mypass\"",
  /*fr. usage ex.*/ "1.2.3.4 21 /pub/file \"laurent\" \"maison\"",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000291_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000291_main(int argc, char *argv[])
{ lcrzo_sock sockcontrol;
  lcrzo_ipl ipl;
  lcrzo_uint16 port;
  lcrzo_string pwd;
  lcrzo_int16 language;

  lcrzo_init();
  if ( argc<5 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000291, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* initialize IP address */
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &ipl));
  lcrzo_epr(shared_para_port_init_dst(argv[2], 21, &port));

  /* initialize control connection */
  lcrzo_epr(lcrzo_sock_tcpcli_real(ipl, port, &sockcontrol));

  /* first, we connect */
  if (argc>5)
  { lcrzo_epr(lcrzo_string_initm_text(argv[5], &pwd));
  }
  else
  { lcrzo_epr(lcrzo_string_initm_text_passwd("Passwd", "", &pwd));
  }
  lcrzo_epr(shared_ftp_login(&sockcontrol, argv[4], pwd));
  lcrzo_epr(lcrzo_string_free2(&pwd));

  /* we send a 'DELE' */
  lcrzo_epr(shared_ftp_cmd_dele(&sockcontrol, argv[3]));

  /* then, we send a 'QUIT' */
  lcrzo_epr(shared_ftp_cmd_quit(&sockcontrol));

  /* close the socket */
  lcrzo_epr(lcrzo_sock_close(&sockcontrol));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}
