
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000294=
{ /*reference*/     "lcrzoex", 294,
  /*version*/       1, 1,
  /*title*/         "download a web page",
  /*french title*/  "telecharge une page web",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "http://sitelogin:sitepass@site:port/file localfile [http://proxylogin:proxypass@proxy:port/]",
  /*french usage*/  "http://sitelogin:sitepass@site:port/fichier fichierlocal [http://proxylogin:proxypass@proxy:port/]",
  /*usage example*/ "http://server:81/index.html /tmp/file http://bob:pass@proxy:8080/",
  /*fr. usage ex.*/ "http://serveur:81/index.html /tmp/fichier http://laurent:passe@proxy:8080/",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000294_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000294_main(int argc, char *argv[])
{ lcrzo_string urlsite, localfile, urlproxy;
  int ret;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000294, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* the default resolver timeout is too short if it's long to reach
     webserver's DNS */
  lcrzo_epr(shared_http_set_resolver_timeout());

  /* set parameters */
  lcrzo_epr(lcrzo_string_initm_text(argv[1], &urlsite));
  lcrzo_epr(lcrzo_string_initm_text(argv[2], &localfile));
  if ( argc<4 )
  { lcrzo_epr(lcrzo_string_initm_text("", &urlproxy));
  }
  else
  { lcrzo_epr(lcrzo_string_initm_text(argv[3], &urlproxy));
  }

  ret=shared_http_url_download_file(urlsite, urlproxy, NULL, localfile);
  if (ret!=LCRZO_ERR_OK) { lcrzo_epr(lcrzo_err_print(ret)); }

  lcrzo_epr(lcrzo_string_free2(&urlsite));
  lcrzo_epr(lcrzo_string_free2(&localfile));
  lcrzo_epr(lcrzo_string_free2(&urlproxy));

  lcrzo_close();
  return(ret);
}

