
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000312=
{ /*reference*/     "lcrzoex", 312,
  /*version*/       1, 0,
  /*title*/         "real tcp client [stdin] (local ip/port)",
  /*french title*/  "client tcp reel [stdin] (ip/port local)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "client_name server_name client_port server_port",
  /*french usage*/  "nom_client nom_serveur port_client port_serveur",
  /*usage example*/ "1.2.3.4 1.2.3.5 4444 3333",
  /*fr. usage ex.*/ "1.2.3.4 1.2.3.5 4444 3333",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000312_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000312_main(int argc, char *argv[])
{ lcrzo_ipl serveripl, clientipl;
  lcrzo_uint16 serverport, clientport;
  lcrzo_sock sock;

  lcrzo_init();
  if ( argc<5 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000312, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize IP addresses */
  lcrzo_epr(shared_para_ipl_init_src(argv[1], &clientipl));
  lcrzo_epr(shared_para_ipl_init_dst(argv[2], &serveripl));

  /* initialize port numbers */
  lcrzo_epr(shared_para_port_init_src(argv[3], &clientport));
  lcrzo_epr(shared_para_port_init_dst(argv[4], 0, &serverport));

  /* initialize the socket */
  lcrzo_epr(lcrzo_sock_tcpcli_real2(clientipl, serveripl,
				    clientport, serverport,
				    NULL, 0,
				    &sock));
  
  /* call the example working on the socket */
  lcrzo_epr(shared_sock_stdin(&sock, LCRZO_FALSE));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
