
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000319=
{ /*reference*/     "lcrzoex", 319,
  /*version*/       1, 0,
  /*title*/         "icmp ping (true IP, sent at IP level)",
  /*french title*/  "ping icmp (vrai IP, envoye au niveau IP)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "dstip [maxsentpackets] [beepwhenreached]",
  /*french usage*/  "ipdst [nbmaxidepaquetsenvoyes] [bipquandatteint]",
  /*usage example*/ "5.6.7.78",
  /*fr. usage ex.*/ "5.6.7.78",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000319_main(int argc, char *argv[]);
int lcrzoex_000248_ping(lcrzo_device device,
			lcrzo_etha clientetha,
			lcrzo_etha routeretha,
			lcrzo_ipl clientipl, 
			lcrzo_ipl serveripl,
			lcrzo_uint8 maxpackets,
			lcrzo_bool beepwhenreached);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000319_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_ipl clientipl, serveripl;
  lcrzo_etha ethanull;
  lcrzo_uint8 maxpackets;
  lcrzo_bool beepwhenreached;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000319, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &serveripl));
  if ( argc>2 )
  { lcrzo_epr(lcrzo_uint8_init_text(argv[2], &maxpackets));
  }
  else
    maxpackets=0;
  if ( argc>3 )
  { lcrzo_epr(lcrzo_bool_init_text(argv[3], &beepwhenreached));
  }
  else
    beepwhenreached=LCRZO_FALSE;

  lcrzo_epr(lcrzo_conf_route_to_host_ip(serveripl, device, &clientipl, NULL));

  /* call the main function */
  lcrzo_epr(lcrzo_etha_initdefault(ethanull));
  lcrzo_epr(lcrzoex_000248_ping(device, ethanull, ethanull,
				clientipl, serveripl, maxpackets,
				beepwhenreached));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}


