
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000320=
{ /*reference*/     "lcrzoex", 320,
  /*version*/       1, 0,
  /*title*/         "tcp ping (true IP, sent at IP level)",
  /*french title*/  "ping tcp (vrai IP, envoye au niveau IP)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "dstip dstport [maxsentpackets]",
  /*french usage*/  "dipdst portdst [nbmaxidepaquetsenvoyes]",
  /*usage example*/ "5.6.7.78 80",
  /*fr. usage ex.*/ "5.6.7.78 80",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000320_main(int argc, char *argv[]);
int lcrzoex_000250_tcpping(lcrzo_device device,
			   lcrzo_etha clientetha,
			   lcrzo_etha routeretha,
			   lcrzo_ipl clientipl, 
			   lcrzo_ipl serveripl, 
			   lcrzo_uint16 serverport,
			   lcrzo_uint8 maxpackets);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000320_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_ipl clientipl, serveripl;
  lcrzo_uint16 serverport;
  lcrzo_etha ethanull;
  lcrzo_uint8 maxpackets;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000320, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &serveripl));
  lcrzo_epr(shared_para_port_init_dst(argv[2], 80, &serverport));
  if ( argc>3 )
  { lcrzo_epr(lcrzo_uint8_init_text(argv[3], &maxpackets));
  }
  else
    maxpackets=0;

  lcrzo_epr(lcrzo_conf_route_to_host_ip(serveripl, device, &clientipl, NULL));

  /* call the main function */
  lcrzo_epr(lcrzo_etha_initdefault(ethanull));
  lcrzo_epr(lcrzoex_000250_tcpping(device, ethanull, ethanull,
				   clientipl, serveripl, serverport, 
				   maxpackets));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}
