
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000326=
{ /*reference*/     "lcrzoex", 326,
  /*version*/       1, 0,
  /*title*/         "convert a record to a binary file",
  /*french title*/  "convertit un record en fichier binaire",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "textrecord binaryfile",
  /*french usage*/  "recordtexte fichierbinaire",
  /*usage example*/ "textrecord file",
  /*fr. usage ex.*/ "recordtexte fichier",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000326_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000326_main(int argc, char *argv[])
{ lcrzo_record inputrecord;
  lcrzo_file outputfile;
  lcrzo_string fin, fout;
  lcrzo_data data;
  lcrzo_int32 datasize, count, i;
  int ret;

  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000326, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_string_init_filein(argv[1], &fin));
  lcrzo_epr(shared_para_string_init_fileout(argv[2], &fout));

  /* open the file and the record */
  lcrzo_epr(lcrzo_record_open(&inputrecord, fin, LCRZO_RECORD_OPEN_READ));
  lcrzo_epr(lcrzo_file_open_write(fout, LCRZO_FALSE,LCRZO_FALSE, &outputfile));

  /* convert file content */
  lcrzo_epr(lcrzo_record_count(&inputrecord, &count));
  ret=LCRZO_ERR_OK;
  for ( i=1 ; i<=count && ret==LCRZO_ERR_OK ; i++ )
  { /* read from fin */
    ret=lcrzo_record_valuem_pos(&inputrecord, i,
			         &data, &datasize);
    if (ret==LCRZO_ERR_OK)
    { ret=lcrzo_file_write(&outputfile, data, datasize);
      lcrzo_epr(lcrzo_data_free2(&data));
    }
  }

  /* close files */
  lcrzo_epr(lcrzo_record_close(&inputrecord));
  lcrzo_epr(lcrzo_file_close(&outputfile));
  lcrzo_epr(lcrzo_string_free2(&fin));
  lcrzo_epr(lcrzo_string_free2(&fout));

  lcrzo_close();
  return(ret);
}

