
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000345=
{ /*reference*/     "lcrzoex", 345,
  /*version*/       1, 0,
  /*title*/         "DNS server always answering FAILURE",
  /*french title*/  "serveur DNS repondant toujours FAILURE",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "",
  /*french usage*/  "",
  /*usage example*/ "",
  /*fr. usage ex.*/ "", 
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000345_main(void);
int lcrzoex_000345_dns_answer_fail(lcrzo_sock *psock,
				   lcrzo_constdata data,
				   lcrzo_int32 datasize);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000345_main()
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_sock sock;
  int ret;

  lcrzo_init();

  /* listen */
  lcrzo_epr(lcrzo_sock_udpmulser_real(53, &sock));

  /* treat every packet */
  ret=LCRZO_ERR_OK;
  while (LCRZO_TRUE)
  { ret=lcrzo_sock_readm(&sock, LCRZO_WAIT_INFINITE, &data, &datasize);
    if (ret!=LCRZO_ERR_OK) break;
    ret=lcrzoex_000345_dns_answer_fail(&sock, data, datasize);
    lcrzo_er(lcrzo_data_free2(&data));
    if (ret!=LCRZO_ERR_OK) { lcrzo_epr(lcrzo_err_print(ret)); }
  }
  lcrzo_epr(lcrzo_err_print(ret));

  /* free */
  lcrzo_epr(lcrzo_sock_close(&sock));
  lcrzo_close();
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzoex_000345_dns_answer_fail(lcrzo_sock *psock,
				   lcrzo_constdata data,
				   lcrzo_int32 datasize)
{ shared_dns_header dnsheader;
  lcrzo_data response;
  lcrzo_list rrlist;
  lcrzo_int32 responsesize;
  int ret;

  /* display received data */
  lcrzo_er(shared_dns_print(data, datasize, LCRZO_PRINTTYPE_ARRAY));

  /* preparate for the response */
  lcrzo_er(shared_dns_packet_decode(data, datasize,
                                    &dnsheader, &rrlist));
  dnsheader.isaresponse=LCRZO_TRUE;
  dnsheader.rcode=SHARED_DNS_HEADER_RCODE_FAILURE;
  ret=shared_dns_packet_initm(dnsheader, &rrlist, &response, &responsesize);
  lcrzo_er(lcrzo_list_close(&rrlist));
  if (ret!=LCRZO_ERR_OK) return(ret);
  lcrzo_er(shared_dns_print(response, responsesize, LCRZO_PRINTTYPE_ARRAY));

  /* response */
  lcrzo_er(lcrzo_sock_write(psock, response, responsesize));

  lcrzo_er(lcrzo_data_free2(&response));
  return(LCRZO_ERR_OK);  
}




