
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000346=
{ /*reference*/     "lcrzoex", 346,
  /*version*/       1, 0,
  /*title*/         "real multiclient udp server [display and echo]",
  /*french title*/  "serveur udp multiclient reel [affiche et echo]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_port",
  /*french usage*/  "port_serveur",
  /*usage example*/ "5566",
  /*fr. usage ex.*/ "5566",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000346_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000346_main(int argc, char *argv[])
{ lcrzo_sock sock;
  lcrzo_uint16 port;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000346, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_para_port_init_listen(argv[1], &port));
  lcrzo_epr(lcrzo_sock_udpmulser_real(port, &sock));
  lcrzo_epr(shared_sock_echo(&sock));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}

