
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_toolbox.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000351=
{ /*reference*/     "lcrzoex", 351, 
  /*version*/       1, 0, 
  /*title*/         "print information about a tool", 
  /*french title*/  "affiche les informations sur un outil", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "tool_number",
  /*french usage*/  "numero_d_outil", 
  /*usage example*/ "7",
  /*fr. usage ex.*/ "7", 
  /*author*/        "Laurent"
};

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000351_main(int argc, char *argv[]);
int lcrzoex_000351_main(int argc, char *argv[])
{ lcrzo_string str;
  lcrzo_uint32 toolnumber;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000351, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(lcrzo_uint32_init_text(argv[1], &toolnumber));
  lcrzo_epr(lcrzo_string_initm_text("lcrzoex", &str));
  lcrzo_epr(shared_toolbox_tool_usage_print(str, toolnumber));
  lcrzo_epr(lcrzo_string_free2(&str));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
