
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000360=
{ /*reference*/     "lcrzoex", 360,
  /*version*/       1, 0,
  /*title*/         "web spider simple",
  /*french title*/  "web spider simple",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "http://sitelogin:sitepass@site:port/file localdir [http://proxylogin:proxypass@proxy:port/]",
  /*french usage*/  "http://sitelogin:sitepass@site:port/fichier repertoirelocal [http://proxylogin:proxypass@proxy:port/]",
  /*usage example*/ "http://server:81/index.html /tmp/dir/ http://bob:pass@proxy:8080/",
  /*fr. usage ex.*/ "http://serveur:81/index.html /tmp/rep/ http://laurent:passe@proxy:8080/",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000360_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000360_main(int argc, char *argv[])
{ shared_http_spider spider;
  
  lcrzo_init();
  if ( argc<3 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000360, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* the default resolver timeout is too short if it's long to reach
     webserver's DNS */
  lcrzo_epr(shared_http_set_resolver_timeout());

  lcrzo_epr(shared_http_spider_initdefault(&spider));
  lcrzo_epr(shared_http_spider_set_localrootdir(&spider, argv[2]));
  lcrzo_epr(shared_http_spider_add_urltodownload(&spider, 
						 SHARED_HTTP_LINKTYPE_A_HREF,
						 argv[1]));
  if ( argc>=4 )
  { lcrzo_epr(shared_http_spider_set_proxyurl(&spider, argv[3]));
  }

  lcrzo_epr(shared_http_spider_run(&spider));
  lcrzo_epr(shared_http_spider_linkconversion(&spider));
  lcrzo_epr(shared_http_spider_close(&spider));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
