
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000361=
{ /*reference*/     "lcrzoex", 361,
  /*version*/       1, 0,
  /*title*/         "web spider with configuration file",
  /*french title*/  "web spider avec un fichier de configuration",
  /*description*/   "use tool 362 to generate an example of configuration file",
  /*french desc.*/  "utiliser l'outil 362 pour generer un exemple de fichier de configuration",
  /*usage*/         "configuration_file",
  /*french usage*/  "fichier_de_configuration",
  /*usage example*/ "/tmp/conffile",
  /*fr. usage ex.*/ "/tmp/fichierconf",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000361_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000361_main(int argc, char *argv[])
{ shared_http_spider spider;
  
  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000361, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* the default resolver timeout is too short if it's long to reach
     webserver's DNS */
  lcrzo_epr(shared_http_set_resolver_timeout());

  lcrzo_epr(shared_http_spider_init_conffile(&spider, argv[1]));
  lcrzo_epr(shared_http_spider_run(&spider));
  lcrzo_epr(shared_http_spider_linkconversion(&spider));
  lcrzo_epr(shared_http_spider_close(&spider));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
