
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000362=
{ /*reference*/     "lcrzoex", 362,
  /*version*/       1, 0,
  /*title*/         "create a sample conffile for web spider",
  /*french title*/  "cree un exemple de fichier de conf pour le web spider",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "/tmp/conffile_to_create",
  /*french usage*/  "/tmp/fichier_de_conf_a_creer",
  /*usage example*/ "/tmp/conffile",
  /*fr. usage ex.*/ "/tmp/conffile",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000362_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000362_main(int argc, char *argv[])
{ shared_conffile conffile;
  
  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000362, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_epr(shared_conffile_create_init(&conffile, argv[1]));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable localrootdir contient le nom du repertoire ou les fichiers", 
    "Variable localrootdir contains directory name where file have to be"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "doivent etre sauves", 
    "saved"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "localrootdir",
    "/tmp/dir/"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable urltodownload contient l'url a telecharger", 
    "Variable urltodownload contains url to download"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urltodownload", 
    "http://www.server.com/dir/page.html"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable proxyurl contient les infos sur le proxy", 
    "Variable proxyurl contains proxy information"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "(commentez-la si vous n'avez pas de proxy)", 
    "(comment it if you do not have a proxy)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "proxyurl",
    "http://proxylogin:proxypass:server:8080/"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable maxrecursion contient le niveau maxi de recursion", 
    "Variable maxrecursion contains maximum recursion level"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "(0 signifie pas de limite)", 
    "(0 means no limit)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "maxrecursion",
    "0"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable millisleep contient le temps a attendre avant chaque ", 
    "Variable millisleep contains time to wait between each download "));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "telechargement (valeur recommandee : 1000 )", 
    "(recommended : 1000)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "millisleep",
    "0"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable urlmustcontain contient une expression reguliere decrivant", 
    "Variable urlmustcontain contains a regular expression describing"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "ce qui doit etre present dans l'url. La pseudo-regle est :", 
    "what have to be present in the url. The rule is :"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    " si ( url==urlmustcontain1 || url==urlmustcontain2 || etc. ) telecharge", 
    " if ( url==urlmustcontain1 || url==urlmustcontain2 || etc. ) download"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustcontain",
    "http://www\\.server\\.com/dir/"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustcontain",
    "http://1.2.3.4/dir/"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustcontain",
    "http://[^/]*/images/"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustcontain",
    "\\.html$"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustcontain",
    "\\.gif$"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustcontain",
    "/cgi-bin/prog\\?var=123123"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable urlmustnotcontain contient une expression reguliere", 
    "Variable urlmustnotcontain contains a regular expression describing"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "decrivant ce qui ne doit pas etre present dans l'url. La pseudo-regle est :", 
    "what have to be not present in the url. The rule is :"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    " si ( url==mustnotcontain1 || url==mustnotcontain2 || etc. ) ne telecharge pas", 
    " if ( url==mustnotcontain1 || url==mustnotcontain2 || etc. ) do not download"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "Une autre regle est : si l'url est dans urlmustcontain et dans", 
    "Another rule is : if url is in urlmustcontain and in"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "urlmustnotcontain, on ne la telecharge pas (urlmustnotcontain est", 
    "urlmustnotcontain, we do not download it (urlmustnotcontain is"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "prioritaire).", 
    "prioritary)."));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustnotcontain",
    "\\.mp3$"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "urlmustnotcontain",
    "http://[^/]*/private/"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable getimage indique si l'on veut telecharger", 
    "Variable getimage indicates if we want to download"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "les images (0=non, 1=oui, 2=oui_meme_a_maxrecursion)", 
    "images (0=no, 1=yes, 2=yes_even_at_maxrecursion)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "getimage",
    "2"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable getmultimedia indique si l'on veut telecharger", 
    "Variable getmultimedia indicates if we  want to download"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "les documents multimedia (0=non, 1=oui, 2=oui_meme_a_maxrecursion)", 
    "multimedia documents (0=no, 1=yes, 2=yes_even_at_maxrecursion)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "getmultimedia",
    "2"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable getcode indique si l'on veut telecharger", 
    "Variable getcode indicates if we  want to download"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "les scripts (0=non, 1=oui, 2=oui_meme_a_maxrecursion)", 
    "script code (0=no, 1=yes, 2=yes_even_at_maxrecursion)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "getcode",
    "2"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable maxfilenamelen specifie la taille maximale des noms de", 
    "Variable maxfilenamelen specifies maximum length of file/directory"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "fichier ou repertoire (recommande : 64 ; minimum : 8)", 
    "names (recommanded : 64 ; minimum : 8)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "maxfilenamelen",
    "64"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable linkconversion indique comment convertir les liens des", 
    "Variable linkconversion indicates how to convert links in files after"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "fichiers apres telechargement (0: pas de conversion, 1: faire pointer", 
    "downloading (0: no conversion, 1: point links not downloaded to the"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "les liens non telecharges vers le web, 2: faire pointer les liens non", 
    "web location, 2: point links not downloaded to the local"));
  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "telecharges vers le chemin local)", 
    "path)"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "linkconversion",
    "1"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_comment(&conffile, 
    "La variable useragent contient le nom de l'User-Agent", 
    "Variable useragent contains the name of User-Agent"));
  lcrzo_epr(shared_conffile_create_varval(&conffile, 
    "useragent", 
    "Mozilla/4.79"));
  lcrzo_epr(shared_conffile_create_emptyline(&conffile));

  lcrzo_epr(shared_conffile_create_close(&conffile));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}



