
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000366=
{ /*reference*/     "lcrzoex", 366,
  /*version*/       1, 0,
  /*title*/         "compute MD5 of a file",
  /*french title*/  "calcule le MD5 d'un fichier",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file",
  /*french usage*/  "fichier",
  /*usage example*/ "/tmp/file",
  /*fr. usage ex.*/ "/tmp/fichier",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000366_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000366_main(int argc, char *argv[])
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_string filename, hexamd5;
  lcrzo_file inputfile;
  shared_md5_context ctx;
  int ret;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000366, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_para_string_init_filein(argv[1], &filename));

#if 0
  /* this can be used for small files */
  lcrzo_epr(lcrzo_filename_read(filename, &data, &datasize));
  lcrzo_epr(shared_md5_compute_data(data, datasize, &hexamd5));
  lcrzo_epr(lcrzo_data_free2(&data));
#else
  lcrzo_epr(shared_md5_init(&ctx));
  lcrzo_epr(lcrzo_file_open_read(filename, &inputfile));
  ret=LCRZO_ERR_OK;
  while (ret==LCRZO_ERR_OK)
  { /* read from fin */
    ret=lcrzo_file_readm(&inputfile, LCRZO_WAIT_INFINITE, &data, &datasize);
    if (ret==LCRZO_ERR_OK)
    { lcrzo_epr(shared_md5_update(&ctx, data, datasize));
      lcrzo_epr(lcrzo_data_free2(&data));
    }
  }
  if (ret==LCRZO_ERR_OKDATAEND) ret=LCRZO_ERR_OK;
  lcrzo_epr(lcrzo_file_close(&inputfile));
  lcrzo_epr(shared_md5_final(&ctx, &hexamd5));
#endif
  printf("%s\n", hexamd5);

  lcrzo_er(lcrzo_string_free2(&hexamd5));
  lcrzo_er(lcrzo_string_free2(&filename));
 
  lcrzo_close();
  return(LCRZO_ERR_OK);
}
