
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000380=
{ /*reference*/     "lcrzoex", 380,
  /*version*/       1, 0,
  /*title*/         "icmp timestamp (true IP, sent at Ethernet level",
  /*french title*/  "timestamp icmp (vrai IP, envoye au niveau Ethernet)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "ipaddress [maxsentpackets]",
  /*french usage*/  "adresseip [nbmaxidepaquetsenvoyes]",
  /*usage example*/ "1.2.3.4",
  /*fr. usage ex.*/ "1.2.3.4",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000380_main(int argc, char *argv[]);
int lcrzoex_000379_ping(lcrzo_device device,
			lcrzo_etha clientetha,
			lcrzo_etha routeretha,
			lcrzo_ipl clientipl, 
			lcrzo_ipl serveripl,
			lcrzo_uint8 maxpackets);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000380_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_etha clientetha, routeretha;
  lcrzo_ipl clientipl, serveripl;
  lcrzo_uint8 maxpackets;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000380, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &serveripl));
  if ( argc>2 )
  { lcrzo_epr(lcrzo_uint8_init_text(argv[2], &maxpackets));
  }
  else
    maxpackets=0;

  /* get necessary addresses */
  lcrzo_epr(lcrzo_conf_route_to_host(serveripl,
				     device, clientetha, routeretha,
				     &clientipl, NULL));

  /* call the main function */
  lcrzo_epr(lcrzoex_000379_ping(device, clientetha, routeretha,
				clientipl, serveripl, maxpackets));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}






