
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000381=
{ /*reference*/     "lcrzoex", 381,
  /*version*/       1, 0,
  /*title*/         "icmp timestamp (true IP, sent at IP level)",
  /*french title*/  "timestamp icmp (vrai IP, envoye au niveau IP)",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "dstip [maxsentpackets]",
  /*french usage*/  "ipdst [nbmaxidepaquetsenvoyes]",
  /*usage example*/ "5.6.7.78",
  /*fr. usage ex.*/ "5.6.7.78",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000381_main(int argc, char *argv[]);
int lcrzoex_000379_ping(lcrzo_device device,
			lcrzo_etha clientetha,
			lcrzo_etha routeretha,
			lcrzo_ipl clientipl, 
			lcrzo_ipl serveripl,
			lcrzo_uint8 maxpackets);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000381_main(int argc, char *argv[])
{ lcrzo_device device;
  lcrzo_ipl clientipl, serveripl;
  lcrzo_etha ethanull;
  lcrzo_uint8 maxpackets;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000381, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &serveripl));
  if ( argc>2 )
  { lcrzo_epr(lcrzo_uint8_init_text(argv[2], &maxpackets));
  }
  else
    maxpackets=0;

  lcrzo_epr(lcrzo_conf_route_to_host_ip(serveripl, device, &clientipl, NULL));

  /* call the main function */
  lcrzo_epr(lcrzo_etha_initdefault(ethanull));
  lcrzo_epr(lcrzoex_000379_ping(device, ethanull, ethanull,
				clientipl, serveripl, maxpackets));

  lcrzo_close();
  return (LCRZO_ERR_OK);
}


