
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/* set information about this example */
shared_lcrzoex_infos lcrzoex_000410=
{ /*reference*/     "lcrzoex", 410, 
  /*version*/       1, 0, 
  /*title*/         "print Ethernet addresses of computers on a network (iplist)", 
  /*french title*/  "affiche les adresses Ethernet des machines d'un reseau (iplist)", 
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "iplist",
  /*french usage*/  "iplist", 
  /*usage example*/ "192.168.1.0/24,192.168.2.3,192.168.3.4-192.168.3.6",
  /*fr. usage ex.*/ "192.168.1.0/24,192.168.2.3,192.168.3.4-192.168.3.6",
  /*author*/        "Laurent"
};

/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000410_main(int argc, char *argv[]);
int lcrzoex_000410_main(int argc, char *argv[])
{ lcrzo_ipl ipl;
  lcrzo_etha etha;
  lcrzo_list iplist;
  int ret;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000410, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  lcrzo_er(lcrzo_iplist_init_text(argv[1], &iplist));
  lcrzo_er(lcrzo_iplist_value_first(&iplist, &ipl));
  ret=LCRZO_ERR_OK;
  while(LCRZO_TRUE)
  { lcrzo_epr(lcrzo_ipl_print("", ipl, ""));
    ret=lcrzo_etha_init_ipl(ipl, etha);
    if (ret==LCRZO_ERR_OK)
    { lcrzo_epr(lcrzo_etha_print("\t", etha, "\n"));
    }
    else
    { puts("");
    }
    ret=lcrzo_iplist_value_next(&iplist, ipl, &ipl);
    if (ret!=LCRZO_ERR_OK)
    { if (ret==LCRZO_ERR_OKDATAEND) ret=LCRZO_ERR_OK;
      break;
    }
  }
  lcrzo_epr(lcrzo_list_close(&iplist));

  lcrzo_close();
  return(ret);
}

