/*
		                 LCRZOEX
                             Network toolbox
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzoex.

  Lcrzoex is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Lcrzoex is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

#include <lcrzo.h>
#include "lcrzoex.h"
#include "shared/shared_toolbox.h"

/*-------------------------------------------------------------*/
/* include all the example code we need */
#include "lcrzoex_000401.c"
#include "lcrzoex_000402.c"
#include "lcrzoex_000403.c"
#include "lcrzoex_000404.c"
#include "lcrzoex_000405.c"
#include "lcrzoex_000406.c"
#include "lcrzoex_000407.c"
#include "lcrzoex_000408.c"
#include "lcrzoex_000409.c"
#include "lcrzoex_000410.c"


/*-------------------------------------------------------------*/
int lcrzoex__00009_main(int ac, char* av[], lcrzo_uint32 toolnumber)
{ int ret;

  switch ((int)toolnumber)
  { 
    case   401 : ret=lcrzoex_000401_main(ac, av); break;
    case   402 : ret=lcrzoex_000402_main(ac, av); break;
    case   403 : ret=lcrzoex_000403_main(ac, av); break;
    case   404 : ret=lcrzoex_000404_main(ac, av); break;
    case   405 : ret=lcrzoex_000405_main(ac, av); break;
    case   406 : ret=lcrzoex_000406_main(ac, av); break;
    case   407 : ret=lcrzoex_000407_main(ac, av); break;
    case   408 : ret=lcrzoex_000408_main(ac, av); break;
    case   409 : ret=lcrzoex_000409_main(ac, av); break;
    case   410 : ret=lcrzoex_000410_main(ac, av); break;
    default : ret=LCRZOEX_ERR_MISC_BADTOOLNUMBER;
  }

  return(ret);
}

/*-------------------------------------------------------------*/
int lcrzoex__00009_infos(lcrzo_uint32 toolnumber,
			 shared_lcrzoex_infos *pinfos)
{ shared_lcrzoex_infos infos;

  switch ((int)toolnumber)
  { case   401 : infos=lcrzoex_000401; break;
    case   402 : infos=lcrzoex_000402; break;
    case   403 : infos=lcrzoex_000403; break;
    case   404 : infos=lcrzoex_000404; break;
    case   405 : infos=lcrzoex_000405; break;
    case   406 : infos=lcrzoex_000406; break;
    case   407 : infos=lcrzoex_000407; break;
    case   408 : infos=lcrzoex_000408; break;
    case   409 : infos=lcrzoex_000409; break;
    case   410 : infos=lcrzoex_000410; break;
    default : return(LCRZOEX_ERR_MISC_BADTOOLNUMBER);
  }

  if (pinfos!=NULL) *pinfos=infos;
  return(LCRZO_ERR_OK);
}

