#ifndef LCRZOEX_CONFFILE_INCLUDED
#define LCRZOEX_CONFFILE_INCLUDED 1

/*
  Read configuration files containing data of the form :
   # comment
   var1=val      # variable="var1" ; value="val"
   var2          # variable="var2" ; value=""
   var1=val2     # variable="var1" ; value="val2"
   var3="an #x"  # variable="var3" ; value="an #x"
   var4="an\"x"  # variable="var4" ; value='an"x'
   var5="an\\x"  # variable="var5" ; value='an\x'
*/

/*-------------------------------------------------------------*/
typedef struct {
  LCRZOFILE *pfile;
} shared_conffile;

/*-------------------------------------------------------------*/
int shared_conffile_list_init(lcrzo_list *plist);
int shared_conffile_list_add_pos(lcrzo_list *plist,
				 lcrzo_int32 pos,
				 lcrzo_conststring var,
				 lcrzo_conststring val);
int shared_conffile_list_valuem_pos(lcrzo_list *plist,
				    lcrzo_int32 pos,
				    lcrzo_string *pvar,
				    lcrzo_string *pval);

/*-------------------------------------------------------------*/
int shared_conffile_list_init_file(lcrzo_conststring filename,
				   lcrzo_list *plist);


/*-------------------------------------------------------------*/
int shared_conffile_create_init(shared_conffile *pconffile,
				lcrzo_conststring filename);
int shared_conffile_create_comment(shared_conffile *pconffile,
				   lcrzo_conststring frcmt,
				   lcrzo_conststring encmt);
int shared_conffile_create_emptyline(shared_conffile *pconffile);
int shared_conffile_create_varval(shared_conffile *pconffile,
				  lcrzo_conststring var,
				  lcrzo_conststring val);
int shared_conffile_create_close(shared_conffile *pconffile);

#endif






