#ifndef LCRZOEX_FTP_INCLUDED
#define LCRZOEX_FTP_INCLUDED 1

int shared_ftp_cmd_user(lcrzo_sock *psockcontrol,
			lcrzo_conststring user);
int shared_ftp_cmd_pass(lcrzo_sock *psockcontrol,
			lcrzo_conststring pass);

int shared_ftp_cmd_quit(lcrzo_sock *psockcontrol);

int shared_ftp_cmd_port(lcrzo_sock *psockcontrol,
			lcrzo_ipl clientipl, 
			lcrzo_uint16 clientdataport);
int shared_ftp_cmd_pasv(lcrzo_sock *psockcontrol,
			lcrzo_ipl *pserveripl, 
			lcrzo_uint16 *pserverdataport);

int shared_ftp_cmd_retr(lcrzo_sock *psockcontrol,
			lcrzo_conststring file);
int shared_ftp_cmd_stor(lcrzo_sock *psockcontrol,
			lcrzo_conststring file);
int shared_ftp_cmd_dele(lcrzo_sock *psockcontrol,
			lcrzo_conststring file);

int shared_ftp_cmd_type(lcrzo_sock *psockcontrol,
			lcrzo_conststring type);
int shared_ftp_cmd_stat(lcrzo_sock *psockcontrol,
			lcrzo_conststring fileordir,
			lcrzo_list *plistfile,
			lcrzo_list *plistdir,
			lcrzo_list *plistlinkname,
			lcrzo_list *plistlinkobj);

int shared_ftp_cmd_mkd(lcrzo_sock *psockcontrol,
		       lcrzo_conststring dir);
int shared_ftp_cmd_cwd(lcrzo_sock *psockcontrol,
		       lcrzo_conststring dir);
int shared_ftp_cmd_pwd(lcrzo_sock *psockcontrol,
		       lcrzo_string *pcurrentdir);
int shared_ftp_cmd_list(lcrzo_sock *psockcontrol,
			lcrzo_conststring dir);

int shared_ftp_cmd_size(lcrzo_sock *psockcontrol,
			lcrzo_conststring file,
			lcrzo_int32 *pfilesize);

/*-------------------------------------------------------------*/
int shared_ftp_cmd_readbanner(lcrzo_sock *psockcontrol);
int shared_ftp_cmd_datasock_waitend(lcrzo_sock *psockcontrol);

int shared_ftp_cmd_type_ascii(lcrzo_sock *psockcontrol);
int shared_ftp_cmd_type_bin(lcrzo_sock *psockcontrol);

/*-------------------------------------------------------------*/
int shared_ftp_login(lcrzo_sock *psockcontrol,
		     lcrzo_conststring user,
		     lcrzo_conststring pass);
int shared_ftp_login_anonymous(lcrzo_sock *psockcontrol);

/*-------------------------------------------------------------*/
int shared_ftp_data_list(lcrzo_sock *psockcontrol,
			 lcrzo_bool usesockdata,
			 lcrzo_sock *psockdata,
			 lcrzo_ipc *pipcdata,
			 lcrzo_conststring fileordir,
			 lcrzo_list *plistfile,
			 lcrzo_list *plistdir,
       lcrzo_list *plistlinkname,
 			 lcrzo_list *plistlinkobj);
int shared_ftp_data_retr(lcrzo_sock *psockcontrol,
			 lcrzo_bool usesockdata,
			 lcrzo_sock *psockdata,
			 lcrzo_ipc *pipcdata,
			 lcrzo_conststring distantfilename,
			 lcrzo_conststring localfilename);
int shared_ftp_data_stor(lcrzo_sock *psockcontrol,
			 lcrzo_bool usesockdata,
			 lcrzo_sock *psockdata,
			 lcrzo_ipc *pipcdata,
			 lcrzo_conststring localfilename,
			 lcrzo_conststring distantfilename);

/*-------------------------------------------------------------*/
int shared_ftp_file_typesize(lcrzo_sock *psockcontrol,
			     lcrzo_conststring file,
			     lcrzo_bool *pisfile,
			     lcrzo_bool *pisdir,
			     lcrzo_bool *pislink,
			     lcrzo_int32 *pfilesize);

#endif
