#ifndef LCRZOEX_HTTP_INCLUDED
#define LCRZOEX_HTTP_INCLUDED 1

/*-------------------------------------------------------------*/
/* the default resolver timeout is too short if it's long to reach
   webserver's DNS */
int shared_http_set_resolver_timeout(void);

/*-------------------------------------------------------------*/
int shared_http_initm_methurlhttpver(lcrzo_conststring method,
				     lcrzo_conststring url,
				     lcrzo_conststring version,
				     lcrzo_data *pdata,
				     lcrzo_int32 *pdatasize);

int shared_http_appendm_hostport(lcrzo_conststring hostname,
				 lcrzo_uint16 port,
				 lcrzo_int32 datacurrentsize,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);

int shared_http_appendm_ipport(lcrzo_ipl ip,
			       lcrzo_uint16 port,
			       lcrzo_int32 datacurrentsize,
			       lcrzo_data *pdata,
			       lcrzo_int32 *pdatasize);

int shared_http_appendm_authbasiclogpass(lcrzo_conststring login,
					 lcrzo_conststring passwd,
					 lcrzo_int32 datacurrentsize,
					 lcrzo_data *pdata,
					 lcrzo_int32 *pdatasize);
int shared_http_appendm_proxyauthbasiclogpass(lcrzo_conststring login,
					      lcrzo_conststring passwd,
					      lcrzo_int32 datacurrentsize,
					      lcrzo_data *pdata,
					      lcrzo_int32 *pdatasize);

/*-------------------------------------------------------------*/
int shared_http_initm_httpvererr(lcrzo_conststring version,
				 lcrzo_uint16 errorcode,
				 lcrzo_conststring errorstring,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);
int shared_http_appendm_connection(lcrzo_conststring type,
				   lcrzo_int32 datacurrentsize,
				   lcrzo_data *pdata,
				   lcrzo_int32 *pdatasize);
int shared_http_appendm_contenttype(lcrzo_conststring type,
				    lcrzo_int32 datacurrentsize,
				    lcrzo_data *pdata,
				    lcrzo_int32 *pdatasize);
int shared_http_appendm_wwwauth(lcrzo_conststring realm,
				lcrzo_int32 datacurrentsize,
				lcrzo_data *pdata,
				lcrzo_int32 *pdatasize);
int shared_http_appendm_location(lcrzo_conststring loc,
				 lcrzo_int32 datacurrentsize,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);
int shared_http_appendm_useragent(lcrzo_conststring useragent,
				  lcrzo_int32 datacurrentsize,
				  lcrzo_data *pdata,
				  lcrzo_int32 *pdatasize);

/*-------------------------------------------------------------*/
int shared_http_request_get(lcrzo_sock *psock,
			    lcrzo_conststring url,
			    lcrzo_conststring hostname,
			    lcrzo_uint16 port,
			    lcrzo_conststring proxylogin,
			    lcrzo_conststring proxypasswd,
			    lcrzo_conststring sitelogin,
			    lcrzo_conststring sitepasswd);
int shared_http_request_get2(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring proxylogin,
			     lcrzo_conststring proxypasswd,
			     lcrzo_conststring sitelogin,
			     lcrzo_conststring sitepasswd,
			     lcrzo_conststring useragent);

int shared_http_request_post(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring proxylogin,
			     lcrzo_conststring proxypasswd,
			     lcrzo_conststring sitelogin,
			     lcrzo_conststring sitepasswd,
			     lcrzo_conststring parameters);

int shared_http_request_head(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring proxylogin,
			     lcrzo_conststring proxypasswd,
			     lcrzo_conststring sitelogin,
			     lcrzo_conststring sitepasswd);

int shared_http_request_put(lcrzo_sock *psock,
			    lcrzo_conststring url,
			    lcrzo_conststring hostname,
			    lcrzo_uint16 port,
			    lcrzo_conststring proxylogin,
			    lcrzo_conststring proxypasswd,
			    lcrzo_conststring sitelogin,
			    lcrzo_conststring sitepasswd,
			    lcrzo_data filedata,
			    lcrzo_int32 filedatasize);

int shared_http_request_delete(lcrzo_sock *psock,
			       lcrzo_conststring url,
			       lcrzo_conststring hostname,
			       lcrzo_uint16 port,
			       lcrzo_conststring proxylogin,
			       lcrzo_conststring proxypasswd,
			       lcrzo_conststring sitelogin,
			       lcrzo_conststring sitepasswd);

/*-------------------------------------------------------------*/
int shared_http_request_readheader(lcrzo_sock *psock,
				   lcrzo_time *pmaxwaitingtime,
				   lcrzo_string *pmethod,
				   lcrzo_string *purl,
				   lcrzo_string *pversion,
				   lcrzo_string *phost,
				   lcrzo_string *puseragent,
				   lcrzo_string *pproxylogin,
				   lcrzo_string *pproxypasswd,
				   lcrzo_string *psitelogin,
				   lcrzo_string *psitepasswd,
				   lcrzo_int32 *pcontentlength,
				   lcrzo_data *pheader,
				   lcrzo_int32 *pheadersize);
int shared_http_response_readheader(lcrzo_sock *psock,
				    lcrzo_uint16 *perrorcode,
				    lcrzo_string *perrormsg,
				    lcrzo_string *pservertype,
				    lcrzo_string *pcontenttype,
				    lcrzo_int32 *pcontentlenght,
				    lcrzo_string *plocation,
				    lcrzo_data *pheader,
				    lcrzo_int32 *pheadersize);

int shared_http_response_readbody(lcrzo_sock *psock,
				  lcrzo_time *pmaxwaitingtime,
				  lcrzo_int32 contentlength,
				  lcrzo_data *pbody,
				  lcrzo_int32 *pbodysize);

/*-------------------------------------------------------------*/
int shared_http_set_proxysite_userpass(int argc, 
				       char *argv[],
				       int startat,
				       lcrzo_string *pproxyuser, 
				       lcrzo_string *pproxypasswd, 
				       lcrzo_string *psiteuser,
				       lcrzo_string *psitepasswd);

/*-------------------------------------------------------------*/
#define SHARED_HTTP_ERRORCODE_OK                  200
#define SHARED_HTTP_ERRORCODE_CREATED             201
#define SHARED_HTTP_ERRORCODE_ACCEPTED            202
#define SHARED_HTTP_ERRORCODE_NOCONTENT           204
#define SHARED_HTTP_ERRORCODE_MOVEDPERMANENTLY    301
#define SHARED_HTTP_ERRORCODE_MOVEDTEMPORARILY    302
#define SHARED_HTTP_ERRORCODE_NOTMODIFIED         304
#define SHARED_HTTP_ERRORCODE_BADREQUEST          400
#define SHARED_HTTP_ERRORCODE_UNAUTHORIZED        401
#define SHARED_HTTP_ERRORCODE_FORBIDDEN           403
#define SHARED_HTTP_ERRORCODE_NOTFOUND            404
#define SHARED_HTTP_ERRORCODE_INTERNALSERVERERROR 500
#define SHARED_HTTP_ERRORCODE_NOTIMPLEMENTED      501
#define SHARED_HTTP_ERRORCODE_BADGATEWAY          502
#define SHARED_HTTP_ERRORCODE_SERVICEUNAVAILABLE  503

/*-------------------------------------------------------------*/
int shared_http_url_download_file(lcrzo_conststring siteurl, 
				  lcrzo_conststring proxyurl, 
				  lcrzo_uint16 *perrorcode,
				  lcrzo_conststring localfile);
int shared_http_url_download_file2(lcrzo_conststring siteurl, 
				   lcrzo_conststring proxyurl, 
				   lcrzo_conststring useragent, 
				   lcrzo_uint16 *perrorcode,
				   lcrzo_conststring localfile);

/*-------------------------------------------------------------*/
#define SHARED_HTTP_LINK_CONTAIN_HTML        0x01
#define SHARED_HTTP_LINK_CONTAIN_IMAGE       0x02
#define SHARED_HTTP_LINK_CONTAIN_MULTIMEDIA  0x04
#define SHARED_HTTP_LINK_CONTAIN_CODE        0x08
#define SHARED_HTTP_LINK_CONTAIN_REFERENCE   0x10

/*-------------------------------------------------------------*/
#define SHARED_HTTP_LINK_FORMAT_URL          0x01
#define SHARED_HTTP_LINK_FORMAT_URLLISTSPACE 0x02
#define SHARED_HTTP_LINK_FORMAT_URLLISTCOMMA 0x04
#define SHARED_HTTP_LINK_FORMAT_REFRESHURL   0x08

/*-------------------------------------------------------------*/
/* Various link types from :
    - HTML 3.2
    - HTML 4.01
    - http://msdn.microsoft.com/workshop/author/html/reference/elements.asp
    - http://developer.netscape.com/docs/manuals/htmlguid/contents.htm
 */
#define SHARED_HTTP_LINKTYPE_BEGIN              1
#define SHARED_HTTP_LINKTYPE_A_HREF             1
#define SHARED_HTTP_LINKTYPE_APPLET_ARCHIVE     2
#define SHARED_HTTP_LINKTYPE_APPLET_CODE        3
#define SHARED_HTTP_LINKTYPE_APPLET_CODEBASE    4
#define SHARED_HTTP_LINKTYPE_AREA_HREF          5
#define SHARED_HTTP_LINKTYPE_BASE_HREF          6
#define SHARED_HTTP_LINKTYPE_BGSOUND_SRC        7
#define SHARED_HTTP_LINKTYPE_BLOCKQUOTE_CITE    8
#define SHARED_HTTP_LINKTYPE_BODY_BACKGROUND    9
#define SHARED_HTTP_LINKTYPE_DEL_CITE          10
#define SHARED_HTTP_LINKTYPE_EMBED_PLUGINSPAGE 11
#define SHARED_HTTP_LINKTYPE_EMBED_SRC         12
#define SHARED_HTTP_LINKTYPE_EMBED_HREF        13
#define SHARED_HTTP_LINKTYPE_FIG_IMAGEMAP      14
#define SHARED_HTTP_LINKTYPE_FIG_SRC           15
#define SHARED_HTTP_LINKTYPE_FORM_ACTION       16
#define SHARED_HTTP_LINKTYPE_FRAME_LONGDESC    17
#define SHARED_HTTP_LINKTYPE_FRAME_SRC         18
#define SHARED_HTTP_LINKTYPE_HEAD_PROFILE      19
#define SHARED_HTTP_LINKTYPE_IFRAME_LONGDESC   20
#define SHARED_HTTP_LINKTYPE_IFRAME_SRC        21
#define SHARED_HTTP_LINKTYPE_ILAYER_BACKGROUND 22
#define SHARED_HTTP_LINKTYPE_ILAYER_SRC        23
#define SHARED_HTTP_LINKTYPE_IMG_DYNSRC        24
#define SHARED_HTTP_LINKTYPE_IMG_LONGDESC      25
#define SHARED_HTTP_LINKTYPE_IMG_LOWSRC        26
#define SHARED_HTTP_LINKTYPE_IMG_SRC           27
#define SHARED_HTTP_LINKTYPE_IMG_USEMAP        28
#define SHARED_HTTP_LINKTYPE_INPUT_SRC         29
#define SHARED_HTTP_LINKTYPE_INPUT_USEMAP      30
#define SHARED_HTTP_LINKTYPE_INS_CITE          31
#define SHARED_HTTP_LINKTYPE_LAYER_BACKGROUND  32
#define SHARED_HTTP_LINKTYPE_LAYER_SRC         33
#define SHARED_HTTP_LINKTYPE_LINK_HREF         34
#define SHARED_HTTP_LINKTYPE_META_CONTENT      35
#define SHARED_HTTP_LINKTYPE_OBJECT_ARCHIVE    36
#define SHARED_HTTP_LINKTYPE_OBJECT_CLASSID    37
#define SHARED_HTTP_LINKTYPE_OBJECT_CODEBASE   38
#define SHARED_HTTP_LINKTYPE_OBJECT_DATA       39
#define SHARED_HTTP_LINKTYPE_OBJECT_USEMAP     40
#define SHARED_HTTP_LINKTYPE_OVERLAY_IMAGEMAP  41
#define SHARED_HTTP_LINKTYPE_OVERLAY_SRC       42
#define SHARED_HTTP_LINKTYPE_Q_CITE            43
#define SHARED_HTTP_LINKTYPE_SCRIPT_FOR        44
#define SHARED_HTTP_LINKTYPE_SCRIPT_SRC        45
#define SHARED_HTTP_LINKTYPE_SELECT_SRC        46
#define SHARED_HTTP_LINKTYPE_TABLE_BACKGROUND  47
#define SHARED_HTTP_LINKTYPE_TD_BACKGROUND     48
#define SHARED_HTTP_LINKTYPE_TH_BACKGROUND     49
#define SHARED_HTTP_LINKTYPE_TR_BACKGROUND     50
#define SHARED_HTTP_LINKTYPE_XML_SRC           51
#define SHARED_HTTP_LINKTYPE_END               51

/*-------------------------------------------------------------*/
int shared_http_linktype_get_tag(lcrzo_uint32 linktype,
				 lcrzo_string *ptag);
int shared_http_linktype_get_para(lcrzo_uint32 linktype,
				  lcrzo_string *ppara);
int shared_http_linktype_get_contain(lcrzo_uint32 linktype,
				     lcrzo_uint16 *pcontain);
int shared_http_linktype_get_format(lcrzo_uint32 linktype,
				    lcrzo_uint16 *pformat);

/*-------------------------------------------------------------*/
int shared_http_urllist_init(lcrzo_list *plist);
int shared_http_urllist_add_pos(lcrzo_list *plist,
				lcrzo_int32 pos,
				lcrzo_uint32 type,
				lcrzo_conststring url,
				lcrzo_int32 startpos,
				lcrzo_int32 endpos,
				lcrzo_uint32 refresh);
int shared_http_urllist_valuem_pos(lcrzo_list *plist,
				   lcrzo_int32 pos,
				   lcrzo_uint32 *ptype,
				   lcrzo_string *purl,
				   lcrzo_int32 *pstartpos,
				   lcrzo_int32 *pendpos,
				   lcrzo_uint32 *prefresh);

/*-------------------------------------------------------------*/
int shared_http_urllist_init_file(lcrzo_conststring filename,
				  lcrzo_list *purllist);

/*-------------------------------------------------------------*/
/* pt means percenttext "%XX" */
/* encode nothing */
#define SHARED_HTTP_PT_TYPE_ENCODENONE   1
/* encode everything */
#define SHARED_HTTP_PT_TYPE_ENCODEALL    2
/* 0-9a-zA-Z_.- and / are not encoded */
#define SHARED_HTTP_PT_TYPE_PATH        11
/* 0-9a-zA-Z_.- and =& are not encoded */
#define SHARED_HTTP_PT_TYPE_VARVAL      12
/* 0-9a-zA-Z_.- are not encoded */
#define SHARED_HTTP_PT_TYPE_ANCHOR      13
/* 0-9a-zA-Z are not encoded */
#define SHARED_HTTP_PT_TYPE_LOGPWD      14
int shared_http_pt_initm_data(lcrzo_constdata data,
			      lcrzo_int32 datasize,
			      lcrzo_uint16 pttype,
			      lcrzo_string *ptextwithpercent);
int shared_http_pt_initm_string(lcrzo_conststring str,
				lcrzo_uint16 pttype,
				lcrzo_string *ptextwithpercent);

int shared_http_data_initm_pt(lcrzo_conststring textwithpercent,
			      lcrzo_data *pdata,
			      lcrzo_int32 *pdatasize);
int shared_http_string_initm_pt(lcrzo_conststring textwithpercent,
				lcrzo_string *pstr);

int shared_http_pt_initm_pt(lcrzo_conststring textwithpercent,
			    lcrzo_uint16 pttype,
			    lcrzo_string *ptextwithpercent);

/*-------------------------------------------------------------*/
/* html encoded (&amp;, &#34;, etc.) */
int shared_http_string_initm_he(lcrzo_conststring texthtmlencoded,
				lcrzo_string *pstr);
int shared_http_he_initm_string(lcrzo_conststring str,
				lcrzo_string *ptexthtmlencoded);

/*-------------------------------------------------------------*/
/*
 url : http://u:p@s:80/a/b%20/c?t=u&v=%4Fw
 dp(distantpath) : [.|..]/a/b%20/c?t=u&v=%4Fw
 dpurl : url or dp
 alp(absolutelocalpath) : http_3A/
 rlp(relativelocalpath) : ../dir/...

Note : we recognize and create HTTP and FTP(except type) urls (rfc 1738)
 */

/*
  http://server/          <-> user=NULL  passwd=NULL
  http://u:p@server/      <-> user="u"   passwd="p"
  http://u:@server/       <-> user="u"   passwd=""
  http://:@server/        <-> user=""    passwd=""
  http://u@server/        <-> user="u"   passwd=NULL (may ask it using a form)
  http://@server/         <-> user=""    passwd=NULL
*/

int shared_http_url_init(lcrzo_conststring proto,
			 lcrzo_conststring user,
			 lcrzo_conststring password,
			 lcrzo_conststring server,
			 lcrzo_uint16 port,
			 lcrzo_conststring path,
			 lcrzo_conststring ptvarval,
			 lcrzo_conststring anchor,
			 lcrzo_string *purl);
int shared_http_dp_init(lcrzo_conststring path,
			lcrzo_conststring ptvarval,
			lcrzo_conststring anchor,
			lcrzo_string *pdp);
int shared_http_varval_init(lcrzo_conststring var,
                            lcrzo_constdata val,
			    lcrzo_int32 valsize,
			    lcrzo_string *pptvarval);

/*-------------------------------------------------------------*/
int shared_http_dpurl_isurl(lcrzo_conststring dpurl,
			    lcrzo_bool *pyes);
int shared_http_dpurl_isurl_http(lcrzo_conststring dpurl,
				 lcrzo_bool *pyes);
int shared_http_dpurl_isurl_ftp(lcrzo_conststring dpurl,
				lcrzo_bool *pyes);
int shared_http_dpurl_isdp(lcrzo_conststring dpurl,
			   lcrzo_bool *pyes);

/*-------------------------------------------------------------*/
int shared_http_url_decode(lcrzo_conststring url,
			   lcrzo_string *pproto,
			   lcrzo_string *puser,
			   lcrzo_string *ppassword,
			   lcrzo_string *pserver,
			   lcrzo_uint16 *pport,
			   lcrzo_string *ppath,
			   lcrzo_string *pptvarval,
			   lcrzo_string *panchor);
int shared_http_dp_decode(lcrzo_conststring dp,
			  lcrzo_string *ppath,
			  lcrzo_string *pptvarval,
			  lcrzo_string *panchor);
int shared_http_varval_decode(lcrzo_conststring ptvarval,
			      lcrzo_conststring var,
			      lcrzo_data *pval,
			      lcrzo_int32 *pvalsize);

/*-------------------------------------------------------------*/
int shared_http_url_init_url(lcrzo_conststring url,
			     lcrzo_string *purl);
int shared_http_url_init_dp(lcrzo_conststring urlwheredpwasfound,
			    lcrzo_conststring dp,
			    lcrzo_string *purl);
int shared_http_url_init_dpurl(lcrzo_conststring urlwheredpurlwasfound,
			       lcrzo_conststring dpurl,
			       lcrzo_string *purl);
int shared_http_url_init_alp(lcrzo_conststring alp,
			     lcrzo_string *purl);
int shared_http_url_init_rlp(lcrzo_conststring alpwhererlpwasfound,
			     lcrzo_conststring rlp,
			     lcrzo_string *purl);

/*-------------------------------------------------------------*/
int shared_http_dp_init_dp(lcrzo_conststring urlwheredpwasfound,
			   lcrzo_conststring dp,
			   lcrzo_conststring urlwhichwillcontaindp,
			   lcrzo_string *pdp);
int shared_http_dp_init_url(lcrzo_conststring url,
			    lcrzo_conststring urlwhichwillcontaindp,
			    lcrzo_string *pdp);
int shared_http_dp_init_dpurl(lcrzo_conststring urlwheredpurlwasfound,
			      lcrzo_conststring dpurl,
			      lcrzo_conststring urlwhichwillcontaindp,
			      lcrzo_string *pdp);
int shared_http_dp_init_alp(lcrzo_conststring alp,
			    lcrzo_conststring urlwhichwillcontaindp,
			    lcrzo_string *pdp);
int shared_http_dp_init_rlp(lcrzo_conststring alpwhererlpwasfound,
			    lcrzo_conststring rlp,
			    lcrzo_conststring urlwhichwillcontaindp,
			    lcrzo_string *pdp);

/*-------------------------------------------------------------*/
int shared_http_alp_init_alp(lcrzo_conststring alp,
			     lcrzo_uint16 maxfilenamelen,
			     lcrzo_string *palp);
int shared_http_alp_init_url(lcrzo_conststring url,
			     lcrzo_uint16 maxfilenamelen,
			     lcrzo_string *palp);
int shared_http_alp_init_dp(lcrzo_conststring urlwheredpwasfound,
			    lcrzo_conststring dp,
			    lcrzo_uint16 maxfilenamelen,
			    lcrzo_string *palp);
int shared_http_alp_init_dpurl(lcrzo_conststring urlwheredpurlwasfound,
			       lcrzo_conststring dpurl,
			       lcrzo_uint16 maxfilenamelen,
			       lcrzo_string *palp);
int shared_http_alp_init_rlp(lcrzo_conststring alpwhererlpwasfound,
			     lcrzo_conststring rlp,
			     lcrzo_string *palp);

/*-------------------------------------------------------------*/
int shared_http_rlp_init_rlp(lcrzo_conststring alpwhererlpwasfound,
			     lcrzo_conststring rlp,
			     lcrzo_conststring alpwhichwillcontainrlp,
			     lcrzo_uint16 maxfilenamelen,
			     lcrzo_string *prlp);
int shared_http_rlp_init_dp(lcrzo_conststring urlwheredpwasfound,
			    lcrzo_conststring dp,
			    lcrzo_conststring alpwhichwillcontainrlp,
			    lcrzo_uint16 maxfilenamelen,
			    lcrzo_string *prlp);
int shared_http_rlp_init_url(lcrzo_conststring url,
			     lcrzo_conststring alpwhichwillcontainrlp,
			     lcrzo_uint16 maxfilenamelen,
			     lcrzo_string *prlp);
int shared_http_rlp_init_dpurl(lcrzo_conststring urlwheredpurlwasfound,
			       lcrzo_conststring dpurl,
			       lcrzo_conststring alpwhichwillcontainrlp,
			       lcrzo_uint16 maxfilenamelen,
			       lcrzo_string *prlp);
int shared_http_rlp_init_alp(lcrzo_conststring alp,
			     lcrzo_conststring alpwhichwillcontainrlp,
			     lcrzo_string *prlp);

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_string proxyurl;
  lcrzo_string localrootdir;
  lcrzo_string useragent;
  lcrzo_list listurltodownload;
  lcrzo_uint32 maxrecursion;
  lcrzo_uint32 currentrecursionlevel;
  lcrzo_uint32 millisleep;
  lcrzo_list listurlmustcontain;
  lcrzo_list listurlmustnotcontain;
  lcrzo_uint16 getimage;
  lcrzo_uint16 getmultimedia;
  lcrzo_uint16 getcode;
  lcrzo_uint16 maxfilenamelen;
  lcrzo_uint16 linkconversion;
  lcrzo_bool lastisarecurmarker;
  lcrzo_file logfile;
  lcrzo_bool logfileinitialized;
} shared_http_spider;

/* Note : currently, this spider does not support :
    - cookies
    - SHARED_HTTP_LINK_FORMAT_URLLISTSPACE (<object archive=...>)
    - SHARED_HTTP_LINK_FORMAT_URLLISTCOMMA (<applet archive=...>)    
    - IMG ISMAP (<a href="t"><img src=u ismap></A>)
    - POST form with its variables
    - Javascript/VBscript (to search new urls)
 */

int shared_http_spider_initdefault(shared_http_spider *pspider);
int shared_http_spider_set_proxyurl(shared_http_spider *pspider,
				    lcrzo_conststring proxyurl);
int shared_http_spider_set_localrootdir(shared_http_spider *pspider,
					lcrzo_conststring localrootdir);
int shared_http_spider_set_useragent(shared_http_spider *pspider,
				     lcrzo_conststring useragent);
int shared_http_spider_set_maxrecursion(shared_http_spider *pspider,
					lcrzo_uint32 maxrecursion);
int shared_http_spider_set_millisleep(shared_http_spider *pspider,
				      lcrzo_uint32 millisleep);
int shared_http_spider_set_getimage(shared_http_spider *pspider,
				    lcrzo_uint16 getimage);
int shared_http_spider_set_getmultimedia(shared_http_spider *pspider,
					 lcrzo_uint16 getmultimedia);
int shared_http_spider_set_getcode(shared_http_spider *pspider,
				   lcrzo_uint16 getcode);
int shared_http_spider_set_maxfilenamelen(shared_http_spider *pspider,
					  lcrzo_uint16 maxfilenamelen);
int shared_http_spider_set_linkconversion(shared_http_spider *pspider,
					  lcrzo_uint16 linkconversion);
int shared_http_spider_add_urltodownload(shared_http_spider *pspider,
					 lcrzo_uint32 linktype,
					 lcrzo_conststring url);
int shared_http_spider_add_urlmustcontain(shared_http_spider *pspider,
					  lcrzo_conststring urlmustcontain);
int shared_http_spider_add_urlmustnotcontain(shared_http_spider *pspider,
					 lcrzo_conststring urlmustnotcontain);

int shared_http_spider_init_conffile(shared_http_spider *pspider,
				     lcrzo_conststring conffile);

int shared_http_spider_run(shared_http_spider *pspider);

int shared_http_spider_linkconversion(shared_http_spider *pspider);

int shared_http_spider_close(shared_http_spider *pspider);

#endif


