#ifndef LCRZOEX_LCRZOEX_INCLUDED
#define LCRZOEX_LCRZOEX_INCLUDED 1

/*-------------------------------------------------------------*/
typedef struct
{ lcrzo_conststring refname;
  lcrzo_uint32      refvalue;
  lcrzo_uint8       majorversion;
  lcrzo_uint8       minorversion;
  lcrzo_conststring title_en;
  lcrzo_conststring title_fr;
  lcrzo_conststring description_en;
  lcrzo_conststring description_fr;
  lcrzo_conststring usage_en;
  lcrzo_conststring usage_fr;
  lcrzo_conststring usageex_en;
  lcrzo_conststring usageex_fr;
  lcrzo_conststring author;
} shared_lcrzoex_infos;

/*en print information about an tool */
/*fr affiche les informations sur un outil */
int shared_lcrzoex_infos_fprint(LCRZOFILE *pf,
				shared_lcrzoex_infos infos,
				lcrzo_conststring progname);
#define shared_lcrzoex_infos_print(i,p) shared_lcrzoex_infos_fprint(stdout,i,p)
int shared_lcrzoex_infos_noadmcheck_fprint(LCRZOFILE *pf,
					   shared_lcrzoex_infos infos,
					   lcrzo_conststring progname);
#define shared_lcrzoex_infos_noadmcheck_print(i,p) shared_lcrzoex_infos_noadmcheck_fprint(stdout,i,p)

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_PROCESSOTHEREXIT_WARN==1
 /* This function is only used in debugging mode.
    You can ignore it. */
 int shared_lcrzoex_debug_processotherexit_wanttowarn(lcrzo_bool yes);
#else
 #define shared_lcrzoex_debug_processotherexit_wanttowarn(a) LCRZO_ERR_OK;
#endif

/*-------------------------------------------------------------*/
int shared_lcrzoex_err_print(int ret);

#endif
