#ifndef LCRZOEX_MD5_INCLUDED
#define LCRZOEX_MD5_INCLUDED 1

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_uint32 buf[4];
  lcrzo_uint32 bits[2];
  lcrzo_uint8 in[64];
} shared_md5_context;

/*-------------------------------------------------------------*/
int shared_md5_init(shared_md5_context *pcontext);
int shared_md5_update(shared_md5_context *pcontext,
		      lcrzo_constdata data,
		      lcrzo_int32 datasize);
int shared_md5_update_text(shared_md5_context *pcontext,
			   lcrzo_conststring str);
int shared_md5_final(shared_md5_context *pcontext,
		     lcrzo_string *phexamd5);

/*-------------------------------------------------------------*/
int shared_md5_compute_data(lcrzo_constdata data,
			    lcrzo_int32 datasize,
			    lcrzo_string *phexamd5);
int shared_md5_compute_string(lcrzo_conststring str,
			      lcrzo_string *phexamd5);

#endif

