/*
		                 LCRZOEX
                             Network toolbox
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzoex.

  Lcrzoex is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Lcrzoex is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

#include <lcrzo.h>
#include "../lcrzoex.h"

/*-------------------------------------------------------------*/
int shared_record_exact_initdefault(shared_record_exact *psre)
{
  psre->pspoof=NULL;
  psre->pspoofdev=NULL;
  psre->paddhdreth=NULL;
  psre->paddhdrip=NULL;
  psre->paddhdrudp=NULL;
  psre->paddhdrtcp=NULL;
  psre->paddhdricmp=NULL;
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_exact_eth_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos)
{ shared_record_exact *psre=(shared_record_exact *)pinfos;

  if (psre==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoofdev==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->paddhdreth!=NULL)
  { puts("psre->paddhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psre->paddhdrip!=NULL)
  { puts("psre->paddhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  
  /*spoof*/
  lcrzo_epr(lcrzo_spoof_eth(psre->pspoof, *(psre->pspoofdev),
			    (lcrzo_constdata)data, (lcrzo_uint16)datasize));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_exact_ip_spoof(lcrzo_ptr data,
				 lcrzo_int32 datasize,
				 lcrzo_ptr pinfos)
{ shared_record_exact *psre=(shared_record_exact *)pinfos;

  if (psre==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->paddhdrip!=NULL)
  { puts("psre->paddhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /*spoof*/
  if ( psre->paddhdreth!=NULL && psre->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethdata(psre->pspoof, *(psre->pspoofdev),
				  *(psre->paddhdreth), 
				  (lcrzo_constdata)data,
				  (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ip(psre->pspoof, (lcrzo_constdata)data,
			     (lcrzo_uint16)datasize));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_exact_udp_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos)
{ shared_record_exact *psre=(shared_record_exact *)pinfos;

  if (psre==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);

  /*spoof*/
  if ( psre->paddhdreth!=NULL && psre->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethipoptdata(psre->pspoof, *(psre->pspoofdev),
				       *(psre->paddhdreth), 
				       *(psre->paddhdrip), NULL, 0,
				       (lcrzo_constdata)data, 
				       (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ipoptdata(psre->pspoof,
				    *(psre->paddhdrip), NULL, 0,
				    (lcrzo_constdata)data, 
				    (lcrzo_uint16)datasize));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_exact_tcp_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos)
{ shared_record_exact *psre=(shared_record_exact *)pinfos;

  if (psre==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);

  /*spoof*/
  if ( psre->paddhdreth!=NULL && psre->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethipoptdata(psre->pspoof, *(psre->pspoofdev),
				       *(psre->paddhdreth), 
				       *(psre->paddhdrip), NULL, 0,
				       (lcrzo_constdata)data, 
				       (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ipoptdata(psre->pspoof,
				    *(psre->paddhdrip), NULL, 0,
				    (lcrzo_constdata)data, 
				    (lcrzo_uint16)datasize));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_exact_icmp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_exact *psre=(shared_record_exact *)pinfos;

  if (psre==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);

  /*spoof*/
  if ( psre->paddhdreth!=NULL && psre->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethipoptdata(psre->pspoof, *(psre->pspoofdev),
				       *(psre->paddhdreth), 
				       *(psre->paddhdrip), NULL, 0,
				       (lcrzo_constdata)data, 
				       (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ipoptdata(psre->pspoof,
				    *(psre->paddhdrip), NULL, 0,
				    (lcrzo_constdata)data,
				    (lcrzo_uint16) datasize));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_exact_data_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_exact *psre=(shared_record_exact *)pinfos;

  if (psre==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psre->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);

  /*spoof*/
  if ( psre->paddhdreth!=NULL && psre->pspoofdev!=NULL )
  { if ( psre->paddhdrip!=NULL && psre->paddhdrudp!=NULL )
    { lcrzo_epr(lcrzo_spoof_ethipoptudpdata(psre->pspoof, *(psre->pspoofdev),
					    *(psre->paddhdreth), 
					    *(psre->paddhdrip), NULL, 0,
					    *(psre->paddhdrudp), 
					    (lcrzo_constdata)data,
					    (lcrzo_uint16)datasize));
    }
    else if ( psre->paddhdrip!=NULL && psre->paddhdrtcp!=NULL )
    { lcrzo_epr(lcrzo_spoof_ethipopttcpoptdata(psre->pspoof,
					       *(psre->pspoofdev),
					       *(psre->paddhdreth), 
					       *(psre->paddhdrip), NULL, 0,
					       *(psre->paddhdrtcp), NULL, 0,
					       (lcrzo_constdata)data,
					       (lcrzo_uint16)datasize));
    }
    else if ( psre->paddhdrip!=NULL && psre->paddhdricmp!=NULL )
    { lcrzo_epr(lcrzo_spoof_ethipopticmpdata(psre->pspoof, *(psre->pspoofdev),
					     *(psre->paddhdreth), 
					     *(psre->paddhdrip), NULL, 0,
					     *(psre->paddhdricmp), 
					     (lcrzo_constdata)data,
					     (lcrzo_uint16)datasize));
    }
    else if ( psre->paddhdrip!=NULL )
    { lcrzo_epr(lcrzo_spoof_ethipoptdata(psre->pspoof, *(psre->pspoofdev),
					 *(psre->paddhdreth), 
					 *(psre->paddhdrip), NULL, 0,
					 (lcrzo_constdata)data,
					 (lcrzo_uint16)datasize));
    }
    else
    { lcrzo_epr(lcrzo_spoof_ethdata(psre->pspoof, *(psre->pspoofdev),
				    *(psre->paddhdreth), 
				    (lcrzo_constdata)data, 
				    (lcrzo_uint16)datasize));
    }
  }
  else
  { if ( psre->paddhdrip==NULL ) return(LCRZO_ERR_PANULLPTR);
    if (psre->paddhdrudp!=NULL)
    { lcrzo_epr(lcrzo_spoof_ipoptudpdata(psre->pspoof, 
					 *(psre->paddhdrip), NULL, 0,
					 *(psre->paddhdrudp), 
					 (lcrzo_constdata)data, 
					 (lcrzo_uint16)datasize));
    }
    else if (psre->paddhdrtcp!=NULL)
    { lcrzo_epr(lcrzo_spoof_ipopttcpoptdata(psre->pspoof,
					    *(psre->paddhdrip), NULL, 0,
					    *(psre->paddhdrtcp), NULL, 0,
					    (lcrzo_constdata)data, 
					    (lcrzo_uint16)datasize));
    }
    else if (psre->paddhdricmp!=NULL)
    { lcrzo_epr(lcrzo_spoof_ipopticmpdata(psre->pspoof, 
					  *(psre->paddhdrip), NULL, 0,
					  *(psre->paddhdricmp), 
					  (lcrzo_constdata)data, 
					  (lcrzo_uint16)datasize));
    }
    else 
    { lcrzo_epr(lcrzo_spoof_ipoptdata(psre->pspoof,
				      *(psre->paddhdrip), NULL, 0,
				      (lcrzo_constdata)data, 
				      (lcrzo_uint16)datasize));
    }
  }

  return (LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int shared_record_addmod_initdefault(shared_record_addmod *psram)
{
  psram->pspoof=NULL;
  psram->pspoofdev=NULL;
  psram->paddhdreth=NULL;
  psram->paddhdrip=NULL;
  psram->pmodhdreth=NULL;
  psram->pmodhdrip=NULL;
  psram->pmodhdrudp=NULL;
  psram->pmodhdrtcp=NULL;
  psram->pmodhdricmp=NULL;
  psram->pmodhdrarp=NULL;
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_addmod_eth_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_addmod *psram=(shared_record_addmod *)pinfos;
  lcrzo_data ethdata, ipdata, protodata, spdata;
  lcrzo_int32 spdatasize;
  lcrzo_uint16 ethdatasize, ipdatasize, protodatasize;
  lcrzo_bool haseth, hasip, hasudp, hastcp, hasicmp, hasarp; 
  lcrzo_hdrleth hdreth;
  lcrzo_hdrlip hdrip;
  lcrzo_ipopt ipopt;
  lcrzo_uint8 ipoptsize, tcpoptsize;
  lcrzo_hdrludp hdrudp;
  lcrzo_hdrltcp hdrtcp;
  lcrzo_tcpopt tcpopt;
  lcrzo_hdrlicmp hdricmp;
  lcrzo_hdrlarp hdrarp;
  int ret;

  if (psram==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pspoofdev==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->paddhdreth!=NULL)
  { puts("psram->paddhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psram->paddhdrip!=NULL)
  { puts("psram->paddhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  
  /* by default, has no header */
  haseth=LCRZO_FALSE;
  hasip=LCRZO_FALSE;
  hasudp=LCRZO_FALSE;
  hastcp=LCRZO_FALSE;
  hasicmp=LCRZO_FALSE;
  hasarp=LCRZO_FALSE;

  /* for the compiler warning */
  hdrip.id=0;
  hdrudp.len=0;
  hdrtcp.fin=0;
  hdricmp.type=0;
  hdrarp.op=0;
  ipdata=NULL;
  protodata=NULL;
  ipdatasize=0;
  ipoptsize=0;
  tcpoptsize=0;
  protodatasize=0;

  /* try to decompose the Ethernet packet */
  ret=lcrzo_packet_decodem_ethdata((lcrzo_data)data, datasize,
				   &hdreth, &ethdata, &ethdatasize);
  if (ret!=LCRZO_ERR_OK)
  { puts("This packet doesn't start with an Ethernet header");
    return (LCRZO_ERR_OK); /*ignore error, and continue*/
  }
  haseth=LCRZO_TRUE;

  /* try to decode the ARP packet */  
  if (hdreth.type==LCRZO_HDRLETH_TYPE_ARP)
  { ret=lcrzo_packet_decode_arp(ethdata, ethdatasize, &hdrarp);
    hasarp=LCRZO_TRUE;
  } 

  /* try to decode the IP packet */  
  if (hdreth.type==LCRZO_HDRLETH_TYPE_IP)
  { ret=lcrzo_packet_decodem_ipoptdata(ethdata, ethdatasize,
				       &hdrip, ipopt, &ipoptsize, 
				       &ipdata, &ipdatasize);
    if (ret==LCRZO_ERR_OK)
    { hasip=LCRZO_TRUE;
      /* try to decode UDP packet */
      if ( hdrip.protocol==LCRZO_HDRLIP_PROTOCOL_UDP )
      { ret=lcrzo_packet_decodem_udpdata(ipdata, ipdatasize,
					 &hdrudp, &protodata, &protodatasize);
        if (ret==LCRZO_ERR_OK)
        { hasudp=LCRZO_TRUE;
	}
      }
      /* try to decode TCP packet */
      else if ( hdrip.protocol==LCRZO_HDRLIP_PROTOCOL_TCP )
      { ret=lcrzo_packet_decodem_tcpoptdata(ipdata, ipdatasize,
					    &hdrtcp, tcpopt, &tcpoptsize, 
					    &protodata, &protodatasize);
        if (ret==LCRZO_ERR_OK)
        { hastcp=LCRZO_TRUE;
	}
      }
      /* try to decode ICMP packet */
      else if ( hdrip.protocol==LCRZO_HDRLIP_PROTOCOL_ICMP )
      { ret=lcrzo_packet_decodem_icmpdata(ipdata, ipdatasize,
					  &hdricmp, &protodata,&protodatasize);
        if (ret==LCRZO_ERR_OK)
        { hasicmp=LCRZO_TRUE;
	}
      }
    }
  }

  /* modify values */
  if (psram->pmodhdreth!=NULL)
    lcrzo_epr(lcrzo_hdrleth_update(*(psram->pmodhdreth), &hdreth));
  if (psram->pmodhdrip!=NULL)
  { lcrzo_epr(lcrzo_hdrlip_update(*(psram->pmodhdrip), &hdrip));
    hdrudp.check=LCRZO_HDRLUDP_CHECK_DEFVAL;
    hdrtcp.check=LCRZO_HDRLTCP_CHECK_DEFVAL;
    hdricmp.check=LCRZO_HDRLICMP_CHECK_DEFVAL;
  }
  if (psram->pmodhdrudp!=NULL)
    lcrzo_epr(lcrzo_hdrludp_update(*(psram->pmodhdrudp), &hdrudp));
  if (psram->pmodhdrtcp!=NULL)
    lcrzo_epr(lcrzo_hdrltcp_update(*(psram->pmodhdrtcp), &hdrtcp));
  if (psram->pmodhdricmp!=NULL)
    lcrzo_epr(lcrzo_hdrlicmp_update(*(psram->pmodhdricmp), &hdricmp));
  if (psram->pmodhdrarp!=NULL)
    lcrzo_epr(lcrzo_hdrlarp_update(*(psram->pmodhdrarp), &hdrarp));

  /* reconstruct packets */
  if ( hasip )
  { if (hasudp)
    { lcrzo_epr(lcrzo_packet_initm_ethipoptudpdata(hdreth, hdrip,
						   ipopt, ipoptsize,
						   hdrudp,
						   protodata, protodatasize,
						   &spdata, &spdatasize));
    }
    else if (hastcp)
    { lcrzo_epr(lcrzo_packet_initm_ethipopttcpoptdata(hdreth, hdrip,
						      ipopt, ipoptsize,
						      hdrtcp,
						      tcpopt, tcpoptsize,
						      protodata, protodatasize,
						      &spdata, &spdatasize));
    }
    else if (hasicmp)
    { lcrzo_epr(lcrzo_packet_initm_ethipopticmpdata(hdreth, hdrip,
						    ipopt, ipoptsize,
						    hdricmp,
						    protodata, protodatasize,
						    &spdata, &spdatasize));
    }
    else
    { lcrzo_epr(lcrzo_packet_initm_ethipoptdata(hdreth, hdrip,
						ipopt, ipoptsize,
						ipdata, ipdatasize,
						&spdata, &spdatasize));
    }
  }
  else if ( hasarp )
  { lcrzo_epr(lcrzo_packet_initm_etharp(hdreth, hdrarp,
					&spdata, &spdatasize));
  }
  else
  { lcrzo_epr(lcrzo_packet_initm_ethdata(hdreth, ethdata, ethdatasize,
					 &spdata, &spdatasize));
  }

  /* free data */
  if (haseth) { lcrzo_er(lcrzo_data_free2(&ethdata)); }
  if (hasip) { lcrzo_er(lcrzo_data_free2(&ipdata)); }
  if (hasudp||hastcp||hasicmp) { lcrzo_er(lcrzo_data_free2(&protodata)); }

  /*spoof*/
  lcrzo_epr(lcrzo_spoof_eth(psram->pspoof, *(psram->pspoofdev),
			    spdata, spdatasize));
  lcrzo_er(lcrzo_data_free2(&spdata));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_addmod_ip_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos)
{ shared_record_addmod *psram=(shared_record_addmod *)pinfos;
  lcrzo_data ipdata, protodata, spdata;
  lcrzo_int32 spdatasize;
  lcrzo_uint16 ipdatasize, protodatasize;
  lcrzo_bool hasip, hasudp, hastcp, hasicmp; 
  lcrzo_hdrlip hdrip;
  lcrzo_ipopt ipopt;
  lcrzo_uint8 ipoptsize, tcpoptsize;
  lcrzo_hdrludp hdrudp;
  lcrzo_hdrltcp hdrtcp;
  lcrzo_tcpopt tcpopt;
  lcrzo_hdrlicmp hdricmp;
  int ret;

  if (psram==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->paddhdrip!=NULL)
  { puts("psram->paddhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psram->pmodhdreth!=NULL)
  { puts("psram->pmodhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  
  /* by default, has no header */
  hasip=LCRZO_FALSE;
  hasudp=LCRZO_FALSE;
  hastcp=LCRZO_FALSE;
  hasicmp=LCRZO_FALSE;

  /* for the compiler warning */
  hdrip.id=0;
  hdrudp.len=0;
  hdrtcp.fin=0;
  hdricmp.type=0;
  ipdata=NULL;
  protodata=NULL;
  ipdatasize=0;
  ipoptsize=0;
  tcpoptsize=0;
  protodatasize=0;

  /* try to decompose the IP packet */
  ret=lcrzo_packet_decodem_ipoptdata((lcrzo_data)data, datasize,
				     &hdrip, ipopt, &ipoptsize, 
				     &ipdata, &ipdatasize);
  if (ret!=LCRZO_ERR_OK)
  { puts("This packet doesn't start with an IP header");
    return (LCRZO_ERR_OK); /*ignore error, and continue*/
  }
  hasip=LCRZO_TRUE;

  /* try to decode UDP packet */
  if ( hdrip.protocol==LCRZO_HDRLIP_PROTOCOL_UDP )
  { ret=lcrzo_packet_decodem_udpdata(ipdata, ipdatasize,
				     &hdrudp, &protodata, &protodatasize);
    if (ret==LCRZO_ERR_OK)
    { hasudp=LCRZO_TRUE;
    }
  }
  /* try to decode TCP packet */
  else if ( hdrip.protocol==LCRZO_HDRLIP_PROTOCOL_TCP )
  { ret=lcrzo_packet_decodem_tcpoptdata(ipdata, ipdatasize,
					&hdrtcp, tcpopt, &tcpoptsize, 
					&protodata, &protodatasize);
    if (ret==LCRZO_ERR_OK)
    { hastcp=LCRZO_TRUE;
    }
  }
  /* try to decode ICMP packet */
  else if ( hdrip.protocol==LCRZO_HDRLIP_PROTOCOL_ICMP )
  { ret=lcrzo_packet_decodem_icmpdata(ipdata, ipdatasize,
				      &hdricmp, &protodata,&protodatasize);
    if (ret==LCRZO_ERR_OK)
    { hasicmp=LCRZO_TRUE;
    }
  }

  /* modify values */
  if (psram->pmodhdrip!=NULL)
  { lcrzo_epr(lcrzo_hdrlip_update(*(psram->pmodhdrip), &hdrip));
    hdrudp.check=LCRZO_HDRLUDP_CHECK_DEFVAL;
    hdrtcp.check=LCRZO_HDRLTCP_CHECK_DEFVAL;
    hdricmp.check=LCRZO_HDRLICMP_CHECK_DEFVAL;
  }
  if (psram->pmodhdrudp!=NULL)
    lcrzo_epr(lcrzo_hdrludp_update(*(psram->pmodhdrudp), &hdrudp));
  if (psram->pmodhdrtcp!=NULL)
    lcrzo_epr(lcrzo_hdrltcp_update(*(psram->pmodhdrtcp), &hdrtcp));
  if (psram->pmodhdricmp!=NULL)
    lcrzo_epr(lcrzo_hdrlicmp_update(*(psram->pmodhdricmp), &hdricmp));

  /* reconstruct packets */
  printf("--%d\n", hdrip.totlen);
  hdrip.totlen=LCRZO_HDRLIP_TOTLEN_DEFVAL;
  if (hasudp)
  { lcrzo_epr(lcrzo_packet_initm_ipoptudpdata(hdrip, ipopt, ipoptsize,
					      hdrudp,
					      protodata, protodatasize,
					      &spdata, &spdatasize));
  }
  else if (hastcp)
  { lcrzo_epr(lcrzo_packet_initm_ipopttcpoptdata(hdrip, ipopt, ipoptsize,
						 hdrtcp,
						 tcpopt, tcpoptsize,
						 protodata, protodatasize,
						 &spdata, &spdatasize));
  }
  else if (hasicmp)
  { lcrzo_epr(lcrzo_packet_initm_ipopticmpdata(hdrip, ipopt, ipoptsize,
					       hdricmp,
					       protodata, protodatasize,
					       &spdata, &spdatasize));
  }
  else
  { lcrzo_epr(lcrzo_packet_initm_ipoptdata(hdrip, ipopt, ipoptsize,
					   ipdata, ipdatasize,
					   &spdata, &spdatasize));
  }

  /* free data */
  if (hasip) { lcrzo_er(lcrzo_data_free2(&ipdata)); }
  if (hasudp||hastcp||hasicmp) { lcrzo_er(lcrzo_data_free2(&protodata)); }

  /*spoof*/
  if ( psram->paddhdreth!=NULL && psram->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethdata(psram->pspoof, *(psram->pspoofdev),
				  *(psram->paddhdreth), 
				  spdata, (lcrzo_uint16)spdatasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ip(psram->pspoof, spdata, spdatasize));
  }

  lcrzo_er(lcrzo_data_free2(&spdata));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_addmod_udp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_addmod *psram=(shared_record_addmod *)pinfos;
  lcrzo_data protodata, spdata;
  lcrzo_int32 spdatasize;
  lcrzo_uint16 protodatasize;
  lcrzo_hdrludp hdrudp;
  int ret;

  if (psram==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pmodhdreth!=NULL)
  { puts("psram->pmodhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psram->pmodhdrip!=NULL)
  { puts("psram->pmodhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* try to decompose the UDP packet */
  ret=lcrzo_packet_decodem_udpdata((lcrzo_data)data, datasize,
				   &hdrudp, &protodata, &protodatasize);
  if (ret!=LCRZO_ERR_OK)
  { puts("This packet doesn't start with an UDP header");
    return (LCRZO_ERR_OK); /*ignore error, and continue*/
  }

  /* modify header and force checksum to be recomputed */
  if (psram->pmodhdrudp!=NULL)
    lcrzo_epr(lcrzo_hdrludp_update(*(psram->pmodhdrudp), &hdrudp));
  hdrudp.check=LCRZO_HDRLUDP_CHECK_DEFVAL;

  /* reconstruct packets */
  lcrzo_epr(lcrzo_packet_initm_ipoptudpdata(*(psram->paddhdrip), NULL, 0,
					    hdrudp, protodata, protodatasize,
					    &spdata, &spdatasize));

  /* free data */
  lcrzo_er(lcrzo_data_free2(&protodata));

  /*spoof*/
  if ( psram->paddhdreth!=NULL && psram->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethdata(psram->pspoof, *(psram->pspoofdev),
				  *(psram->paddhdreth), 
				  spdata, (lcrzo_uint16)spdatasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ip(psram->pspoof, spdata, spdatasize));
  }

  lcrzo_er(lcrzo_data_free2(&spdata));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_addmod_tcp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_addmod *psram=(shared_record_addmod *)pinfos;
  lcrzo_data protodata, spdata;
  lcrzo_int32 spdatasize;
  lcrzo_uint16 protodatasize;
  lcrzo_hdrltcp hdrtcp;
  lcrzo_tcpopt tcpopt;
  lcrzo_uint8 tcpoptsize;
  int ret;

  if (psram==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pmodhdreth!=NULL)
  { puts("psram->pmodhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psram->pmodhdrip!=NULL)
  { puts("psram->pmodhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* try to decompose the TCP packet */
  ret=lcrzo_packet_decodem_tcpoptdata((lcrzo_data)data, datasize,
				      &hdrtcp, tcpopt, &tcpoptsize,
				      &protodata, &protodatasize);
  if (ret!=LCRZO_ERR_OK)
  { puts("This packet doesn't start with an TCP header");
    return (LCRZO_ERR_OK); /*ignore error, and continue*/
  }

  /* modify header and force checksum to be recomputed */
  if (psram->pmodhdrtcp!=NULL)
    lcrzo_epr(lcrzo_hdrltcp_update(*(psram->pmodhdrtcp), &hdrtcp));
  hdrtcp.check=LCRZO_HDRLTCP_CHECK_DEFVAL;

  /* reconstruct packets */
  lcrzo_epr(lcrzo_packet_initm_ipopttcpoptdata(*(psram->paddhdrip), NULL, 0,
					       hdrtcp, tcpopt, tcpoptsize,
					       protodata, protodatasize,
					       &spdata, &spdatasize));

  /* free data */
  lcrzo_er(lcrzo_data_free2(&protodata));

  /*spoof*/
  if ( psram->paddhdreth!=NULL && psram->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethdata(psram->pspoof, *(psram->pspoofdev),
				  *(psram->paddhdreth), 
				  spdata, (lcrzo_uint16)spdatasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ip(psram->pspoof, spdata, spdatasize));
  }

  lcrzo_er(lcrzo_data_free2(&spdata));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_addmod_icmp_spoof(lcrzo_ptr data,
				    lcrzo_int32 datasize,
				    lcrzo_ptr pinfos)
{ shared_record_addmod *psram=(shared_record_addmod *)pinfos;
  lcrzo_data protodata, spdata;
  lcrzo_int32 spdatasize;
  lcrzo_uint16 protodatasize;
  lcrzo_hdrlicmp hdricmp;
  int ret;

  if (psram==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psram->pmodhdreth!=NULL)
  { puts("psram->pmodhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psram->pmodhdrip!=NULL)
  { puts("psram->pmodhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* try to decompose the ICMP packet */
  ret=lcrzo_packet_decodem_icmpdata((lcrzo_data)data, datasize,
				    &hdricmp, &protodata, &protodatasize);
  if (ret!=LCRZO_ERR_OK)
  { puts("This packet doesn't start with an ICMP header");
    return (LCRZO_ERR_OK); /*ignore error, and continue*/
  }

  /* modify header and force checksum to be recomputed */
  if (psram->pmodhdricmp!=NULL)
    lcrzo_epr(lcrzo_hdrlicmp_update(*(psram->pmodhdricmp), &hdricmp));
  hdricmp.check=LCRZO_HDRLICMP_CHECK_DEFVAL;

  /* reconstruct packets */
  lcrzo_epr(lcrzo_packet_initm_ipopticmpdata(*(psram->paddhdrip), NULL, 0,
					    hdricmp, protodata, protodatasize,
					    &spdata, &spdatasize));

  /* free data */
  lcrzo_er(lcrzo_data_free2(&protodata));

  /*spoof*/
  if ( psram->paddhdreth!=NULL && psram->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethdata(psram->pspoof, *(psram->pspoofdev),
				  *(psram->paddhdreth), 
				  spdata, (lcrzo_uint16)spdatasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ip(psram->pspoof, spdata, spdatasize));
  }

  lcrzo_er(lcrzo_data_free2(&spdata));
  return (LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
int shared_record_update_initdefault(shared_record_update *psru)
{
  psru->pspoof=NULL;
  psru->pspoofdev=NULL;
  psru->paddhdreth=NULL;
  psru->paddhdrip=NULL;
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_eth_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_update *psru=(shared_record_update *)pinfos;
  lcrzo_data data2;

  if (psru==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->pspoofdev==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->paddhdreth!=NULL)
  { puts("psru->paddhdreth should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  if (psru->paddhdrip!=NULL)
  { puts("psru->paddhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  
  /* update fields */
  lcrzo_epr(shared_record_update_eth((lcrzo_constdata)data, datasize, &data2));

  /*spoof*/
  lcrzo_epr(lcrzo_spoof_eth(psru->pspoof, *(psru->pspoofdev),
			    data2, datasize));
  lcrzo_epr(lcrzo_data_free2(&data2));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_ip_spoof(lcrzo_ptr data,
				 lcrzo_int32 datasize,
				 lcrzo_ptr pinfos)
{ shared_record_update *psru=(shared_record_update *)pinfos;
  lcrzo_data data2;

  if (psru==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->paddhdrip!=NULL)
  { puts("psru->paddhdrip should be NULL");
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }

  /* update fields */
  lcrzo_epr(shared_record_update_ip((lcrzo_constdata)data, datasize, &data2));

  /*spoof*/
  if ( psru->paddhdreth!=NULL && psru->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethdata(psru->pspoof, *(psru->pspoofdev),
				  *(psru->paddhdreth), 
				  data2, (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ip(psru->pspoof, data2, datasize));
  }

  lcrzo_epr(lcrzo_data_free2(&data2));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_udp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_update *psru=(shared_record_update *)pinfos;
  lcrzo_data data2;

  if (psru==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);

  /* update fields */
  lcrzo_epr(shared_record_update_udp(psru->paddhdrip->saddr,
				     psru->paddhdrip->daddr,
				     (lcrzo_constdata)data, datasize, &data2));

  /*spoof*/
  if ( psru->paddhdreth!=NULL && psru->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethipoptdata(psru->pspoof, *(psru->pspoofdev),
				       *(psru->paddhdreth), 
				       *(psru->paddhdrip), NULL, 0,
				       data2, (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ipoptdata(psru->pspoof,
				    *(psru->paddhdrip), NULL, 0,
				    data2, (lcrzo_uint16)datasize));
  }

  lcrzo_epr(lcrzo_data_free2(&data2));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_tcp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos)
{ shared_record_update *psru=(shared_record_update *)pinfos;
  lcrzo_data data2;

  if (psru==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);

  /* update fields */
  lcrzo_epr(shared_record_update_tcp(psru->paddhdrip->saddr,
				     psru->paddhdrip->daddr,
				     (lcrzo_constdata)data, datasize, &data2));

  /*spoof*/
  if ( psru->paddhdreth!=NULL && psru->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethipoptdata(psru->pspoof, *(psru->pspoofdev),
				       *(psru->paddhdreth), 
				       *(psru->paddhdrip), NULL, 0,
				       data2, (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ipoptdata(psru->pspoof,
				    *(psru->paddhdrip), NULL, 0,
				    data2, (lcrzo_uint16)datasize));
  }

  lcrzo_epr(lcrzo_data_free2(&data2));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_icmp_spoof(lcrzo_ptr data,
				    lcrzo_int32 datasize,
				    lcrzo_ptr pinfos)
{ shared_record_update *psru=(shared_record_update *)pinfos;
  lcrzo_data data2;

  if (psru==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->pspoof==NULL) return(LCRZO_ERR_PANULLPTR);
  if (psru->paddhdrip==NULL) return(LCRZO_ERR_PANULLPTR);

  /* update fields */
  lcrzo_epr(shared_record_update_icmp((lcrzo_constdata)data, datasize,
				      &data2));

  /*spoof*/
  if ( psru->paddhdreth!=NULL && psru->pspoofdev!=NULL )
  { lcrzo_epr(lcrzo_spoof_ethipoptdata(psru->pspoof, *(psru->pspoofdev),
				       *(psru->paddhdreth), 
				       *(psru->paddhdrip), NULL, 0,
				       data2, (lcrzo_uint16)datasize));
  }
  else
  { lcrzo_epr(lcrzo_spoof_ipoptdata(psru->pspoof,
				    *(psru->paddhdrip), NULL, 0,
				    data2, (lcrzo_uint16)datasize));
  }

  lcrzo_epr(lcrzo_data_free2(&data2));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_eth(lcrzo_constdata data,
			     lcrzo_int32 datasize,
			     lcrzo_data *pdata)
{ lcrzo_hdrleth hdrleth;
  lcrzo_data ethdata;
  lcrzo_int32 ethdatasize;
  int ret;

  if ( datasize<(lcrzo_int32)sizeof(lcrzo_hdrpeth2) )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  ret=lcrzo_hdrleth_init_hdrpeth2(data, &hdrleth);
  if ( ret!=LCRZO_ERR_OK || hdrleth.type!=LCRZO_HDRLETH_TYPE_IP )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  ethdatasize=datasize-sizeof(lcrzo_hdrpeth2);
  ret=shared_record_update_ip(data+sizeof(lcrzo_hdrpeth2), ethdatasize,
			      &ethdata);
  if ( ret!=LCRZO_ERR_OK )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  lcrzo_er(lcrzo_data_initm_data(data, sizeof(lcrzo_hdrpeth2), pdata, NULL));
  lcrzo_er(lcrzo_data_appendm_data(ethdata, ethdatasize, 
				   sizeof(lcrzo_hdrpeth2), 
				   pdata, NULL));
  lcrzo_er(lcrzo_data_free2(&ethdata));

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_priv_record_update_ip(lcrzo_constdata data,
				 lcrzo_int32 datasize,
				 lcrzo_data *pdata);
int shared_priv_record_update_ip(lcrzo_constdata data,
				 lcrzo_int32 datasize,
				 lcrzo_data *pdata)
{ lcrzo_data data2;
  lcrzo_int32 hdroptsize;
  lcrzo_uint16 check;

  if ( datasize<(lcrzo_int32)sizeof(lcrzo_hdrpip2) )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  lcrzo_er(lcrzo_data_initm_data(data, datasize, &data2, NULL));

  /* first, update totlen */
  data2[2]=(lcrzo_uint8)(datasize>>8);
  data2[3]=(lcrzo_uint8)(datasize&0xFF);

  /* now, update checksum */   
  data2[10]=0;
  data2[11]=0;
  hdroptsize=4*(data2[0]&0xF);
  if ( hdroptsize>datasize ) hdroptsize=datasize;
  lcrzo_er(lcrzo_data_checksum(data2, hdroptsize, &check));
  data2[10]=(lcrzo_uint8)(check>>8);
  data2[11]=(lcrzo_uint8)(check&0xFF);

  /* set output */
  if (pdata!=NULL)
  { *pdata=data2;
  }
  else
  { lcrzo_er(lcrzo_data_free2(&data2));
  }
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_ip(lcrzo_constdata data,
			    lcrzo_int32 datasize,
			    lcrzo_data *pdata)
{ lcrzo_hdrlip hdrlip;
  lcrzo_data ipdata, tmp;
  lcrzo_int32 ipdatasize, tmpsize;
  lcrzo_ipopt ipopt;
  lcrzo_uint8 ipoptsize;
  int ret;

  if ( datasize<(lcrzo_int32)sizeof(lcrzo_hdrpip2) )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  ret=lcrzo_hdrlip_init_hdrpip2(data, &hdrlip);
  if ( ret!=LCRZO_ERR_OK )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  ipdatasize=datasize-sizeof(lcrzo_hdrpip2);
  ipoptsize=0;
  if (hdrlip.ihl<5)
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }
  /* suppose ip.ihl is correct (we cannot compute otherwise) */
  if (hdrlip.ihl>5)
  { ipoptsize=(lcrzo_uint8)(4*(hdrlip.ihl-5));
    if (ipdatasize>=ipoptsize)
    { ipdatasize-=ipoptsize;
      memcpy(ipopt, data+sizeof(lcrzo_hdrpip2), ipoptsize);
    }
    else
    { lcrzo_er(shared_priv_record_update_ip(data, datasize, pdata));
      return (LCRZO_ERR_OK);
    }
  }

  switch(hdrlip.protocol)
  { case LCRZO_HDRLIP_PROTOCOL_UDP:
      ret=shared_record_update_udp(hdrlip.saddr, hdrlip.daddr, 
				   data+sizeof(lcrzo_hdrpip2)+ipoptsize,
				   ipdatasize, &ipdata);
      if ( ret!=LCRZO_ERR_OK )
      { lcrzo_er(shared_priv_record_update_ip(data, datasize, pdata));
        return (LCRZO_ERR_OK);
      }
      break;
    case LCRZO_HDRLIP_PROTOCOL_TCP:
      ret=shared_record_update_tcp(hdrlip.saddr, hdrlip.daddr, 
				   data+sizeof(lcrzo_hdrpip2)+ipoptsize,
				   ipdatasize, &ipdata);
      if ( ret!=LCRZO_ERR_OK )
      { lcrzo_er(shared_priv_record_update_ip(data, datasize, pdata));
        return (LCRZO_ERR_OK);
      }
      break;
    case LCRZO_HDRLIP_PROTOCOL_ICMP:
      ret=shared_record_update_icmp(data+sizeof(lcrzo_hdrpip2)+ipoptsize,
				    ipdatasize, &ipdata);
      if ( ret!=LCRZO_ERR_OK )
      { lcrzo_er(shared_priv_record_update_ip(data, datasize, pdata));
        return (LCRZO_ERR_OK);
      }
      break;
    default:
      lcrzo_er(shared_priv_record_update_ip(data, datasize, pdata));
      return (LCRZO_ERR_OK);
  }

  lcrzo_er(lcrzo_data_initm_data(data, sizeof(lcrzo_hdrpip2),
				 &tmp, &tmpsize));
  if (ipoptsize)
  { lcrzo_er(lcrzo_data_appendm_data(ipopt, ipoptsize, tmpsize,
				     &tmp, &tmpsize));
  }
  lcrzo_er(lcrzo_data_appendm_data(ipdata, ipdatasize, tmpsize,
				   &tmp, &tmpsize));
  lcrzo_er(lcrzo_data_free2(&ipdata));
  lcrzo_er(shared_priv_record_update_ip(tmp, tmpsize, pdata));
  lcrzo_er(lcrzo_data_free2(&tmp));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_pseudo(lcrzo_uint32 saddr,
			 lcrzo_uint32 daddr,
			 lcrzo_uint8  protocol,
			 lcrzo_constdata hdranddata,
			 lcrzo_uint16 hdranddatasize,
			 lcrzo_uint16 *pcheck);
int shared_record_pseudo(lcrzo_uint32 saddr,
			 lcrzo_uint32 daddr,
			 lcrzo_uint8  protocol,
			 lcrzo_constdata hdranddata,
			 lcrzo_uint16 hdranddatasize,
			 lcrzo_uint16 *pcheck)
{ lcrzo_data tmp;
  lcrzo_int32 tmpsize;

  tmpsize=12+hdranddatasize;
  lcrzo_er(lcrzo_data_alloc(tmpsize, &tmp));
  tmp[0]=(lcrzo_uint8)(saddr>>24);
  tmp[1]=(lcrzo_uint8)(0xFF&(saddr>>16));
  tmp[2]=(lcrzo_uint8)(0xFF&(saddr>>8));
  tmp[3]=(lcrzo_uint8)(0xFF&saddr);
  tmp[4]=(lcrzo_uint8)(daddr>>24);
  tmp[5]=(lcrzo_uint8)(0xFF&(daddr>>16));
  tmp[6]=(lcrzo_uint8)(0xFF&(daddr>>8));
  tmp[7]=(lcrzo_uint8)(0xFF&daddr);
  tmp[8]=0;
  tmp[9]=protocol;
  tmp[10]=(lcrzo_uint8)(0xFF&(hdranddatasize>>8));
  tmp[11]=(lcrzo_uint8)(0xFF&hdranddatasize);
  memcpy(tmp+12, hdranddata, hdranddatasize);
  lcrzo_er(lcrzo_data_checksum(tmp, tmpsize, pcheck));
  lcrzo_er(lcrzo_data_free2(&tmp));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_udp(lcrzo_uint32 saddr,
			     lcrzo_uint32 daddr,
			     lcrzo_constdata data,
			     lcrzo_int32 datasize,
			     lcrzo_data *pdata)
{ lcrzo_data data2;
  lcrzo_uint16 check;

  if ( datasize<(lcrzo_int32)sizeof(lcrzo_hdrpudp2) )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  lcrzo_er(lcrzo_data_initm_data(data, datasize, &data2, NULL));

  /* first, update len */
  data2[4]=(lcrzo_uint8)(datasize>>8);
  data2[5]=(lcrzo_uint8)(datasize&0xFF);

  /* now, update checksum */   
  data2[6]=0;
  data2[7]=0;
  lcrzo_er(shared_record_pseudo(saddr, daddr, LCRZO_HDRLIP_PROTOCOL_UDP,
				data2, (lcrzo_uint16)datasize, &check));  
  data2[6]=(lcrzo_uint8)(check>>8);
  data2[7]=(lcrzo_uint8)(check&0xFF);

  /* set output */
  if (pdata!=NULL)
  { *pdata=data2;
  }
  else
  { lcrzo_er(lcrzo_data_free2(&data2));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_tcp(lcrzo_uint32 saddr,
			     lcrzo_uint32 daddr,
			     lcrzo_constdata data,
			     lcrzo_int32 datasize,
			     lcrzo_data *pdata)
{ lcrzo_data data2;
  lcrzo_uint16 check;

  if ( datasize<(lcrzo_int32)sizeof(lcrzo_hdrptcp2) )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  lcrzo_er(lcrzo_data_initm_data(data, datasize, &data2, NULL));

  /* update checksum */   
  data2[16]=0;
  data2[17]=0;
  lcrzo_er(shared_record_pseudo(saddr, daddr, LCRZO_HDRLIP_PROTOCOL_TCP,
				data2, (lcrzo_uint16)datasize, &check));  
  data2[16]=(lcrzo_uint8)(check>>8);
  data2[17]=(lcrzo_uint8)(check&0xFF);

  /* set output */
  if (pdata!=NULL)
  { *pdata=data2;
  }
  else
  { lcrzo_er(lcrzo_data_free2(&data2));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_record_update_icmp(lcrzo_constdata data,
			      lcrzo_int32 datasize,
			      lcrzo_data *pdata)
{ lcrzo_data data2;
  lcrzo_uint16 check;

  if ( datasize<(lcrzo_int32)sizeof(lcrzo_hdrpicmp2) )
  { lcrzo_er(lcrzo_data_initm_data(data, datasize, pdata, NULL));
    return (LCRZO_ERR_OK);
  }

  lcrzo_er(lcrzo_data_initm_data(data, datasize, &data2, NULL));

  /* update checksum */   
  data2[2]=0;
  data2[3]=0;
  lcrzo_er(lcrzo_data_checksum(data2, datasize, &check));
  data2[2]=(lcrzo_uint8)(check>>8);
  data2[3]=(lcrzo_uint8)(check&0xFF);

  /* set output */
  if (pdata!=NULL)
  { *pdata=data2;
  }
  else
  { lcrzo_er(lcrzo_data_free2(&data2));
  }

  return (LCRZO_ERR_OK);
}

