#ifndef LCRZOEX_RECORD_INCLUDED
#define LCRZOEX_RECORD_INCLUDED 1

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_spoof *pspoof;
  lcrzo_device *pspoofdev;
  /* added headers */
  lcrzo_hdrleth *paddhdreth;
  lcrzo_hdrlip *paddhdrip;
  lcrzo_hdrludp *paddhdrudp;
  lcrzo_hdrltcp *paddhdrtcp;
  lcrzo_hdrlicmp *paddhdricmp;
} shared_record_exact;

/*-------------------------------------------------------------*/
int shared_record_exact_initdefault(shared_record_exact *psram);

/*-------------------------------------------------------------*/
int shared_record_exact_eth_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos);
int shared_record_exact_ip_spoof(lcrzo_ptr data,
				 lcrzo_int32 datasize,
				 lcrzo_ptr pinfos);
int shared_record_exact_udp_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos);
int shared_record_exact_tcp_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos);
int shared_record_exact_icmp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_exact_data_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_spoof *pspoof;
  lcrzo_device *pspoofdev;
  /* added headers */
  lcrzo_hdrleth *paddhdreth;
  lcrzo_hdrlip *paddhdrip;
  /* modified fields */
  lcrzo_hdrleth *pmodhdreth;
  lcrzo_hdrlip *pmodhdrip;
  lcrzo_hdrludp *pmodhdrudp;
  lcrzo_hdrltcp *pmodhdrtcp;
  lcrzo_hdrlicmp *pmodhdricmp;
  lcrzo_hdrlarp *pmodhdrarp;
} shared_record_addmod;

/*-------------------------------------------------------------*/
int shared_record_addmod_initdefault(shared_record_addmod *psram);

/*-------------------------------------------------------------*/
int shared_record_addmod_eth_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_addmod_ip_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos);
int shared_record_addmod_udp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_addmod_tcp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_addmod_icmp_spoof(lcrzo_ptr data,
				    lcrzo_int32 datasize,
				    lcrzo_ptr pinfos);


/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_spoof *pspoof;
  lcrzo_device *pspoofdev;
  /* added headers */
  lcrzo_hdrleth *paddhdreth;
  lcrzo_hdrlip *paddhdrip;
} shared_record_update;

/*-------------------------------------------------------------*/
int shared_record_update_initdefault(shared_record_update *psru);

/*-------------------------------------------------------------*/
int shared_record_update_eth_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_update_ip_spoof(lcrzo_ptr data,
				  lcrzo_int32 datasize,
				  lcrzo_ptr pinfos);
int shared_record_update_udp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_update_tcp_spoof(lcrzo_ptr data,
				   lcrzo_int32 datasize,
				   lcrzo_ptr pinfos);
int shared_record_update_icmp_spoof(lcrzo_ptr data,
				    lcrzo_int32 datasize,
				    lcrzo_ptr pinfos);

/*-------------------------------------------------------------*/
int shared_record_update_eth(lcrzo_constdata data,
			     lcrzo_int32 datasize,
			     lcrzo_data *pdata);
int shared_record_update_ip(lcrzo_constdata data,
			    lcrzo_int32 datasize,
			    lcrzo_data *pdata);
int shared_record_update_udp(lcrzo_uint32 saddr,
			     lcrzo_uint32 daddr,
			     lcrzo_constdata data,
			     lcrzo_int32 datasize,
			     lcrzo_data *pdata);
int shared_record_update_tcp(lcrzo_uint32 saddr,
			     lcrzo_uint32 daddr,
			     lcrzo_constdata data,
			     lcrzo_int32 datasize,
			     lcrzo_data *pdata);
int shared_record_update_icmp(lcrzo_constdata data,
			      lcrzo_int32 datasize,
			      lcrzo_data *pdata);

#endif

