#ifndef LCRZOEX_SMTP_INCLUDED
#define LCRZOEX_SMTP_INCLUDED 1

/*-------------------------------------------------------------*/
int shared_smtp_appendm_line_msgid(lcrzo_string *poutput);
int shared_smtp_appendm_line_date(lcrzo_string *poutput);
int shared_smtp_appendm_line_from(lcrzo_conststring username,
				  lcrzo_conststring email,
				  lcrzo_string *poutput);
int shared_smtp_appendm_line_replyto(lcrzo_conststring username,
				     lcrzo_conststring email,
				     lcrzo_string *poutput);
int shared_smtp_appendm_line_to(lcrzo_conststring username,
				lcrzo_conststring email,
				lcrzo_string *poutput);
int shared_smtp_appendm_line_organization(lcrzo_string *poutput);
int shared_smtp_appendm_line_xmailer(lcrzo_string *poutput);
int shared_smtp_appendm_line_xacclang(lcrzo_string *poutput);
int shared_smtp_appendm_line_mimeversion(lcrzo_string *poutput);
int shared_smtp_appendm_line_conttype_mpmixed(lcrzo_conststring boundary,
					      lcrzo_string *poutput);
int shared_smtp_appendm_line_conttype_textplainusascii(lcrzo_conststring name,
						       lcrzo_string *poutput);
int shared_smtp_appendm_line_conttype_textplainiso8859(lcrzo_conststring name,
						       lcrzo_string *poutput);
int shared_smtp_appendm_line_conttype_appoctstream(lcrzo_conststring name,
						   lcrzo_string *poutput);
int shared_smtp_appendm_line_cte_7bit(lcrzo_string *poutput);
int shared_smtp_appendm_line_cte_8bit(lcrzo_string *poutput);
int shared_smtp_appendm_line_cte_base64(lcrzo_string *poutput);
int shared_smtp_appendm_line_contdisp_inline(lcrzo_conststring filename,
					     lcrzo_string *poutput);
int shared_smtp_appendm_line_contdisp_attach(lcrzo_conststring filename,
					     lcrzo_string *poutput);
int shared_smtp_appendm_line_empty(lcrzo_string *poutput);
int shared_smtp_appendm_line_subject(lcrzo_conststring subject, 
				     lcrzo_string *poutput);
int shared_smtp_appendm_line_boundary(lcrzo_conststring boundary,
				      lcrzo_bool islast,
				      lcrzo_string *poutput);

/*-------------------------------------------------------------*/
int shared_smtp_generateboundary(lcrzo_string *pboundary);

/*-------------------------------------------------------------*/
int shared_smtp_initm_headerbody_usascii(lcrzo_conststring from,
					 lcrzo_conststring replyto,
					 lcrzo_conststring to,
					 lcrzo_conststring subject, 
					 lcrzo_constdata bodydata,
					 lcrzo_int32 bodydatasize,
					 lcrzo_data *pdataout,
					 lcrzo_int32 *pdataoutsize);
int shared_smtp_initm_headerbody_iso8859(lcrzo_conststring from,
					 lcrzo_conststring replyto,
					 lcrzo_conststring to,
					 lcrzo_conststring subject, 
					 lcrzo_constdata bodydata,
					 lcrzo_int32 bodydatasize,
					 lcrzo_data *pdataout,
					 lcrzo_int32 *pdataoutsize);

/*-------------------------------------------------------------*/
int shared_smtp_initm_multipart_header(lcrzo_conststring from,
				       lcrzo_conststring replyto,
				       lcrzo_conststring to,
				       lcrzo_conststring subject, 
				       lcrzo_string *pboundary,
				       lcrzo_data *pdataout,
				       lcrzo_int32 *pdataoutsize);
int shared_smtp_appendm_multipart_usascii(lcrzo_conststring boundary,
					  lcrzo_conststring headername,
					  lcrzo_conststring headerfilename,
					  lcrzo_constdata data,
					  lcrzo_int32 datasize,
					  lcrzo_int32 dataoutcurrentsize,
					  lcrzo_data *pdataout,
					  lcrzo_int32 *pdataoutsize);
int shared_smtp_appendm_multipart_iso8859(lcrzo_conststring boundary,
					  lcrzo_conststring headername,
					  lcrzo_conststring headerfilename,
					  lcrzo_constdata data,
					  lcrzo_int32 datasize,
					  lcrzo_int32 dataoutcurrentsize,
					  lcrzo_data *pdataout,
					  lcrzo_int32 *pdataoutsize);
int shared_smtp_appendm_multipart_base64(lcrzo_conststring boundary,
					 lcrzo_conststring headername,
					 lcrzo_conststring headerfilename,
					 lcrzo_constdata data,
					 lcrzo_int32 datasize,
					 lcrzo_int32 dataoutcurrentsize,
					 lcrzo_data *pdataout,
					 lcrzo_int32 *pdataoutsize);
int shared_smtp_appendm_multipart_end(lcrzo_conststring boundary,
				      lcrzo_int32 dataoutcurrentsize,
				      lcrzo_data *pdataout,
				      lcrzo_int32 *pdataoutsize);

/*-------------------------------------------------------------*/
int shared_smtp_sendmsg(lcrzo_ipl serverip, 
			lcrzo_uint16 serverport,
			lcrzo_conststring mailfrom, 
			lcrzo_conststring rcptto,
			lcrzo_constdata headerbody,
			lcrzo_int32 headerbodysize);


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
int shared_smtp_initm_subjectdata_file(lcrzo_conststring subject, 
				       lcrzo_conststring bodyfilename,
				       lcrzo_string *psubject, 
				       lcrzo_data *pdata,
				       lcrzo_int32 *pdatasize);


/*-------------------------------------------------------------*/
int shared_smtp_initm_headerbody_file(lcrzo_conststring from,
				      lcrzo_conststring replyto,
				      lcrzo_conststring to,
				      lcrzo_conststring subject, 
				      lcrzo_conststring bodyfilename,
				      lcrzo_data *pdata,
				      lcrzo_int32 *pdatasize);

int shared_smtp_initm_multipart_2files(lcrzo_conststring from,
				       lcrzo_conststring replyto,
				       lcrzo_conststring to,
				       lcrzo_conststring subject, 
				       lcrzo_conststring bodyfilename,
				       lcrzo_conststring attachementfilename,
				       lcrzo_data *pdata,
				       lcrzo_int32 *pdatasize);

/*-------------------------------------------------------------*/
int shared_smtp_sendmsg_hb_file(lcrzo_ipl serverip, 
				lcrzo_uint16 serverport,
				lcrzo_conststring mailfrom, 
				lcrzo_conststring rcptto,
				lcrzo_conststring from, 
				lcrzo_conststring replyto, 
				lcrzo_conststring to,
				lcrzo_conststring subject, 
				lcrzo_conststring bodyfilename);
int shared_smtp_sendmsg_mp_2files(lcrzo_ipl serverip, 
				  lcrzo_uint16 serverport,
				  lcrzo_conststring mailfrom, 
				  lcrzo_conststring rcptto,
				  lcrzo_conststring from, 
				  lcrzo_conststring replyto, 
				  lcrzo_conststring to,
				  lcrzo_conststring subject, 
				  lcrzo_conststring bodyfilename,
				  lcrzo_conststring attachementfilename);

#endif


