#ifndef LCRZOEX_SOCK_INCLUDED
#define LCRZOEX_SOCK_INCLUDED 1

typedef struct {
  lcrzo_device device;
  lcrzo_etha clientetha;
  lcrzo_etha serveretha;
  lcrzo_ipl clientipl;
  lcrzo_ipl serveripl;
  lcrzo_ipl serveripl2;
  lcrzo_uint16 clientport;
  lcrzo_uint16 clientport2;
  lcrzo_uint16 serverport;
  lcrzo_uint16 serverport2;
  lcrzo_uint32 seqnum;
  lcrzo_uint8 ttl;
} shared_sock_address;

int shared_sock_banner(lcrzo_sock *psock);

int shared_sock_stdin(lcrzo_sock *psock,
		      lcrzo_bool isanudpserver);
int shared_sock_pipe(lcrzo_sock *psock,
		     lcrzo_bool isanudpserver,
		     lcrzo_bool proposecleantermination);

int shared_sock_echo(lcrzo_sock *psock);
int shared_socktcpmulser_echo(lcrzo_sock *psock, 
			      lcrzo_ptr pinfos);
int shared_sock_display(lcrzo_sock *psock);

/*-------------------------------------------------------------*/
typedef struct
{ lcrzo_process child;
} shared_sock_ipctcpser;
int shared_sock_ipctcpser_real_init(lcrzo_ipl ipl,
				    shared_sock_ipctcpser *psits,
				    lcrzo_ipc *pipc);
int shared_sock_ipctcpser_real2_init(lcrzo_ipl ipl,
				     lcrzo_uint16 port,
				     lcrzo_constipopt ipopt,
				     lcrzo_uint8 ipoptsize,
				     shared_sock_ipctcpser *psits,
				     lcrzo_ipc *pipc);
int shared_sock_ipctcpser_close(shared_sock_ipctcpser *psits);


#endif
