/*
		                 LCRZOEX
                             Network toolbox
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzoex.

  Lcrzoex is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Lcrzoex is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

#include <lcrzo.h>
#include "../lcrzoex.h"


/*-------------------------------------------------------------*/
int shared_syslog_datehexa(lcrzo_uint8 facilitypriority,
			   lcrzo_conststring username,
			   lcrzo_data *pdata,
			   lcrzo_int32 *pdatasize)
{ lcrzo_data data;
  lcrzo_int32 datasize;
  lcrzo_time currenttime;
  lcrzo_uint32 sec, usec;

  /* initialize the data */
  lcrzo_epr(lcrzo_data_initm_char('<', 1, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_uint8(facilitypriority, "%u", datasize, 
                                   &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_char('>', 1, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(username, datasize, &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(" was here at ", datasize, 
                                    &data, &datasize));
  lcrzo_epr(lcrzo_time_init_currenttime(&currenttime));
  lcrzo_epr(lcrzo_time_get_secusec(&currenttime, &sec, &usec));
  lcrzo_epr(lcrzo_data_appendm_uint32(sec, "%08X", datasize,
				      &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(".", datasize, 
                                    &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_uint32(usec, "%08X", datasize,
				      &data, &datasize));
  lcrzo_epr(lcrzo_data_appendm_text(".", datasize, &data, &datasize));

  /* set the output values */
  if (pdatasize!=NULL) *pdatasize=datasize;
  if (pdata!=NULL)
  { *pdata=data;
  }
  else
  { lcrzo_er(lcrzo_data_free2(&data));
  }

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_syslog_sockdatehexa(lcrzo_sock *psock,
			       lcrzo_uint8 facilitypriority,
			       lcrzo_conststring username)
{ lcrzo_data data;
  lcrzo_int32 datasize;

  /* initialize the data */
  lcrzo_epr(shared_syslog_datehexa(facilitypriority, username,
				   &data, &datasize));

  /* write to the socket */
  lcrzo_epr(lcrzo_sock_write(psock, data, datasize));
  lcrzo_epr(lcrzo_data_free2(&data));

  return (LCRZO_ERR_OK);
}

