#ifndef LCRZOEX_TELNET_INCLUDED
#define LCRZOEX_TELNET_INCLUDED 1

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_ipc ipcdata;
  lcrzo_process child;
} shared_telnet;

/*-------------------------------------------------------------*/
int shared_telnet_init(lcrzo_ipl serveripl, 
		       lcrzo_uint16 serverport,
		       shared_telnet *ptelnet);
int shared_telnet_close(shared_telnet *ptelnet);

/* note : if login/password is incorrect, this function automatically
   closes session by calling shared_telnet_close */
int shared_telnet_login(shared_telnet *ptelnet,
			lcrzo_conststring login,
			lcrzo_conststring password);

int shared_telnet_exec(shared_telnet *ptelnet,
		       lcrzo_conststring command,
		       lcrzo_uint32 readtimeout,
		       lcrzo_data *preaddata,
		       lcrzo_int32 *preaddatasize);

int shared_telnet_logout(shared_telnet *ptelnet);



#endif
