/*
		                 LCRZOEX
                             Network toolbox
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzoex.

  Lcrzoex is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Lcrzoex is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

#include <lcrzo.h>
#include "../lcrzoex.h"
#include "shared_toolbox.h"

/*-------------------------------------------------------------*/
int shared_toolbox__x_main(int ac, 
			   char* av[], 
			   lcrzo_uint32 toolnumber)
{ int ret;

  /* call the wanted tool */
  ret=LCRZO_ERR_OK;
  if ( toolnumber>=1 && toolnumber<=50 )
  { ret=lcrzoex__00001_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=51 && toolnumber<=100 )
  { ret=lcrzoex__00002_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=101 && toolnumber<=150 )
  { ret=lcrzoex__00003_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=151 && toolnumber<=200 )
  { ret=lcrzoex__00004_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=201 && toolnumber<=250 )
  { ret=lcrzoex__00005_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=251 && toolnumber<=300 )
  { ret=lcrzoex__00006_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=301 && toolnumber<=350 )
  { ret=lcrzoex__00007_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=351 && toolnumber<=400 )
  { ret=lcrzoex__00008_main(ac, av, toolnumber);
  }
  else if ( toolnumber>=401 && toolnumber<=450 )
  { ret=lcrzoex__00009_main(ac, av, toolnumber);
  }
  else 
  { ret=LCRZOEX_ERR_MISC_BADTOOLNUMBER;
  }

  return(ret);
}

/*-------------------------------------------------------------*/
int shared_toolbox__x_infos(lcrzo_uint32 toolnumber,
			    shared_lcrzoex_infos *pinfos)
{ int ret;

  if ( toolnumber>=1 && toolnumber<=50 )
  { ret=lcrzoex__00001_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=51 && toolnumber<=100 )
  { ret=lcrzoex__00002_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=101 && toolnumber<=150 )
  { ret=lcrzoex__00003_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=151 && toolnumber<=200 )
  { ret=lcrzoex__00004_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=201 && toolnumber<=250 )
  { ret=lcrzoex__00005_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=251 && toolnumber<=300 )
  { ret=lcrzoex__00006_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=301 && toolnumber<=350 )
  { ret=lcrzoex__00007_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=351 && toolnumber<=400 )
  { ret=lcrzoex__00008_infos(toolnumber, pinfos);
  }
  else if ( toolnumber>=401 && toolnumber<=450 )
  { ret=lcrzoex__00009_infos(toolnumber, pinfos);
  }
  else 
  { ret=LCRZOEX_ERR_MISC_BADTOOLNUMBER;
  }

  return(ret);
}

/*-------------------------------------------------------------*/
int shared_toolbox_tool_unknown_print(lcrzo_uint32 toolnumber)
{ lcrzo_int16 language;

  lcrzo_epr(lcrzo_global_get_language(&language));
  if ( language==LCRZO_GLOBAL_LANG_FR )
  { lcrzo_epr(lcrzo_uint32_print("Outil '", toolnumber, "%u", "' inconnu.\n"));
    lcrzo_epr(lcrzo_uint32_print("L'outil numero ", toolnumber, "%u",
		       " est peut etre disponible "));
    printf("dans une version recente de lcrzoex.\n"); 
  }
  else
  { lcrzo_epr(lcrzo_uint32_print("Tool '", toolnumber, "%u", "' unknown.\n"));
    lcrzo_epr(lcrzo_uint32_print("Tool number ", toolnumber, "%u",
		       " is perhaps only available "));
    printf("in a newer version of lcrzoex.\n"); 
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_tool_usage_print(lcrzo_conststring progname,
				    lcrzo_uint32 toolnumber)
{ lcrzo_string pn;
  lcrzo_int16 language;
  shared_lcrzoex_infos infos;
  int ret;

  /* get the current language */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* display usage */
  if ( language==LCRZO_GLOBAL_LANG_FR )
    printf("\n---------- Voici comment utiliser cet outil :\n");
  else 
    printf("\n---------- Here is how to use this tool :\n");

  /* create a string containing "progname tool_number" */
  lcrzo_epr(lcrzo_string_initm_text(progname, &pn));
  lcrzo_epr(lcrzo_string_appendm_text(" ", &pn));
  lcrzo_epr(lcrzo_string_appendm_uint32(toolnumber, "%u", &pn));

  /* print infos about this tool */
  ret=shared_toolbox__x_infos(toolnumber, &infos);
  if (ret==LCRZO_ERR_OK)
  { ret=shared_lcrzoex_infos_print(infos, pn);
  }

  lcrzo_epr(lcrzo_string_free2(&pn));

  return(ret);
}

/*-------------------------------------------------------------*/
int shared_toolbox_tool_get_title(lcrzo_uint32 toolnumber,
				  lcrzo_int16 language,
				  lcrzo_string *ptitle)
{ shared_lcrzoex_infos infos;

  lcrzo_er(shared_toolbox__x_infos(toolnumber, &infos));
  if (language==LCRZO_GLOBAL_LANG_FR)
  { lcrzo_er(lcrzo_string_initm_text(infos.title_fr, ptitle));
  }
  else
  { lcrzo_er(lcrzo_string_initm_text(infos.title_en, ptitle));
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_tool_get_max(lcrzo_uint32 *pmaxtoolnumber)
{ lcrzo_uint32 toolnumber;
  int ret;
  
  toolnumber=400; /* sure over 400 */
  while (LCRZO_TRUE)
  { ret=shared_toolbox__x_infos(toolnumber, NULL);
    if (ret!=LCRZO_ERR_OK) break;
    toolnumber++;
  }
  if (pmaxtoolnumber!=NULL) *pmaxtoolnumber=toolnumber-1;

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
typedef struct {
  lcrzo_uint32 toolnumber;
  lcrzo_uint8 c;
} shared_priv_toolbox_helpmode_tool;

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_cat_init(shared_toolbox_helpmode_cat *pcat,
				     lcrzo_int16 language,
				     lcrzo_int16 level)
{
  pcat->language=language;
  pcat->level=level;
  pcat->c='a';
  lcrzo_epr(lcrzo_list_init(&pcat->list, 
			    sizeof(shared_priv_toolbox_helpmode_tool),
			    NULL));

  if ( pcat->language==LCRZO_GLOBAL_LANG_FR )
  { printf("\n++++++++++ Plusieurs outils sont disponibles dans cette categorie :\n");
    printf(" 0 + quitter lcrzoex\n");
    printf(" 1 + revenir au menu principal\n");
    printf(" 2 + revenir a la categorie precedente\n");
  }
  else 
  { printf("\n++++++++++ Several tools are available in this category :\n");
    printf(" 0 + leave lcrzoex\n");  
    printf(" 1 + go back to the main menu\n");  
    printf(" 2 + go back to the previous category\n");  
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_cat_add(shared_toolbox_helpmode_cat *pcat,
				    lcrzo_uint32 toolnumber)
{ shared_priv_toolbox_helpmode_tool hmt;
  lcrzo_string title;

  printf(" %c -", pcat->c);
  lcrzo_er(lcrzo_uint32_print("", toolnumber, "% 4u", ":"));
  lcrzo_er(shared_toolbox_tool_get_title(toolnumber, pcat->language, &title));
  printf("%s\n", title);
  lcrzo_er(lcrzo_string_free2(&title));

  hmt.toolnumber=toolnumber;
  hmt.c=pcat->c;
  lcrzo_epr(lcrzo_list_add_pos(&pcat->list, -1, &hmt));

  pcat->c++;
  if (pcat->c=='z'+1) pcat->c='A';
  if (pcat->c=='Z'+1) return(LCRZO_ERR_IEINTERNALERROR);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_cat_close(shared_toolbox_helpmode_cat *pcat,
				      lcrzo_string levels, 
				      lcrzo_uint32 *ptoolnumber)
{ shared_priv_toolbox_helpmode_tool hmt;
  lcrzo_uint8 choice, i;
  lcrzo_string str;
  lcrzo_int32 count, j;
  
  lcrzo_epr(lcrzo_string_initm_text("012", &str));
  if ( pcat->c>='a' && pcat->c<='z'+1 )
  { for ( i='a' ; i<pcat->c ; i++ )
    { lcrzo_epr(lcrzo_string_appendm_char(i, 1, &str));
    }
  }
  else
  { for ( i='a' ; i<='z' ; i++ )
    { lcrzo_epr(lcrzo_string_appendm_char(i, 1, &str));
    }
    for ( i='A' ; i<pcat->c ; i++ )
    { lcrzo_epr(lcrzo_string_appendm_char(i, 1, &str));
    }
  }

  lcrzo_epr(lcrzo_stdin_char((pcat->language==LCRZO_GLOBAL_LANG_FR)?
			     "Selectionnez un outil":
			     "Select a tool", 
			     (lcrzo_constdata)str, 'a', &choice));
  lcrzo_er(lcrzo_string_free2(&str));
  if (choice=='0') 
  { levels[0]='\0';
  }
  else if (choice=='1') 
  { levels[1]='\0';
  }
  else if (choice=='2') 
  { levels[pcat->level]='\0';
  }
  else
  { lcrzo_epr(lcrzo_list_count(&pcat->list, &count));
    for ( j=1 ; j<=count ; j++ )
    { lcrzo_epr(lcrzo_list_value_pos(&pcat->list, j, &hmt));
      if ( hmt.c==choice )
      { if (ptoolnumber!=NULL) *ptoolnumber=hmt.toolnumber;
        return(LCRZO_ERR_OK);
      }
    }
    printf("Char %c was not found in list\n", choice);
    return(LCRZO_ERR_IEINTERNALERROR);
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_catheader_init(shared_toolbox_helpmode_catheader *pcatheader,
					   lcrzo_int16 language,
					   lcrzo_int16 level)
{
  pcatheader->language=language;
  pcatheader->level=level;
  pcatheader->c='a';

  if ( pcatheader->language==LCRZO_GLOBAL_LANG_FR )
  { printf("\n********** Plusieurs sous-categories sont disponibles :\n");
    printf(" 0 + quitter lcrzoex\n");
    printf(" 1 + revenir au menu principal\n");
    printf(" 2 + revenir a la categorie precedente\n");
  }
  else 
  { printf("\n********** Several sub-categories are available :\n");
    printf(" 0 + leave lcrzoex\n");  
    printf(" 1 + go back to the main menu\n");  
    printf(" 2 + go back to the previous category\n");  
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_catheader_add(shared_toolbox_helpmode_catheader *pcatheader,
					   lcrzo_conststring frstr,
					   lcrzo_conststring enstr)
{
  if ( pcatheader->language==LCRZO_GLOBAL_LANG_FR )
  { printf(" %c - %s\n", pcatheader->c, frstr);
  }
  else 
  { printf(" %c - %s\n", pcatheader->c, enstr);  
  }

  pcatheader->c++;
  if (pcatheader->c=='z'+1) return(LCRZO_ERR_IEINTERNALERROR);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_catheader_close(shared_toolbox_helpmode_catheader *pcatheader,
					    lcrzo_string levels)
{ lcrzo_uint8 choice, i;
  lcrzo_string str;

  lcrzo_epr(lcrzo_string_initm_text("012", &str));
  for ( i='a' ; i<pcatheader->c ; i++ )
  { lcrzo_epr(lcrzo_string_appendm_char(i, 1, &str));
  }
  lcrzo_epr(lcrzo_stdin_char((pcatheader->language==LCRZO_GLOBAL_LANG_FR)?
			     "Entrez une sous-categorie":
			     "Enter a sub-category", 
			     (lcrzo_constdata)str, 'a', &choice));
  lcrzo_er(lcrzo_string_free2(&str));
  if (choice=='0') 
  { levels[0]='\0';
  }
  else if (choice=='1') 
  { levels[1]='\0';
  }
  else if (choice=='2') 
  { levels[pcatheader->level-1]='\0';
  }
  else
  { levels[pcatheader->level]=choice;
    levels[pcatheader->level+1]='\0'; 
  }
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_helpmode_mainmenu(lcrzo_int16 language,
				     lcrzo_string levels)
{ lcrzo_uint8 choice;
  char c;

  c='a';
  if ( language==LCRZO_GLOBAL_LANG_FR )
  { printf("\n########## MENU PRINCIPAL\n");
    printf(" 0 + quitter lcrzoex\n");
    printf(" %c + outils simples a utiliser (nouveaux utilisateurs, commencer ici)\n", c++);
    printf(" %c - obtient des informations\n", c++);
    printf(" %c - sniffe\n", c++);
    printf(" %c - spoof\n", c++);
    printf(" %c - donnees sauvees dans un record\n", c++);
    printf(" %c - clients udp\n", c++);
    printf(" %c - clients tcp\n", c++);
    printf(" %c - serveurs udp\n", c++);
    printf(" %c - serveurs tcp\n", c++);
    printf(" %c - routeurs et ponts\n", c++);
    printf(" %c - backdoors\n", c++);
    printf(" %c - utilitaires pour administrateurs\n", c++);
    printf(" %c - utilitaires malicieux\n", c++);
    printf(" %c - outils non reseau\n", c++);
    printf(" %c + cherche la description d'un outil\n", c++);
    printf(" %c + affiche l'usage d'un outil lorsque l'on connait son numero\n", c++);
    printf(" %c + enregistre les informations sur les outils dans un fichier\n", c++);
  }
  else
  { printf("\n########## MAIN MENU\n");
    printf(" 0 + quit lcrzoex\n");
    printf(" %c + easy tools (new users, start here)\n", c++);
    printf(" %c - obtain information\n", c++);
    printf(" %c - sniff\n", c++);
    printf(" %c - spoof\n", c++);
    printf(" %c - data in records\n", c++);
    printf(" %c - udp clients\n", c++);
    printf(" %c - tcp clients\n", c++);
    printf(" %c - udp servers\n", c++);
    printf(" %c - tcp servers\n", c++);
    printf(" %c - routers and bridges\n", c++);
    printf(" %c - backdoors\n", c++);
    printf(" %c - administrators utilities\n", c++);
    printf(" %c - malicious utilities\n", c++);
    printf(" %c - non network tools\n", c++);
    printf(" %c + search descriptions of tools\n", c++);
    printf(" %c + display usage of a tool, when its number is known\n", c++);
    printf(" %c + save information about all tools in a file\n", c++);
  }
  /* get the user's choice */
  lcrzo_epr(lcrzo_stdin_char((language==LCRZO_GLOBAL_LANG_FR)?
			     "Entrez une categorie":
			     "Enter a category", 
			     (lcrzo_constdata)"0abcdefghijklmnopq",
			     'a', &choice));
  if (choice=='0')
    levels[0]='\0';
  else 
  { levels[1]=choice;
    levels[2]='\0'; 
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_tool_search(void)
{ lcrzo_string title, searchedstring;
  lcrzo_uint32 toolnumber, displayedtools;
  lcrzo_int16 language;
  int ret;

  /* get the current language */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* ask user the searched string */
  puts("");
  lcrzo_er(lcrzo_string_initm_text_stdin((language==LCRZO_GLOBAL_LANG_FR)?
					 "Entrez le motif a chercher (ping, serveur, etc.)":
					 "Enter the pattern to search (ping, server, etc.)",
					 NULL, &searchedstring));

  /* main loop */
  toolnumber=1;
  displayedtools=0;
  while (LCRZO_TRUE)
  { /* obtain the title of this tool */
    ret=shared_toolbox_tool_get_title(toolnumber, language, &title);
    if (ret!=LCRZO_ERR_OK) break;
    /* check if it contains wanted data */
    ret=shared_string_search_text_case(title, LCRZO_FALSE, +1, -1,
				       searchedstring,
				       NULL, NULL, NULL, NULL);
    if (ret!=LCRZO_ERR_OK)
    { lcrzo_er(lcrzo_string_free2(&title));
      toolnumber++;
      continue;
    }
    /* eventually print a separator */
    if ( displayedtools!=0 && ( ! (displayedtools%20) ) )
    { lcrzo_er(lcrzo_stdin_press((language==LCRZO_GLOBAL_LANG_FR)?
				 "Pressez une touche pour continuer":
				 "Press a key to continue"));
    }
    /* display it */
    lcrzo_er(lcrzo_uint32_print("", toolnumber, "% 4u", ":"));
    printf("%s\n", title);
    lcrzo_er(lcrzo_string_free2(&title));
    /* next tool */
    toolnumber++;
    displayedtools++;
  }

  lcrzo_er(lcrzo_stdin_press((language==LCRZO_GLOBAL_LANG_FR)?
			     "Pressez une touche pour terminer":
			     "Press a key to terminate"));
  lcrzo_er(lcrzo_string_free2(&searchedstring));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_toolbox_tool_savefile(void)
{ shared_lcrzoex_infos infos;
  lcrzo_file file;
  LCRZOFILE *stream;
  lcrzo_string filename;
  lcrzo_uint32 toolnumber;
  lcrzo_int16 language;
  int ret;

  /* get the current language */
  lcrzo_epr(lcrzo_global_get_language(&language));

  /* ask user the filename */
  puts("");
  lcrzo_er(lcrzo_string_initm_text_stdin((language==LCRZO_GLOBAL_LANG_FR)?
					 "Entrez le fichier ou sauver l'information":
					 "Enter the filename where to save information",
					 (language==LCRZO_GLOBAL_LANG_FR)?
					 "listeoutilslcrzoex.txt":
					 "lcrzoextoollist.txt",
					 &filename));
  lcrzo_er(lcrzo_file_open_write(filename, LCRZO_FALSE, LCRZO_TRUE, &file));
  lcrzo_er(lcrzo_stream_init_file(&file, &stream));
  lcrzo_er(lcrzo_string_free2(&filename));

  /* main loop */
  toolnumber=1;
  while (LCRZO_TRUE)
  { /* obtain the title of this tool */
    ret=shared_toolbox__x_infos(toolnumber, &infos);
    if (ret!=LCRZO_ERR_OK) break;
    /* save it */
    lcrzo_er(shared_lcrzoex_infos_noadmcheck_fprint(stream, infos, "lcrzoex"));
    fprintf((FILE*)stream, "\n");
    /* next tool */
    toolnumber++;
  }

  lcrzo_er(lcrzo_stream_close(stream));
  lcrzo_er(lcrzo_file_close(&file));
  if (language==LCRZO_GLOBAL_LANG_FR)
  { puts("Fichier sauve");
  }
  else
  { puts("File saved");
  }
  lcrzo_er(lcrzo_stdin_press((language==LCRZO_GLOBAL_LANG_FR)?
			     "Pressez une touche pour terminer":
			     "Press a key to terminate"));
  return(LCRZO_ERR_OK);
}

