/*
		                 LCRZOEX
                             Network toolbox
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzoex.

  Lcrzoex is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  Lcrzoex is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details (http://www.gnu.org/).

------------------------------------------------------------------------
*/

#include <lcrzo.h>
#include "../lcrzoex.h"


/*-------------------------------------------------------------*/
#define SHARED_PARA_PRIV_TYPE_DEVICE          10
#define SHARED_PARA_PRIV_TYPE_DEVICE_1        'd'
#define SHARED_PARA_PRIV_TYPE_DEVICE_2        '_'
#define SHARED_PARA_PRIV_TYPE_DEVICENUMBER    11
#define SHARED_PARA_PRIV_TYPE_DEVICENUMBER_1  'd'
#define SHARED_PARA_PRIV_TYPE_DEVICENUMBER_2  'n'
#define SHARED_PARA_PRIV_TYPE_ETHS            20
#define SHARED_PARA_PRIV_TYPE_ETHS_1          'e'
#define SHARED_PARA_PRIV_TYPE_ETHS_2          '_'
#define SHARED_PARA_PRIV_TYPE_ETHRANGE        21
#define SHARED_PARA_PRIV_TYPE_ETHRANGE_1      'e'
#define SHARED_PARA_PRIV_TYPE_ETHRANGE_2      'r'
#define SHARED_PARA_PRIV_TYPE_ETHLIST         22
#define SHARED_PARA_PRIV_TYPE_ETHLIST_1       'e'
#define SHARED_PARA_PRIV_TYPE_ETHLIST_2       'l'
#define SHARED_PARA_PRIV_TYPE_HS              30
#define SHARED_PARA_PRIV_TYPE_HS_1            'h'
#define SHARED_PARA_PRIV_TYPE_HS_2            '_'
#define SHARED_PARA_PRIV_TYPE_IPS             40
#define SHARED_PARA_PRIV_TYPE_IPS_1           'i'
#define SHARED_PARA_PRIV_TYPE_IPS_2           '_'
#define SHARED_PARA_PRIV_TYPE_IPRANGE         41
#define SHARED_PARA_PRIV_TYPE_IPRANGE_1       'i'
#define SHARED_PARA_PRIV_TYPE_IPRANGE_2       'r'
#define SHARED_PARA_PRIV_TYPE_IPLIST          42
#define SHARED_PARA_PRIV_TYPE_IPLIST_1        'i'
#define SHARED_PARA_PRIV_TYPE_IPLIST_2        'l'
#define SHARED_PARA_PRIV_TYPE_PORT            50
#define SHARED_PARA_PRIV_TYPE_PORT_1          'p'
#define SHARED_PARA_PRIV_TYPE_PORT_2          '_'
#define SHARED_PARA_PRIV_TYPE_PORTRANGE       51
#define SHARED_PARA_PRIV_TYPE_PORTRANGE_1     'p'
#define SHARED_PARA_PRIV_TYPE_PORTRANGE_2     'r'
#define SHARED_PARA_PRIV_TYPE_PORTLIST        52
#define SHARED_PARA_PRIV_TYPE_PORTLIST_1      'p'
#define SHARED_PARA_PRIV_TYPE_PORTLIST_2      'l'
#define SHARED_PARA_PRIV_TYPE_UINT32          60
#define SHARED_PARA_PRIV_TYPE_UINT32_1        'n'
#define SHARED_PARA_PRIV_TYPE_UINT32_2        '_'
#define SHARED_PARA_PRIV_TYPE_STRING          70
#define SHARED_PARA_PRIV_TYPE_STRING_1        's'
#define SHARED_PARA_PRIV_TYPE_STRING_2        '_'
#define SHARED_PARA_PRIV_TYPE_PASSWD          71
#define SHARED_PARA_PRIV_TYPE_PASSWD_1        's'
#define SHARED_PARA_PRIV_TYPE_PASSWD_2        'p'


/*-------------------------------------------------------------*/
int shared_para_priv_type_get(lcrzo_uint8 c1,
			      lcrzo_uint8 c2,
			      lcrzo_int32 *ptype);
int shared_para_priv_type_get(lcrzo_uint8 c1,
			      lcrzo_uint8 c2,
			      lcrzo_int32 *ptype)
{ lcrzo_int32 type;

  if ( c1==SHARED_PARA_PRIV_TYPE_DEVICE_1 &&
       c2==SHARED_PARA_PRIV_TYPE_DEVICE_2 )
  { type=SHARED_PARA_PRIV_TYPE_DEVICE;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_DEVICENUMBER_1 &&
            c2==SHARED_PARA_PRIV_TYPE_DEVICENUMBER_2 )
  { type=SHARED_PARA_PRIV_TYPE_DEVICENUMBER;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_ETHS_1 &&
            c2==SHARED_PARA_PRIV_TYPE_ETHS_2 )
  { type=SHARED_PARA_PRIV_TYPE_ETHS;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_ETHRANGE_1 &&
            c2==SHARED_PARA_PRIV_TYPE_ETHRANGE_2 )
  { type=SHARED_PARA_PRIV_TYPE_ETHRANGE;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_ETHLIST_1 &&
            c2==SHARED_PARA_PRIV_TYPE_ETHLIST_2 )
  { type=SHARED_PARA_PRIV_TYPE_ETHLIST;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_HS_1 &&
            c2==SHARED_PARA_PRIV_TYPE_HS_2 )
  { type=SHARED_PARA_PRIV_TYPE_HS;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_IPS_1 &&
            c2==SHARED_PARA_PRIV_TYPE_IPS_2 )
  { type=SHARED_PARA_PRIV_TYPE_IPS;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_IPRANGE_1 &&
            c2==SHARED_PARA_PRIV_TYPE_IPRANGE_2 )
  { type=SHARED_PARA_PRIV_TYPE_IPRANGE;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_IPLIST_1 &&
            c2==SHARED_PARA_PRIV_TYPE_IPLIST_2 )
  { type=SHARED_PARA_PRIV_TYPE_IPLIST;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_PORT_1 &&
            c2==SHARED_PARA_PRIV_TYPE_PORT_2 )
  { type=SHARED_PARA_PRIV_TYPE_PORT;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_PORTRANGE_1 &&
            c2==SHARED_PARA_PRIV_TYPE_PORTRANGE_2 )
  { type=SHARED_PARA_PRIV_TYPE_PORTRANGE;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_PORTLIST_1 &&
            c2==SHARED_PARA_PRIV_TYPE_PORTLIST_2 )
  { type=SHARED_PARA_PRIV_TYPE_PORTLIST;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_UINT32_1 &&
            c2==SHARED_PARA_PRIV_TYPE_UINT32_2 )
  { type=SHARED_PARA_PRIV_TYPE_UINT32;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_STRING_1 &&
            c2==SHARED_PARA_PRIV_TYPE_STRING_2 )
  { type=SHARED_PARA_PRIV_TYPE_STRING;
  }
  else if ( c1==SHARED_PARA_PRIV_TYPE_PASSWD_1 &&
            c2==SHARED_PARA_PRIV_TYPE_PASSWD_2 )
  { type=SHARED_PARA_PRIV_TYPE_PASSWD;
  }
  else
  { return(LCRZOEX_ERR_PARA_UNKNOWNTYPE);
  }

  if (ptype!=NULL) *ptype=type;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_decode(lcrzo_conststring str,
			    lcrzo_int32 stroutputtype,
			    lcrzo_int32 *pinputtype,
			    lcrzo_string *pinputstr,
			    lcrzo_bool *pneedtoaskuser,
			    lcrzo_int32 *poutputtype);
int shared_para_priv_decode(lcrzo_conststring str,
			    lcrzo_int32 stroutputtype,
			    lcrzo_int32 *pinputtype,
			    lcrzo_string *pinputstr,
			    lcrzo_bool *pneedtoaskuser,
			    lcrzo_int32 *poutputtype)
{ lcrzo_string corestr;
  lcrzo_int32 corestrsize, inputtype, outputtype;
  lcrzo_int8 bracket1pos, bracket2pos;
  lcrzo_uint8 c1, c2;
  int ret;

  /* get the core string */
  lcrzo_er(lcrzo_string_initm_coretext(str, &corestr));
  corestrsize=strlen(corestr);
  
  /* check if corestr is too short ("a[]c"==4) */
  if ( corestrsize<4)
  { if (pinputtype!=NULL) *pinputtype=stroutputtype;
    if (poutputtype!=NULL) *poutputtype=stroutputtype;
    if (pneedtoaskuser!=NULL) *pneedtoaskuser=LCRZO_FALSE;
    lcrzo_er(lcrzo_string_initm_text(corestr, pinputstr));
    lcrzo_er(lcrzo_string_free2(&corestr));
    return(LCRZO_ERR_OK);
  }

  /* check if contain a '[' */
  if ( corestr[1]=='[' ) bracket1pos=1;
  else if ( corestr[2]=='[' ) bracket1pos=2;
  else bracket1pos=0;

  /* check if contain a ']' */
  if ( corestr[corestrsize-2]==']' ) bracket2pos=1;
  else if ( corestr[corestrsize-3]==']' ) bracket2pos=2;
  else bracket2pos=0;

  /* check */
  if ( bracket1pos==0 || bracket2pos==0 )
  { if (pinputtype!=NULL) *pinputtype=stroutputtype;
    if (poutputtype!=NULL) *poutputtype=stroutputtype;
    if (pneedtoaskuser!=NULL) *pneedtoaskuser=LCRZO_FALSE;
    lcrzo_er(lcrzo_string_initm_text(corestr, pinputstr));
    lcrzo_er(lcrzo_string_free2(&corestr));
    return(LCRZO_ERR_OK);
  }

  /* determine input type */
  c1=corestr[0];
  if ( bracket1pos==1 ) c2='_';
  else c2=corestr[1];

  /* check if input type is known */
  ret=shared_para_priv_type_get(c1, c2, &inputtype);
  if ( ret!=LCRZO_ERR_OK )
  { lcrzo_er(lcrzo_string_free2(&corestr));
    return(ret);
  }

  /* determine output type */
  if ( bracket2pos==1 ) 
  { c1=corestr[corestrsize-1];
    c2='_';
  }
  else
  { c1=corestr[corestrsize-2];
    c2=corestr[corestrsize-1];
  }

  /* check if output type is known */
  ret=shared_para_priv_type_get(c1, c2, &outputtype);
  if ( ret!=LCRZO_ERR_OK )
  { lcrzo_er(lcrzo_string_free2(&corestr));
    return(ret);
  }

  /* set output parameters */
  lcrzo_er(lcrzo_string_initm_data((lcrzo_data)(corestr+bracket1pos+1),
				   corestrsize-bracket1pos-bracket2pos-2,
				   pinputstr));  
  if (pinputtype!=NULL) *pinputtype=inputtype;
  if (poutputtype!=NULL) *poutputtype=outputtype;
  if (pneedtoaskuser!=NULL)
  { if (corestrsize-bracket1pos-bracket2pos-2==0)
      *pneedtoaskuser=LCRZO_TRUE;
    else
      *pneedtoaskuser=LCRZO_FALSE;
  }
  lcrzo_er(lcrzo_string_free2(&corestr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_device(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr);
int shared_para_priv_convert_device(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr)
{ lcrzo_device devicepos;
  lcrzo_etha etha;
  lcrzo_eths eths;
  lcrzo_ipl ipl;
  lcrzo_hs hs;
  lcrzo_ips ips;
  lcrzo_int32 i, count;
  lcrzo_bool deviceequal;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, devicepos, NULL, NULL, NULL,
					    NULL, NULL, NULL, NULL,
					    NULL, NULL));
      lcrzo_er(lcrzo_device_equal2(inputstr, devicepos, &deviceequal));
      if ( deviceequal )
      { lcrzo_er(lcrzo_string_initm_int32(i, "%d", poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);

  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_etha_init_device(inputstr, etha));
    lcrzo_er(lcrzo_eths_init_etha(etha, eths));
    lcrzo_er(lcrzo_string_initm_text(eths, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS )
  { lcrzo_er(lcrzo_ipl_init_device(inputstr, &ipl, NULL));
    lcrzo_er(lcrzo_hs_init_ipl(ipl, hs));
    lcrzo_er(lcrzo_string_initm_text(hs, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_ipl_init_device(inputstr, &ipl, NULL));
    lcrzo_er(lcrzo_ips_init_ipl(ipl, ips));
    lcrzo_er(lcrzo_string_initm_text(ips, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32  )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_devicenumber(lcrzo_conststring inputstr,
					  lcrzo_int32 outputtype,
					  lcrzo_string *poutputstr);
int shared_para_priv_convert_devicenumber(lcrzo_conststring inputstr,
					  lcrzo_int32 outputtype,
					  lcrzo_string *poutputstr)
{ lcrzo_device devicepos;
  lcrzo_etha etha;
  lcrzo_eths eths;
  lcrzo_ipl ipl;
  lcrzo_hs hs;
  lcrzo_ips ips;
  lcrzo_int32 i;
  lcrzo_uint32 iu32;
    
  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { lcrzo_er(lcrzo_int32_init_text(inputstr, &i));
    lcrzo_er(lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_ALL, i, devicepos));
    lcrzo_er(lcrzo_string_initm_text(devicepos, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_int32_init_text(inputstr, &i));
    lcrzo_er(lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_ALL, i, devicepos));
    lcrzo_er(lcrzo_etha_init_device(devicepos, etha));
    lcrzo_er(lcrzo_eths_init_etha(etha, eths));
    lcrzo_er(lcrzo_string_initm_text(eths, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS )
  { lcrzo_er(lcrzo_int32_init_text(inputstr, &i));
    lcrzo_er(lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_ALL, i, devicepos));
    lcrzo_er(lcrzo_ipl_init_device(devicepos, &ipl, NULL));
    lcrzo_er(lcrzo_hs_init_ipl(ipl, hs));
    lcrzo_er(lcrzo_string_initm_text(hs, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_int32_init_text(inputstr, &i));
    lcrzo_er(lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_ALL, i, devicepos));
    lcrzo_er(lcrzo_ipl_init_device(devicepos, &ipl, NULL));
    lcrzo_er(lcrzo_ips_init_ipl(ipl, ips));
    lcrzo_er(lcrzo_string_initm_text(ips, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { lcrzo_er(lcrzo_uint32_init_text(inputstr, &iu32));
    lcrzo_er(lcrzo_string_initm_uint32(iu32, "%u", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_eths(lcrzo_conststring inputstr,
				  lcrzo_int32 outputtype,
				  lcrzo_string *poutputstr);
int shared_para_priv_convert_eths(lcrzo_conststring inputstr,
				  lcrzo_int32 outputtype,
				  lcrzo_string *poutputstr)
{ lcrzo_device devicepos;
  lcrzo_etha etha, ethapos;
  lcrzo_hs hs;
  lcrzo_ips ips;
  lcrzo_int32 i, count;
  lcrzo_int16 hwtype;
  lcrzo_bool ethequal;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { lcrzo_er(lcrzo_etha_init_eths(inputstr, etha));
    lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, devicepos, &hwtype, 
					    ethapos, NULL, NULL,
					    NULL, NULL, NULL, NULL, NULL));
      lcrzo_er(lcrzo_etha_equal2(ethapos, etha, &ethequal));
      if ( ethequal && hwtype==LCRZO_DEVICE_HWTYPE_ETHER )
      { lcrzo_er(lcrzo_string_initm_text(devicepos, poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(lcrzo_etha_init_eths(inputstr, etha));
    lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, NULL, &hwtype,
					    ethapos, NULL, NULL,
					    NULL, NULL, NULL, NULL, NULL));
      lcrzo_er(lcrzo_etha_equal2(ethapos, etha, &ethequal));
      if ( ethequal && hwtype==LCRZO_DEVICE_HWTYPE_ETHER )
      { lcrzo_er(lcrzo_string_initm_int32(i, "%d", poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE || 
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS )
  { lcrzo_er(lcrzo_hs_init_eths(inputstr, hs));
    lcrzo_er(lcrzo_string_initm_text(hs, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_ips_init_eths(inputstr, ips));
    lcrzo_er(lcrzo_string_initm_text(ips, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING || 
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_ethrange(lcrzo_conststring inputstr,
				      lcrzo_int32 outputtype,
				      lcrzo_string *poutputstr);
int shared_para_priv_convert_ethrange(lcrzo_conststring inputstr,
				      lcrzo_int32 outputtype,
				      lcrzo_string *poutputstr)
{ lcrzo_list ethlist, iplist;
  lcrzo_etha etha;  
  lcrzo_ipl ipl;
  int ret;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { ret=lcrzo_ethlist_init_text(inputstr, &ethlist);
    if (ret==LCRZO_ERR_OK)
    { ret=lcrzo_iplist_init(&iplist);
      if (ret==LCRZO_ERR_OK)
      { ret=lcrzo_ethlist_value_first(&ethlist, etha);
        if (ret==LCRZO_ERR_OK)
	{ ret=lcrzo_ipl_init_etha(etha, &ipl);
          if (ret==LCRZO_ERR_OK)
	  { ret=lcrzo_iplist_add_range(&iplist, ipl, ipl);
	    if (ret==LCRZO_ERR_OK)
	    { while (ret==LCRZO_ERR_OK)
	      { ret=lcrzo_ethlist_value_next(&ethlist, etha, etha);
	        if (ret==LCRZO_ERR_OKDATAEND)
	        { ret=LCRZO_ERR_OK;
		  break;
		}
	        if (ret==LCRZO_ERR_OK)
		{ ret=lcrzo_ipl_init_etha(etha, &ipl);
		  if (ret==LCRZO_ERR_OK)
		  { ret=lcrzo_iplist_add_range(&iplist, ipl, ipl);
		  }
		}
	      }
	    }
	  }
	}
	if (ret==LCRZO_ERR_OK)
	{ lcrzo_er(lcrzo_string_initm_iplist(&iplist, poutputstr));
	}
	lcrzo_er(lcrzo_list_close(&iplist));
      }
      lcrzo_er(lcrzo_list_close(&ethlist));
    }
    return(ret);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING || 
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_ethlist(lcrzo_conststring inputstr,
				     lcrzo_int32 outputtype,
				     lcrzo_string *poutputstr);
int shared_para_priv_convert_ethlist(lcrzo_conststring inputstr,
				     lcrzo_int32 outputtype,
				     lcrzo_string *poutputstr)
{ lcrzo_list ethlist, iplist;
  lcrzo_etha etha;  
  lcrzo_ipl ipl;
  int ret;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { ret=lcrzo_ethlist_init_text(inputstr, &ethlist);
    if (ret==LCRZO_ERR_OK)
    { ret=lcrzo_iplist_init(&iplist);
      if (ret==LCRZO_ERR_OK)
      { ret=lcrzo_ethlist_value_first(&ethlist, etha);
        if (ret==LCRZO_ERR_OK)
	{ ret=lcrzo_ipl_init_etha(etha, &ipl);
          if (ret==LCRZO_ERR_OK)
	  { ret=lcrzo_iplist_add_range(&iplist, ipl, ipl);
	    if (ret==LCRZO_ERR_OK)
	    { while (ret==LCRZO_ERR_OK)
	      { ret=lcrzo_ethlist_value_next(&ethlist, etha, etha);
	        if (ret==LCRZO_ERR_OKDATAEND)
	        { ret=LCRZO_ERR_OK;
		  break;
		}
	        if (ret==LCRZO_ERR_OK)
		{ ret=lcrzo_ipl_init_etha(etha, &ipl);
		  if (ret==LCRZO_ERR_OK)
		  { ret=lcrzo_iplist_add_range(&iplist, ipl, ipl);
		  }
		}
	      }
	    }
	  }
	}
	if (ret==LCRZO_ERR_OK)
	{ lcrzo_er(lcrzo_string_initm_iplist(&iplist, poutputstr));
	}
	lcrzo_er(lcrzo_list_close(&iplist));
      }
      lcrzo_er(lcrzo_list_close(&ethlist));
    }
    return(ret);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING || 
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_hs(lcrzo_conststring inputstr,
				lcrzo_int32 outputtype,
				lcrzo_string *poutputstr);
int shared_para_priv_convert_hs(lcrzo_conststring inputstr,
				lcrzo_int32 outputtype,
				lcrzo_string *poutputstr)
{ lcrzo_device devicepos;
  lcrzo_eths eths;
  lcrzo_ips ips;
  lcrzo_ipl ipl, iplpos;
  lcrzo_int32 i, count;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { lcrzo_er(lcrzo_ipl_init_hs(inputstr, &ipl));
    lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, devicepos, NULL, NULL, 
					    &iplpos, NULL,
					    NULL, NULL, NULL, NULL, NULL));
      if ( iplpos==ipl )
      { lcrzo_er(lcrzo_string_initm_text(devicepos, poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(lcrzo_ipl_init_hs(inputstr, &ipl));
    lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, devicepos, NULL, NULL, 
					    &iplpos, NULL,
					    NULL, NULL, NULL, NULL, NULL));
      if ( iplpos==ipl )
      { lcrzo_er(lcrzo_string_initm_int32(i, "%d", poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_eths_init_hs(inputstr, eths));
    lcrzo_er(lcrzo_string_initm_text(eths, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_ips_init_hs(inputstr, ips));
    lcrzo_er(lcrzo_string_initm_text(ips, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32)
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_ips(lcrzo_conststring inputstr,
				 lcrzo_int32 outputtype,
				 lcrzo_string *poutputstr);
int shared_para_priv_convert_ips(lcrzo_conststring inputstr,
				 lcrzo_int32 outputtype,
				 lcrzo_string *poutputstr)
{ lcrzo_device devicepos;
  lcrzo_eths eths;
  lcrzo_hs hs;
  lcrzo_ipl ipl, iplpos;
  lcrzo_int32 i, count;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { lcrzo_er(lcrzo_ipl_init_ips(inputstr, &ipl));
    lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, devicepos, NULL, NULL,
					    &iplpos, NULL,
					    NULL, NULL, NULL, NULL, NULL));
      if ( iplpos==ipl )
      { lcrzo_er(lcrzo_string_initm_text(devicepos, poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(lcrzo_ipl_init_ips(inputstr, &ipl));
    lcrzo_er(lcrzo_conf_devices_count(&count));
    for ( i=1 ; i<=count ; i++ )
    { lcrzo_er(lcrzo_conf_devices_value_pos(i, devicepos, NULL, NULL,
					    &iplpos, NULL,
					    NULL, NULL, NULL, NULL, NULL));
      if ( iplpos==ipl )
      { lcrzo_er(lcrzo_string_initm_int32(i, "%d", poutputstr));
        return(LCRZO_ERR_OK);
      } 
    } 
    return(LCRZO_ERR_OKUNRESOLVED);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_eths_init_ips(inputstr, eths));
    lcrzo_er(lcrzo_string_initm_text(eths, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS )
  { lcrzo_er(lcrzo_hs_init_ips(inputstr, hs));
    lcrzo_er(lcrzo_string_initm_text(hs, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPS )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32)
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_iprange(lcrzo_conststring inputstr,
				     lcrzo_int32 outputtype,
				     lcrzo_string *poutputstr);
int shared_para_priv_convert_iprange(lcrzo_conststring inputstr,
				     lcrzo_int32 outputtype,
				     lcrzo_string *poutputstr)
{ lcrzo_list ethlist, iplist;
  lcrzo_etha etha;  
  lcrzo_ipl ipl;
  int ret;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { ret=lcrzo_iplist_init_text(inputstr, &iplist);
    if (ret==LCRZO_ERR_OK)
    { ret=lcrzo_ethlist_init(&ethlist);
      if (ret==LCRZO_ERR_OK)
      { ret=lcrzo_iplist_value_first(&iplist, &ipl);
        if (ret==LCRZO_ERR_OK)
	{ ret=lcrzo_etha_init_ipl(ipl, etha);
          if (ret==LCRZO_ERR_OK)
	  { ret=lcrzo_ethlist_add_range(&ethlist, etha, etha);
	    if (ret==LCRZO_ERR_OK)
	    { while (ret==LCRZO_ERR_OK)
	      { ret=lcrzo_iplist_value_next(&iplist, ipl, &ipl);
	        if (ret==LCRZO_ERR_OKDATAEND)
	        { ret=LCRZO_ERR_OK;
		  break;
		}
	        if (ret==LCRZO_ERR_OK)
		{ ret=lcrzo_etha_init_ipl(ipl, etha);
		  if (ret==LCRZO_ERR_OK)
		  { ret=lcrzo_ethlist_add_range(&ethlist, etha, etha);
		  }
		}
	      }
	    }
	  }
	}
	if (ret==LCRZO_ERR_OK)
	{ lcrzo_er(lcrzo_string_initm_ethlist(&ethlist, poutputstr));
	}
	lcrzo_er(lcrzo_list_close(&ethlist));
      }
      lcrzo_er(lcrzo_list_close(&iplist));
    }
    return(ret);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPS )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32)
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_iplist(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr);
int shared_para_priv_convert_iplist(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr)
{ lcrzo_list ethlist, iplist;
  lcrzo_etha etha;  
  lcrzo_ipl ipl;
  int ret;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { ret=lcrzo_iplist_init_text(inputstr, &iplist);
    if (ret==LCRZO_ERR_OK)
    { ret=lcrzo_ethlist_init(&ethlist);
      if (ret==LCRZO_ERR_OK)
      { ret=lcrzo_iplist_value_first(&iplist, &ipl);
        if (ret==LCRZO_ERR_OK)
	{ ret=lcrzo_etha_init_ipl(ipl, etha);
          if (ret==LCRZO_ERR_OK)
	  { ret=lcrzo_ethlist_add_range(&ethlist, etha, etha);
	    if (ret==LCRZO_ERR_OK)
	    { while (ret==LCRZO_ERR_OK)
	      { ret=lcrzo_iplist_value_next(&iplist, ipl, &ipl);
	        if (ret==LCRZO_ERR_OKDATAEND)
	        { ret=LCRZO_ERR_OK;
		  break;
		}
	        if (ret==LCRZO_ERR_OK)
		{ ret=lcrzo_etha_init_ipl(ipl, etha);
		  if (ret==LCRZO_ERR_OK)
		  { ret=lcrzo_ethlist_add_range(&ethlist, etha, etha);
		  }
		}
	      }
	    }
	  }
	}
	if (ret==LCRZO_ERR_OK)
	{ lcrzo_er(lcrzo_string_initm_ethlist(&ethlist, poutputstr));
	}
	lcrzo_er(lcrzo_list_close(&ethlist));
      }
      lcrzo_er(lcrzo_list_close(&iplist));
    }
    return(ret);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32)
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_port(lcrzo_conststring inputstr,
				  lcrzo_int32 outputtype,
				  lcrzo_string *poutputstr);
int shared_para_priv_convert_port(lcrzo_conststring inputstr,
				  lcrzo_int32 outputtype,
				  lcrzo_string *poutputstr)
{ lcrzo_uint16 i;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST||
       outputtype==SHARED_PARA_PRIV_TYPE_HS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
	    outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { lcrzo_er(lcrzo_uint16_init_text(inputstr, &i));
    lcrzo_er(lcrzo_string_initm_uint16(i, "%u", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_portrange(lcrzo_conststring inputstr,
				       lcrzo_int32 outputtype,
				       lcrzo_string *poutputstr);
int shared_para_priv_convert_portrange(lcrzo_conststring inputstr,
				       lcrzo_int32 outputtype,
				       lcrzo_string *poutputstr)
{ 
  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST||
       outputtype==SHARED_PARA_PRIV_TYPE_HS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPLIST ||
       outputtype==SHARED_PARA_PRIV_TYPE_PORT )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_portlist(lcrzo_conststring inputstr,
				      lcrzo_int32 outputtype,
				      lcrzo_string *poutputstr);
int shared_para_priv_convert_portlist(lcrzo_conststring inputstr,
				      lcrzo_int32 outputtype,
				      lcrzo_string *poutputstr)
{ 
  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST||
       outputtype==SHARED_PARA_PRIV_TYPE_HS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPLIST ||
       outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
       outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_uint32(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr);
int shared_para_priv_convert_uint32(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr)
{ lcrzo_int32 i32;
  lcrzo_uint16 ui16;

  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(lcrzo_int32_init_text(inputstr, &i32));
    lcrzo_er(lcrzo_string_initm_int32(i32, "%d", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST||
	    outputtype==SHARED_PARA_PRIV_TYPE_HS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { return(LCRZOEX_ERR_PARA_CANTCONVERT);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST )
  { lcrzo_er(lcrzo_uint16_init_text(inputstr, &ui16));
    lcrzo_er(lcrzo_string_initm_uint16(ui16, "%u", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { return(LCRZO_ERR_IEINTERNALERROR);
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
	    outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_string(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr);
int shared_para_priv_convert_string(lcrzo_conststring inputstr,
				    lcrzo_int32 outputtype,
				    lcrzo_string *poutputstr)
{ 
  /* convert depending on the type*/
  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE ||
       outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHS ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST||
       outputtype==SHARED_PARA_PRIV_TYPE_HS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPS ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_IPLIST ||
       outputtype==SHARED_PARA_PRIV_TYPE_PORT ||
       outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE ||
       outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST ||
       outputtype==SHARED_PARA_PRIV_TYPE_UINT32 ||
       outputtype==SHARED_PARA_PRIV_TYPE_STRING ||
       outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
  }
  else
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert(lcrzo_int32 inputtype,
			     lcrzo_conststring inputstr,
			     lcrzo_int32 outputtype,
			     lcrzo_string *poutputstr);
int shared_para_priv_convert(lcrzo_int32 inputtype,
			     lcrzo_conststring inputstr,
			     lcrzo_int32 outputtype,
			     lcrzo_string *poutputstr)
{
  /*
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", "\n"));
  printf("inputstr=%sZZ\n", inputstr);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  */
  /* special case */
  if ( inputtype==outputtype )
  { lcrzo_er(lcrzo_string_initm_text(inputstr, poutputstr));
    return(LCRZO_ERR_OK);
  }

  /* convert depending on the type*/
  if ( inputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { lcrzo_er(shared_para_priv_convert_device(inputstr, outputtype,
					     poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(shared_para_priv_convert_devicenumber(inputstr, outputtype,
						   poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_ETHS )
  { lcrzo_er(shared_para_priv_convert_eths(inputstr, outputtype,
					   poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE )
  { lcrzo_er(shared_para_priv_convert_ethrange(inputstr, outputtype,
					       poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(shared_para_priv_convert_ethlist(inputstr, outputtype,
					      poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_HS )
  { lcrzo_er(shared_para_priv_convert_hs(inputstr, outputtype,
					 poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_IPS )
  { lcrzo_er(shared_para_priv_convert_ips(inputstr, outputtype,
					  poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_IPRANGE )
  { lcrzo_er(shared_para_priv_convert_iprange(inputstr, outputtype,
					      poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(shared_para_priv_convert_iplist(inputstr, outputtype,
					     poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_PORT )
  { lcrzo_er(shared_para_priv_convert_port(inputstr, outputtype,
					   poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE )
  { lcrzo_er(shared_para_priv_convert_portrange(inputstr, outputtype,
						poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_PORTLIST )
  { lcrzo_er(shared_para_priv_convert_portlist(inputstr, outputtype,
					       poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { lcrzo_er(shared_para_priv_convert_uint32(inputstr, outputtype,
					     poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_STRING )
  { lcrzo_er(shared_para_priv_convert_string(inputstr, outputtype,
					     poutputstr));
  }
  else if ( inputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(shared_para_priv_convert_string(inputstr, outputtype,
					     poutputstr));
  }
  else 
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_stdin(lcrzo_conststring message,
			   lcrzo_int32 outputtype,
			   lcrzo_conststring defaultstr,
			   lcrzo_uint32 minvalue,
			   lcrzo_uint32 maxvalue,
			   lcrzo_uint32 defaultnumber,
			   lcrzo_string *poutputstr);
int shared_para_priv_stdin(lcrzo_conststring message,
			   lcrzo_int32 outputtype,
			   lcrzo_conststring defaultstr,
			   lcrzo_uint32 minvalue,
			   lcrzo_uint32 maxvalue,
			   lcrzo_uint32 defaultnumber,
			   lcrzo_string *poutputstr)
{ lcrzo_device device;
  lcrzo_eths eths;
  lcrzo_hs hs;
  lcrzo_ips ips;
  lcrzo_uint32 u, devcount;
  lcrzo_ethrange ethrange;
  lcrzo_list list;
  lcrzo_iprange iprange;
  lcrzo_portrange portrange;
  lcrzo_uint16 minport, maxport, defaultport, p;

  if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICE )
  { lcrzo_er(lcrzo_device_init_stdin(message, defaultstr, device));
    lcrzo_er(lcrzo_string_initm_text(device, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_DEVICENUMBER )
  { lcrzo_er(lcrzo_conf_devices_count((lcrzo_int32*)&devcount));
    if (defaultnumber>devcount) defaultnumber=1;
    if (defaultnumber==0) defaultnumber=1;
    lcrzo_er(lcrzo_uint32_init_stdin(message, 1, devcount, 
				     defaultnumber, &u));
    lcrzo_er(lcrzo_string_initm_uint32(u, "%u", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHS )
  { lcrzo_er(lcrzo_eths_init_stdin(message, defaultstr, eths));
    lcrzo_er(lcrzo_string_initm_text(eths, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHRANGE )
  { lcrzo_er(lcrzo_ethrange_init_stdin(message, defaultstr, ethrange));
    lcrzo_er(lcrzo_string_initm_text(ethrange, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_ETHLIST )
  { lcrzo_er(lcrzo_ethlist_init_stdin(message, defaultstr, &list));
    lcrzo_er(lcrzo_string_initm_ethlist(&list, poutputstr));
    lcrzo_er(lcrzo_list_close(&list));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_HS )
  { lcrzo_er(lcrzo_hs_init_stdin(message, defaultstr, hs));
    lcrzo_er(lcrzo_string_initm_text(hs, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPS )
  { lcrzo_er(lcrzo_ips_init_stdin(message, defaultstr, ips));
    lcrzo_er(lcrzo_string_initm_text(ips, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPRANGE )
  { lcrzo_er(lcrzo_iprange_init_stdin(message, defaultstr, iprange));
    lcrzo_er(lcrzo_string_initm_text(iprange, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_IPLIST )
  { lcrzo_er(lcrzo_iplist_init_stdin(message, defaultstr, &list));
    lcrzo_er(lcrzo_string_initm_iplist(&list, poutputstr));
    lcrzo_er(lcrzo_list_close(&list));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORT )
  { if (minvalue>0xFFFFu) minport=0;
    else minport=(lcrzo_uint16)minvalue;
    if (maxvalue>0xFFFFu) maxport=0;
    else maxport=(lcrzo_uint16)maxvalue;
    if (defaultnumber>0xFFFFu) defaultport=minport;
    else defaultport=(lcrzo_uint16)defaultnumber;
    lcrzo_er(lcrzo_uint16_init_stdin(message, minport, maxport, 
				     defaultport, &p));
    lcrzo_er(lcrzo_string_initm_uint16(p, "%u", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORTRANGE )
  { lcrzo_er(lcrzo_portrange_init_stdin(message, defaultstr, portrange));
    lcrzo_er(lcrzo_string_initm_text(portrange, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PORTLIST )
  { lcrzo_er(lcrzo_portlist_init_stdin(message, defaultstr, &list));
    lcrzo_er(lcrzo_string_initm_portlist(&list, poutputstr));
    lcrzo_er(lcrzo_list_close(&list));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_UINT32 )
  { lcrzo_er(lcrzo_uint32_init_stdin(message, minvalue, maxvalue, 
				     defaultnumber, &u));
    lcrzo_er(lcrzo_string_initm_uint32(u, "%u", poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_STRING )
  { lcrzo_er(lcrzo_string_initm_text_stdin(message, defaultstr, poutputstr));
  }
  else if ( outputtype==SHARED_PARA_PRIV_TYPE_PASSWD )
  { lcrzo_er(lcrzo_string_initm_text_passwd(message, defaultstr, poutputstr));
  }
  else 
  { return(LCRZO_ERR_IEINTERNALERROR);
  }

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_statemachine(lcrzo_conststring str,
				  lcrzo_int32 stroutputtype,
				  lcrzo_conststring message,
				  lcrzo_conststring defaultstr,
				  lcrzo_uint32 minvalue,
				  lcrzo_uint32 maxvalue,
				  lcrzo_uint32 defaultnumber,
				  lcrzo_string *poutputstr);
int shared_para_priv_statemachine(lcrzo_conststring str,
				  lcrzo_int32 stroutputtype,
				  lcrzo_conststring message,
				  lcrzo_conststring defaultstr,
				  lcrzo_uint32 minvalue,
				  lcrzo_uint32 maxvalue,
				  lcrzo_uint32 defaultnumber,
				  lcrzo_string *poutputstr)
{ lcrzo_int32 a, c, d, f;
  lcrzo_string b, e, defaut, user;
  lcrzo_bool needtoaskuser;
  int ret;

  /* first, decode the string "a[b]c" */
  lcrzo_er(shared_para_priv_decode(str, stroutputtype, &a, &b,
				   &needtoaskuser, &c));

  /* c must correspond */
  if ( c!=stroutputtype )
  { lcrzo_er(lcrzo_string_free2(&b));
    return(LCRZOEX_ERR_PARA_BADOUTPUTTYPE);
  }

  /* no ask to user */
  if (!needtoaskuser)
  { ret=shared_para_priv_convert(a, b, c, poutputstr);
    lcrzo_er(lcrzo_string_free2(&b));
    return(ret);
  }
  lcrzo_er(lcrzo_string_free2(&b));

  /* decode the default string "d[e]f" */
  if (defaultstr!=NULL)
  { lcrzo_er(shared_para_priv_decode(defaultstr, stroutputtype, &d, &e, 
				     &needtoaskuser, &f));
    if (!needtoaskuser)
    { ret=shared_para_priv_convert(d, e, a, &defaut);
      if (ret!=LCRZO_ERR_OK)
      { ret=lcrzo_string_initm_text("", &defaut);
      }
    }
    else
    { ret=lcrzo_string_initm_text("", &defaut);
    }
    lcrzo_er(lcrzo_string_free2(&e));
    lcrzo_er(ret);
    /* ask user */
    ret=shared_para_priv_stdin(message, a, defaut, minvalue, maxvalue,
			       defaultnumber, &user);
    lcrzo_er(lcrzo_string_free2(&defaut));
  }
  else
  { ret=shared_para_priv_stdin(message, a, NULL, minvalue, maxvalue,
			       defaultnumber, &user);
  }
  lcrzo_er(ret);

  /* set output */
  ret=shared_para_priv_convert(a, user, c, poutputstr);
  lcrzo_er(lcrzo_string_free2(&user));

  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_device_init(lcrzo_conststring userstr,
			    lcrzo_conststring message,
			    lcrzo_conststring defaultstr,
			    lcrzo_device deviceout)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr, SHARED_PARA_PRIV_TYPE_DEVICE,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_device_init(outputstr, deviceout);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_etha_init(lcrzo_conststring userstr,
			  lcrzo_conststring message,
			  lcrzo_conststring defaultstr,
			  lcrzo_etha ethaout)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr, SHARED_PARA_PRIV_TYPE_ETHS,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_etha_init_eths(outputstr, ethaout);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_ethrange_init(lcrzo_conststring userstr,
			      lcrzo_conststring message,
			      lcrzo_conststring defaultstr,
			      lcrzo_ethrange ethrange)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr,
					 SHARED_PARA_PRIV_TYPE_ETHRANGE,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_string_init_text(outputstr, LCRZO_ETHRANGE_MAXBYTES, ethrange);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_ethlist_init(lcrzo_conststring userstr,
			     lcrzo_conststring message,
			     lcrzo_conststring defaultstr,
			     lcrzo_string *pethliststr)
{ 
  lcrzo_er(shared_para_priv_statemachine(userstr, 
					 SHARED_PARA_PRIV_TYPE_ETHLIST,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 pethliststr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_hs_init(lcrzo_conststring userstr,
			lcrzo_conststring message,
			lcrzo_conststring defaultstr,
			lcrzo_hs hsout)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr, SHARED_PARA_PRIV_TYPE_HS,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_hs_init(outputstr, hsout);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_ipl_init(lcrzo_conststring userstr,
			 lcrzo_conststring message,
			 lcrzo_conststring defaultstr,
			 lcrzo_ipl *pipl)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr, SHARED_PARA_PRIV_TYPE_HS,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_ipl_init_hs(outputstr, pipl);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_iprange_init(lcrzo_conststring userstr,
			     lcrzo_conststring message,
			     lcrzo_conststring defaultstr,
			     lcrzo_iprange iprange)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr,
					 SHARED_PARA_PRIV_TYPE_IPRANGE,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_string_init_text(outputstr, LCRZO_IPRANGE_MAXBYTES, iprange);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_iplist_init(lcrzo_conststring userstr,
			    lcrzo_conststring message,
			    lcrzo_conststring defaultstr,
			    lcrzo_string *pipliststr)
{ 
  lcrzo_er(shared_para_priv_statemachine(userstr, 
					 SHARED_PARA_PRIV_TYPE_IPLIST,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 pipliststr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_port_init(lcrzo_conststring userstr,
			  lcrzo_conststring message,
			  lcrzo_uint16 minport,
			  lcrzo_uint16 maxport,
			  lcrzo_uint16 defaultport,
			  lcrzo_uint16 *pport)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr, 
					 SHARED_PARA_PRIV_TYPE_PORT,
					 message, "", minport, maxport,
					 defaultport, &outputstr));
  ret=lcrzo_uint16_init_text(outputstr, pport);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_portrange_init(lcrzo_conststring userstr,
			       lcrzo_conststring message,
			       lcrzo_conststring defaultstr,
			       lcrzo_portrange portrange)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr,
					 SHARED_PARA_PRIV_TYPE_IPRANGE,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 &outputstr));
  ret=lcrzo_string_init_text(outputstr, LCRZO_PORTRANGE_MAXBYTES, portrange);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_portlist_init(lcrzo_conststring userstr,
			      lcrzo_conststring message,
			      lcrzo_conststring defaultstr,
			      lcrzo_string *pportliststr)
{ 
  lcrzo_er(shared_para_priv_statemachine(userstr, 
					 SHARED_PARA_PRIV_TYPE_PORTLIST,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 pportliststr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint32_init(lcrzo_conststring userstr,
			    lcrzo_conststring message,
			    lcrzo_uint32 minvalue,
			    lcrzo_uint32 maxvalue,
			    lcrzo_uint32 defaultnumber,
			    lcrzo_uint32 *pnumber)
{ lcrzo_string outputstr;
  int ret;

  lcrzo_er(shared_para_priv_statemachine(userstr, SHARED_PARA_PRIV_TYPE_UINT32,
					 message, "", minvalue, maxvalue,
					 defaultnumber, &outputstr));
  ret=lcrzo_uint32_init_text(outputstr, pnumber);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  return(ret);
}

/*-------------------------------------------------------------*/
int shared_para_string_init(lcrzo_conststring userstr,
			    lcrzo_conststring message,
			    lcrzo_conststring defaultstr,
			    lcrzo_string *pstr)
{ 
  lcrzo_er(shared_para_priv_statemachine(userstr, 
					 SHARED_PARA_PRIV_TYPE_STRING,
					 message, defaultstr, 0,0xFFFFFFFFu,0,
					 pstr));
  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
int shared_para_int32_init(lcrzo_conststring userstr,
			   lcrzo_conststring message,
			   lcrzo_int32 minvalue,
			   lcrzo_int32 maxvalue,
			   lcrzo_int32 defaultnumber,
			   lcrzo_int32 *pnumber)
{ lcrzo_uint32 number;

  lcrzo_er(shared_para_uint32_init(userstr, message,
				   minvalue, maxvalue, defaultnumber,&number));
  if (pnumber!=NULL) *pnumber=(lcrzo_int32)number;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint16_init(lcrzo_conststring userstr,
			    lcrzo_conststring message,
			    lcrzo_uint16 minvalue,
			    lcrzo_uint16 maxvalue,
			    lcrzo_uint16 defaultnumber,
			    lcrzo_uint16 *pnumber)
{ lcrzo_uint32 number;

  lcrzo_er(shared_para_uint32_init(userstr, message,
				   minvalue, maxvalue, defaultnumber,&number));
  if (pnumber!=NULL) *pnumber=(lcrzo_uint16)number;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_int16_init(lcrzo_conststring userstr,
			   lcrzo_conststring message,
			   lcrzo_int16 minvalue,
			   lcrzo_int16 maxvalue,
			   lcrzo_int16 defaultnumber,
			   lcrzo_int16 *pnumber)
{ lcrzo_uint32 number;

  lcrzo_er(shared_para_uint32_init(userstr, message,
				   minvalue, maxvalue, defaultnumber,&number));
  if (pnumber!=NULL) *pnumber=(lcrzo_int16)number;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint8_init(lcrzo_conststring userstr,
			   lcrzo_conststring message,
			   lcrzo_uint8 minvalue,
			   lcrzo_uint8 maxvalue,
			   lcrzo_uint8 defaultnumber,
			   lcrzo_uint8 *pnumber)
{ lcrzo_uint32 number;

  lcrzo_er(shared_para_uint32_init(userstr, message,
				   minvalue, maxvalue, defaultnumber,&number));
  if (pnumber!=NULL) *pnumber=(lcrzo_uint8)number;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_int8_init(lcrzo_conststring userstr,
			  lcrzo_conststring message,
			  lcrzo_int8 minvalue,
			  lcrzo_int8 maxvalue,
			  lcrzo_int8 defaultnumber,
			  lcrzo_int8 *pnumber)
{ lcrzo_uint32 number;

  lcrzo_er(shared_para_uint32_init(userstr, message,
				   minvalue, maxvalue, defaultnumber,&number));
  if (pnumber!=NULL) *pnumber=(lcrzo_int8)number;
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_bool_init(lcrzo_conststring userstr,
			  lcrzo_conststring message,
			  lcrzo_bool defaultnumber,
			  lcrzo_bool *pnumber)
{ lcrzo_uint32 number;

  lcrzo_er(shared_para_uint32_init(userstr, message,
				   LCRZO_FALSE, LCRZO_TRUE, defaultnumber,
				   &number));
  if (pnumber!=NULL) *pnumber=(lcrzo_bool)number;
  return(LCRZO_ERR_OK);
}


/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
int shared_para_device_init_src(lcrzo_conststring userstr,
				lcrzo_device device)
{ lcrzo_device dev;
  lcrzo_int16 language;
  int ret;

  lcrzo_er(lcrzo_global_get_language(&language));
  ret=lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_BEST, 1, dev);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_er(lcrzo_device_initdefault(dev));
  }
  ret=shared_para_device_init(userstr, 
			      ( language==LCRZO_GLOBAL_LANG_FR )?
			      "Choisissez un device":
			      "Choose a device",
			      dev, device);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_device_init_listen(lcrzo_conststring userstr,
				   lcrzo_device device)
{ lcrzo_device dev;
  lcrzo_int16 language;
  int ret;

  lcrzo_er(lcrzo_global_get_language(&language));
  ret=lcrzo_device_value_pos(LCRZO_DEVICE_TYPE_BEST, 1, dev);
  if (ret!=LCRZO_ERR_OK)
  { lcrzo_er(lcrzo_device_initdefault(dev));
  }
  ret=shared_para_device_init(userstr, 
			      ( language==LCRZO_GLOBAL_LANG_FR )?
			      "Choisissez un device":
			      "Choose a device",
			      dev, device);
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_etha_init_src(lcrzo_conststring userstr,
			      lcrzo_etha etha)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_etha_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez l'adresse Ethernet source":
				 "Choose source Ethernet address",
				 "aa:aa:aa:aa:aa:aa", 
				 etha));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_etha_init_dst(lcrzo_conststring userstr,
			      lcrzo_etha etha)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_etha_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez l'adresse Ethernet destination":
				 "Choose destination Ethernet address",
				 "bb:bb:bb:bb:bb:bb", 
				 etha));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_etha_init_listen(lcrzo_conststring userstr,
				 lcrzo_etha etha)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_etha_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez l'adresse Ethernet d'ecoute":
				 "Choose listening Ethernet address",
				 "aa:aa:aa:aa:aa:aa", 
				 etha));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_hs_init_src(lcrzo_conststring userstr,
			    lcrzo_hs hs)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_hs_init(userstr,
			       ( language==LCRZO_GLOBAL_LANG_FR )?
			       "Choisissez le nom de machine source":
			       "Choose source hostname",
			       "1.2.3.4", 
			       hs));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_hs_init_dst(lcrzo_conststring userstr,
			    lcrzo_hs hs)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_hs_init(userstr,
			       ( language==LCRZO_GLOBAL_LANG_FR )?
			       "Choisissez le nom de machine destination":
			       "Choose destination hostname",
			       "1.2.3.4", 
			       hs));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_hs_init_listen(lcrzo_conststring userstr,
			       lcrzo_hs hs)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_hs_init(userstr,
			       ( language==LCRZO_GLOBAL_LANG_FR )?
			       "Choisissez le nom de machine ecoutant":
			       "Choose listening hostname",
			       "0.0.0.0", 
			       hs));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_ipl_init_src(lcrzo_conststring userstr,
			     lcrzo_ipl *pipl)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_ipl_init(userstr,
				( language==LCRZO_GLOBAL_LANG_FR )?
				"Choisissez l'adresse IP source":
				"Choose source IP address",
				"1.2.3.4", 
				pipl));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_ipl_init_dst(lcrzo_conststring userstr,
			     lcrzo_ipl *pipl)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_ipl_init(userstr,
				( language==LCRZO_GLOBAL_LANG_FR )?
				"Choisissez l'adresse IP destination":
				"Choose destination IP address",
				"5.6.7.8", 
				pipl));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_ipl_init_listen(lcrzo_conststring userstr,
				lcrzo_ipl *pipl)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_ipl_init(userstr,
				( language==LCRZO_GLOBAL_LANG_FR )?
				"Choisissez l'adresse IP ecoutant":
				"Choose listening IP address",
				"0.0.0.0", 
				pipl));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_port_init_src(lcrzo_conststring userstr,
			      lcrzo_uint16 *pport)
{ lcrzo_int16 language;
  lcrzo_uint16 defport;

  lcrzo_er(lcrzo_uint16_init_rand(1024, 0xFFFF, &defport));
  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_port_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez le port source":
				 "Choose source port number",
				 0, 0xFFFF, defport,
				 pport));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_port_init_dst(lcrzo_conststring userstr,
			      lcrzo_uint16 defaultport,
			      lcrzo_uint16 *pport)
{ lcrzo_int16 language;
  lcrzo_uint16 defport;

  if (defaultport==0)
  { lcrzo_er(lcrzo_uint16_init_rand(1024, 0xFFFF, &defport));
  }
  else
  { defport=defaultport;
  }

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_port_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez le port destination":
				 "Choose destination port number",
				 0, 0xFFFF, defport,
				 pport));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_port_init_listen(lcrzo_conststring userstr,
				 lcrzo_uint16 *pport)
{ lcrzo_int16 language;
  lcrzo_uint16 defport;

  lcrzo_er(lcrzo_uint16_init_rand(1024, 0xFFFF, &defport));
  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_port_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez le port ecoutant":
				 "Choose listening port number",
				 0, 0xFFFF, defport,
				 pport));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint8_init_ipprotocol(lcrzo_conststring userstr,
				      lcrzo_uint8 *pproto)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_uint8_init(userstr,
				  ( language==LCRZO_GLOBAL_LANG_FR )?
				  "Choisissez le protocole IP":
				  "Choose IP protocol number",
				  0, 255, 0, pproto));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint16_init_ipfragoctosize(lcrzo_conststring userstr,
					   lcrzo_uint16 *pfragoctosize)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_uint16_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez la taille des fragments IP":
				   "Choose IP fragments size",
				   1, 8192, 1, pfragoctosize));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_bool_init_tcpsyn(lcrzo_conststring userstr,
				 lcrzo_bool *psyn)
{ lcrzo_er(shared_para_bool_init(userstr,"Bit SYN", LCRZO_FALSE, psyn));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_bool_init_tcpack(lcrzo_conststring userstr,
				 lcrzo_bool *pack)
{ lcrzo_er(shared_para_bool_init(userstr,"Bit ACK", LCRZO_FALSE, pack));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_bool_init_tcprst(lcrzo_conststring userstr,
				 lcrzo_bool *prst)
{ lcrzo_er(shared_para_bool_init(userstr,"Bit RST", LCRZO_FALSE, prst));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_bool_init_tcpfin(lcrzo_conststring userstr,
				 lcrzo_bool *pfin)
{ lcrzo_er(shared_para_bool_init(userstr,"Bit FIN", LCRZO_FALSE, pfin));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint32_init_tcpseqnum(lcrzo_conststring userstr,
				      lcrzo_uint32 *pnumber)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_uint32_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le numero de sequence seqnum":
				   "Choose seqnum",
				   0, 0xFFFFFFFFu, 0, pnumber));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint32_init_tcpacknum(lcrzo_conststring userstr,
				      lcrzo_uint32 *pnumber)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_uint32_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				  "Choisissez le numero d'acquittement acknum":
				   "Choose acknum",
				   0, 0xFFFFFFFFu, 0, pnumber));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint8_init_icmptype(lcrzo_conststring userstr,
				    lcrzo_uint8 *ptype)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_uint8_init(userstr,
				  ( language==LCRZO_GLOBAL_LANG_FR )?
				  "Choisissez le type ICMP":
				  "Choose ICMP type number",
				  0, 255, 0, ptype));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint8_init_icmpcode(lcrzo_conststring userstr,
				    lcrzo_uint8 *pcode)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_uint8_init(userstr,
				  ( language==LCRZO_GLOBAL_LANG_FR )?
				  "Choisissez le code ICMP":
				  "Choose ICMP code number",
				  0, 255, 0, pcode));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_filelocal(lcrzo_conststring userstr,
				      lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier local":
				   "Choose local filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "/tmp/fichierlocal.txt":
				   "/tmp/localfile.txt",
				   pstr));
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier local":
				   "Choose local filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "c:\\fichierlocal.txt":"c:\\localfile.txt",
				   pstr));
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_filedistant(lcrzo_conststring userstr,
					lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier distant":
				   "Choose distant filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "fichierdistant.txt":"distantfile.txt",
				   pstr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_dirlocal(lcrzo_conststring userstr,
				     lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de repertoire local":
				   "Choose local directory name",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "/tmp/repertoirelocal/":"/tmp/localdir/",
				   pstr));
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de repertoire local":
				   "Choose local directory name",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "c:\\repertoirelocal":"c:\\localdir",
				   pstr));
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_dirdistant(lcrzo_conststring userstr,
				       lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de repertoire distant":
				   "Choose distant directory name",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "repertoiredistant":"distantdir",
				   pstr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_snifffilter(lcrzo_conststring userstr,
					lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le filtre de sniff":
				   "Choose sniff filter",
				   NULL,
				   pstr));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_port_init_ftpdatalocal(lcrzo_conststring userstr,
				       lcrzo_uint16 *pport)
{ lcrzo_int16 language;
  lcrzo_uint16 defport;

  lcrzo_er(lcrzo_uint16_init_rand(1024, 0xFFFF, &defport));
  lcrzo_er(lcrzo_global_get_language(&language));
  lcrzo_er(shared_para_port_init(userstr,
				 ( language==LCRZO_GLOBAL_LANG_FR )?
				 "Choisissez le port local de donnees":
				 "Choose source local data port",
				 0, 0xFFFF, defport,
				 pport));
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_filein(lcrzo_conststring userstr,
				   lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier local":
				   "Choose local filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "/tmp/fichierentree.txt":
				   "/tmp/inputfile.txt",
				   pstr));
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier local":
				   "Choose local filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "c:\\fichierentree.txt":
				   "c:\\inputfile.txt",
				   pstr));
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_string_init_fileout(lcrzo_conststring userstr,
				    lcrzo_string *pstr)
{ lcrzo_int16 language;

  lcrzo_er(lcrzo_global_get_language(&language));
#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier local":
				   "Choose local filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "/tmp/fichiersortie.txt":
				   "/tmp/outputfile.txt",
				   pstr));
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(shared_para_string_init(userstr,
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "Choisissez le nom de fichier local":
				   "Choose local filename",
				   ( language==LCRZO_GLOBAL_LANG_FR )?
				   "c:\\fichiersortie.txt":
				   "c:\\outputfile.txt",
				   pstr));
#else
 #error "Unknown value for LCRZODEF_SYSTEM"
#endif
  return(LCRZO_ERR_OK);
}



/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
int shared_para_priv_decode_test(void);
int shared_para_priv_decode_test(void)
{ lcrzo_string inputstr;
  lcrzo_int32 inputtype, outputtype;
  lcrzo_bool n;
  int ret;

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       strcmp(inputstr, "") || outputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       n!=LCRZO_FALSE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("i[zer]d", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_IPS ||
       strcmp(inputstr, "zer") || outputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       n!=LCRZO_FALSE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("ir[zer]d", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_IPRANGE ||
       strcmp(inputstr, "zer") || outputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       n!=LCRZO_FALSE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("ize]d", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       strcmp(inputstr, "ize]d") || outputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       n!=LCRZO_FALSE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("ized", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       strcmp(inputstr, "ized") || outputtype!=SHARED_PARA_PRIV_TYPE_DEVICE ||
       n!=LCRZO_FALSE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("i[zer]n", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_IPS ||
       strcmp(inputstr, "zer") || outputtype!=SHARED_PARA_PRIV_TYPE_UINT32 ||
       n!=LCRZO_FALSE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("i[]n", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZO_ERR_OK || inputtype!=SHARED_PARA_PRIV_TYPE_IPS ||
       strcmp(inputstr, "") || outputtype!=SHARED_PARA_PRIV_TYPE_UINT32 ||
       n!=LCRZO_TRUE ) 
    return(123456);
  lcrzo_er(lcrzo_string_free2(&inputstr));

  inputtype=outputtype=123;
  ret=shared_para_priv_decode("i[zer]y", SHARED_PARA_PRIV_TYPE_DEVICE,
			      &inputtype, &inputstr, &n, &outputtype);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_int32_print("inputtype=", inputtype, "%d", ""));
  printf("inputstr=%s n=%d ", inputstr, n);
  lcrzo_er(lcrzo_int32_print("outputtype=", outputtype, "%d", "\n"));
  if ( ret!=LCRZOEX_ERR_PARA_UNKNOWNTYPE ) 
    return(123456);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_convert_test(void);
int shared_para_priv_convert_test(void)
{ lcrzo_string outputstr;
  int ret;

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_DEVICE");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICE, "eth0",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_DEVICENUMBER");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
   ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_DEVICENUMBER, "2",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
 
  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_ETHS");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHS, "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_ETHRANGE");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE,
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "00:40:33:E0:C2:24-00:40:33:E0:C2:25") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "00:40:33:E0:C2:24-00:40:33:E0:C2:25") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE, 
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE,
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE,
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ||
       strcmp(outputstr, "00:40:33:E0:C2:24-00:40:33:E0:C2:25") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHRANGE,
			       "00:40:33:E0:C2:24-00:40:33:E0:C2:25",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ||
       strcmp(outputstr, "00:40:33:E0:C2:24-00:40:33:E0:C2:25") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_ETHLIST");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST,
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "192.168.10.1,192.168.21.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST, 
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST,
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST,
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ||
       strcmp(outputstr, "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_ETHLIST,
			       "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ||
       strcmp(outputstr, "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_HS");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_HS, "k6",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_IPS");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "eth0") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "2") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "k6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);

  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPS, "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "192.168.10.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_IPRANGE");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE,
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE,
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE,
			       "192.168.10.1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "00:40:33:E0:C2:24") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE,
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ||
       strcmp(outputstr, "192.168.10.1-192.168.10.3") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE,
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "192.168.10.1-192.168.10.3") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE,
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "192.168.10.1-192.168.10.3") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPRANGE, 
			       "192.168.10.1-192.168.10.3",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "192.168.10.1-192.168.10.3") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_IPLIST");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST,
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST,
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST,
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK 
       || strcmp(outputstr, "00:40:33:E0:C2:24,02:60:8C:A3:EA:AA") )
    return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST,
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST,
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ||
       strcmp(outputstr, "192.168.10.1,192.168.21.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST,
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "192.168.10.1,192.168.21.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_IPLIST, 
			       "192.168.10.1,192.168.21.1",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || 
       strcmp(outputstr, "192.168.10.1,192.168.21.1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_PORT");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORT, "1",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_PORTRANGE");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_PORTLIST,&outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTRANGE, "1-6",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_PORTLIST");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_PORTLIST,&outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PORTLIST, "1-6",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1-6") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_UINT32");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d\n", ret);
  if ( ret!=LCRZOEX_ERR_PARA_CANTCONVERT ) return(123456);
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_UINT32, "1",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_STRING");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_STRING, "1",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  /*--*/
  puts("SHARED_PARA_PRIV_TYPE_PASSWD");
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_DEVICENUMBER, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_ETHS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_ETHRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_ETHLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_HS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_IPS, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_IPRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_IPLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_PORT, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_PORTRANGE, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_PORTLIST, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_UINT32, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_STRING, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_convert(SHARED_PARA_PRIV_TYPE_PASSWD, "1",
			       SHARED_PARA_PRIV_TYPE_PASSWD, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK || strcmp(outputstr, "1") ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_priv_stdin_test(void);
int shared_para_priv_stdin_test(void)
{ lcrzo_string outputstr;
  int ret;

  ret=shared_para_priv_stdin("DEVICE", SHARED_PARA_PRIV_TYPE_DEVICE,
			     "eth0", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("DEVICE", SHARED_PARA_PRIV_TYPE_DEVICE,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("DEVICENUMBER",SHARED_PARA_PRIV_TYPE_DEVICENUMBER,
			     "", 0,0,3, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("ETHS", SHARED_PARA_PRIV_TYPE_ETHS,
			     "00:40:33:E0:C2:24", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("ETHS", SHARED_PARA_PRIV_TYPE_ETHS,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("ETHRANGE", SHARED_PARA_PRIV_TYPE_ETHRANGE,
			     "00:40:33:E0:C2:24-a:a:a:a:a:a", 
			     0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("ETHRANGE", SHARED_PARA_PRIV_TYPE_ETHRANGE,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("ETHLIST", SHARED_PARA_PRIV_TYPE_ETHLIST,
			     "00:40:33:E0:C2:24,c:d:d:d:d:d",
			     0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("ETHLIST", SHARED_PARA_PRIV_TYPE_ETHLIST,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("HS", SHARED_PARA_PRIV_TYPE_HS,
			     "k6", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("HS", SHARED_PARA_PRIV_TYPE_HS,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("IPS", SHARED_PARA_PRIV_TYPE_IPS,
			     "192.168.10.1", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("IPS", SHARED_PARA_PRIV_TYPE_IPS,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("IPRANGE", SHARED_PARA_PRIV_TYPE_IPRANGE,
			     "192.168.10.1-200.3.3.3", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("IPRANGE", SHARED_PARA_PRIV_TYPE_IPRANGE,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("IPLIST", SHARED_PARA_PRIV_TYPE_IPLIST,
			     "192.168.10.1, 1.1.1.1", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("IPLIST", SHARED_PARA_PRIV_TYPE_IPLIST,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("PORT", SHARED_PARA_PRIV_TYPE_PORT,
			     "192", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("PORT", SHARED_PARA_PRIV_TYPE_PORT,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("PORTRANGE", SHARED_PARA_PRIV_TYPE_PORTRANGE,
			     "19-200", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("PORTRANGE", SHARED_PARA_PRIV_TYPE_PORTRANGE,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("PORTLIST", SHARED_PARA_PRIV_TYPE_PORTLIST,
			     "192, 1", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("PORTLIST", SHARED_PARA_PRIV_TYPE_PORTLIST,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("UINT32", SHARED_PARA_PRIV_TYPE_UINT32,
			     "", 10,20,15, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("STRING", SHARED_PARA_PRIV_TYPE_STRING,
			     " une chaine ", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("STRING", SHARED_PARA_PRIV_TYPE_STRING,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  ret=shared_para_priv_stdin("PASSWD", SHARED_PARA_PRIV_TYPE_PASSWD,
			     " un pwd ", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));
  ret=shared_para_priv_stdin("PASSWD", SHARED_PARA_PRIV_TYPE_PASSWD,
			     "", 0,0,0, &outputstr);
  printf("ret=%d outputstr=%s\n", ret, outputstr);
  if ( ret!=LCRZO_ERR_OK ) return(123456);
  lcrzo_er(lcrzo_string_free2(&outputstr));

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_device_init_test(void);
int shared_para_device_init_test(void)
{ lcrzo_device device;
  int ret;
  
  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init(" ", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("eth0", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "eth0") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[eth0]d", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "eth0") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[eth0]", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "d[eth0]") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[eth0", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "d[eth0") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("deth0]", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "deth0]") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("y[eth0]", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "y[eth0]") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[]d", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[]d", "msg", "eth0", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[]d", "msg", "d[eth1]d", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("d[]d", "msg", "d[]d", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("h[k6]d", "msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "eth0") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("i[192.168.10.1]d","msg", "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "eth0") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("e[00:40:33:E0:C2:24]d","msg",
			      "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "eth0") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("dn[1]d","msg",
			      "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK || strcmp(device, "lo") ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("h[]d", "msg", "eth1:1", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("i[]d","msga", "eth1:1", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("e[]d","msgb",
			      "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("dn[]d","msgc",
			      "", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("i[]d","msgd",
			      "h[k233]d", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("e[]d","msge",
			      "h[k6]d", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_device_init("vide", device));
  ret=shared_para_device_init("e[00:40:33:E0:C2:24]d","msgf",
			      "h[k6]d", device);
  printf("ret=%d AA%sZZ\n", ret, device);
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_etha_init_test(void);
int shared_para_etha_init_test(void)
{ lcrzo_etha etha;
  int ret;
  
  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("", "msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_FMETH ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("01:23:45:67:89:af", "msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[01:23:45:67:89:af]e","msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[01:23:45:67:89:af]", "msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret==LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[01:23:45:67:89:af]d","msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret==LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[01:23:45:67:89af]e","msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret==LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[]e", "msg", "", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[]e", "msg", "aa:aa:aa:aa:aa:aa", etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[]e","msg","e[aa:aa:aa:aa:aa:aa]e",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[]e","msg","e[toto]e",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("e[]e","msg","e[]e",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("h[k6]e","msg","i[k233]d",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("h[]e","msg","i[k233]i",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("d[eth0]e","msg","",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("d[]e","msg","",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("n[]e","msg","",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  lcrzo_er(lcrzo_etha_init(0x3C, 0x3C,0x3C,0x3C,0x3C,0x3C, etha));
  ret=shared_para_etha_init("n[2]e","msg","",etha);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_etha_print("", etha, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_ipl_init_test(void);
int shared_para_ipl_init_test(void)
{ lcrzo_ipl ipl;
  int ret;
  
  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OKUNRESOLVED ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("1.2.3.4", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK || ipl!=0x01020304 ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("i[1.2.3.4]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK || ipl!=0x01020304 ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("k6", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK || ipl!=0xC0A80A01u ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[k6]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK || ipl!=0xC0A80A01u ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[k6]h", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK || ipl!=0xC0A80A01u ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[1.2.3.4]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK || ipl!=0x01020304 ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("i[]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("i[]i", "msg", "1.2.3.4", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("i[]i", "msg", "k6", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("i[]i", "msg", "h[k6]i", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[]h", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[]h", "msg", "1.2.3.4", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[]h", "msg", "k6", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("h[]h", "msg", "h[k6]h", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("d[eth0]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("d[]i", "msg", "h[k6]e", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("n[2]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("n[]i", "msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ipl=0x3C3C3C3C;
  ret=shared_para_ipl_init("e[00:40:33:E0:C2:24]i","msg", "", &ipl);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_ipl_print("", ipl, "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  return(LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int shared_para_uint32_init_test(void);
int shared_para_uint32_init_test(void)
{ lcrzo_uint32 i;
  int ret;
  
  i=0x3C3C3C3C;
  ret=shared_para_uint32_init("123", "msg", 0, 1000, 50, &i);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_uint32_print("", i, "%u", "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  i=0x3C3C3C3C;
  ret=shared_para_uint32_init("n[123]n", "msg", 0, 1000, 50, &i);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_uint32_print("", i, "%u", "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  i=0x3C3C3C3C;
  ret=shared_para_uint32_init("n[]n", "msg", 0, 1000, 50, &i);
  printf("ret=%d ", ret);
  lcrzo_er(lcrzo_uint32_print("", i, "%u", "\n"));
  if ( ret!=LCRZO_ERR_OK ) return(123456);

  ret=shared_para_uint32_init("d[]n", "msg", 0, 1000, 50, &i);
  if ( ret==LCRZO_ERR_OK ) return(123456);
  ret=shared_para_uint32_init("e[]n", "msg", 0, 1000, 50, &i);
  if ( ret==LCRZO_ERR_OK ) return(123456);
  ret=shared_para_uint32_init("h[]n", "msg", 0, 1000, 50, &i);
  if ( ret==LCRZO_ERR_OK ) return(123456);
  ret=shared_para_uint32_init("i[]n", "msg", 0, 1000, 50, &i);
  if ( ret==LCRZO_ERR_OK ) return(123456);

  return(LCRZO_ERR_OK);
}

